package net.wanji.datacenter;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.domain.EntityScan;
import org.springframework.context.annotation.EnableAspectJAutoProxy;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.transaction.annotation.EnableTransactionManagement;

@SpringBootApplication(scanBasePackages = {"net.wanji.datacenter", "net.wanji.databus", "net.wanji.common"})
@EnableAspectJAutoProxy(proxyTargetClass = true)
@EntityScan(basePackages = {"net.wanji.datacenter.entity", "net.wanji.databus.dao.entity", "net.wanji.databus.dao.entity", "net.wanji.databus.po"})
@MapperScan(basePackages = {"net.wanji.datacenter.mapper",  "net.wanji.databus.dao.mapper"})
@EnableTransactionManagement
@EnableScheduling
public class DataCenterApplication {

    public static void main(String[] args) {
        SpringApplication.run(DataCenterApplication.class);
    }
}


