package net.wanji.datacenter.cache;

import lombok.extern.slf4j.Slf4j;
import net.wanji.common.utils.tool.StringUtils;
import net.wanji.databus.dao.entity.RidInfoEntity;
import net.wanji.databus.dao.mapper.RidInfoMapper;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * @author duanruiming
 * @date 2023/09/04 10:42
 */
@Component
@Slf4j
public class CrossRidInfoCache implements CommandLineRunner {

    @Resource
    private RidInfoMapper ridInfoMapper;

    private static final List<RidInfoEntity> ridInfoEntityList = new ArrayList<>();

    public static RidInfoEntity getStartRidInfoEntity(String startCrossId, Integer inDir) {
        for (RidInfoEntity ridInfoEntity : ridInfoEntityList) {
            if (StringUtils.equalsIgnoreCase(startCrossId, ridInfoEntity.getStartCrossId()) && Objects.equals(inDir, ridInfoEntity.getInDir())) {
                return ridInfoEntity;
            }
        }
        return null;
    }

    public static RidInfoEntity getEndRidInfoEntity(String endCrossId, Integer inDir) {
        for (RidInfoEntity ridInfoEntity : ridInfoEntityList) {
            if (StringUtils.equalsIgnoreCase(endCrossId, ridInfoEntity.getEndCrossId()) && Objects.equals(inDir, ridInfoEntity.getInDir())) {
                return ridInfoEntity;
            }
        }
        return null;
    }

    @Override
    public void run(String... args) throws Exception {
        try {
            init();
        } catch (Exception e) {
            log.error("路段基础信息初始化失败", e);
            throw new Exception(e);
        }
    }

    private void init() throws Exception {
        List<RidInfoEntity> ridInfoEntities = ridInfoMapper.selectAll();
        if (!CollectionUtils.isEmpty(ridInfoEntities)) {
            ridInfoEntityList.addAll(ridInfoEntities);
        }
    }


}
