//package net.wanji.datacenter.cache;
//
//import lombok.extern.slf4j.Slf4j;
//import net.wanji.common.framework.Constants;
//import net.wanji.databus.dao.entity.BaseCrossSchemePO;
//import net.wanji.databus.dao.entity.CrossPhaseLightsPO;
//import net.wanji.databus.dao.entity.CrossPhasePO;
//import net.wanji.databus.dao.mapper.BaseCrossLightsMapper;
//import net.wanji.databus.dao.mapper.BaseCrossPhaseLightsMapper;
//import net.wanji.databus.dao.mapper.BaseCrossPhaseMapper;
//import net.wanji.databus.dao.mapper.BaseCrossSchemeMapper;
//import net.wanji.databus.po.BaseCrossLightsPO;
//import net.wanji.datacenter.pojo.dto.CrossSchemePhaseDirTurnDTO;
//import org.springframework.boot.CommandLineRunner;
//import org.springframework.stereotype.Component;
//import org.springframework.util.CollectionUtils;
//
//import javax.annotation.Resource;
//import java.util.ArrayList;
//import java.util.List;
//
///**
// * @author duanruiming
// * @date 2023/10/14 15:36
// */
//@Component
//@Slf4j
//public class CrossSchemePhaseLightsCache implements CommandLineRunner {
//
//    @Resource
//    BaseCrossSchemeMapper baseCrossSchemeMapper;
//    @Resource
//    BaseCrossPhaseMapper baseCrossPhaseMapper;
//    @Resource
//    BaseCrossPhaseLightsMapper baseCrossPhaseLightsMapper;
//    @Resource
//    BaseCrossLightsMapper baseCrossLightsMapper;
//
//    public static final List<CrossSchemePhaseDirTurnDTO> crossSchemePhaseDirTurnDTOList = new ArrayList<>();
//
//    public void init() throws Exception {
//        try {
//            List<BaseCrossSchemePO> schemePOList = baseCrossSchemeMapper.listCrossSchemeInfo(Constants.SystemParam.NULL, Constants.SystemParam.NULL, Constants.SystemParam.NULL_INT);
//            if (!CollectionUtils.isEmpty(schemePOList)) {
//                for (BaseCrossSchemePO baseCrossSchemePO : schemePOList) {
//                    String crossId = baseCrossSchemePO.getCrossId();
//                    String schemeNo = baseCrossSchemePO.getSchemeNo();
//                    Integer schemeId = baseCrossSchemePO.getId();
//                    List<CrossPhasePO> crossPhasePOList = baseCrossPhaseMapper.selectByCrossIdAndSchemeId(crossId, schemeId);
//                    if (!CollectionUtils.isEmpty(crossPhasePOList)) {
//                        buildData(crossId, schemeNo, crossPhasePOList);
//                    }
//                }
//            }
//            log.info("路口缓存方案相位方向转向数据：{}", crossSchemePhaseDirTurnDTOList);
//        } catch (Exception e) {
//            log.error("路口缓存方案相位方向转向关系数据初始化失败", e);
//            throw new Exception(e);
//        }
//    }
//
//    /**
//     * 构建路口方案相位方向转向实体
//     * @param crossId 路口编号
//     * @param schemeNo
//     * @param crossPhasePOList
//     */
//    private void buildData(String crossId, String schemeNo, List<CrossPhasePO> crossPhasePOList) {
//        for (CrossPhasePO crossPhasePO : crossPhasePOList) {
//            Integer phaseId = crossPhasePO.getId();
//            String phaseNo = crossPhasePO.getPhaseNo();
//            Integer redTime = crossPhasePO.getRedTime();
//            Integer phaseTime = crossPhasePO.getPhaseTime();
//            Integer greenTime = crossPhasePO.getGreenTime();
//            List<CrossPhaseLightsPO> crossPhaseLightsPOList = baseCrossPhaseLightsMapper.selectByPhaseId(phaseId);
//            if (!CollectionUtils.isEmpty(crossPhaseLightsPOList)) {
//                for (CrossPhaseLightsPO crossPhaseLightsPO : crossPhaseLightsPOList) {
//                    CrossSchemePhaseDirTurnDTO crossSchemePhaseDirTurnDTO = new CrossSchemePhaseDirTurnDTO();
//                    crossSchemePhaseDirTurnDTO.setCrossId(crossId);
//                    crossSchemePhaseDirTurnDTO.setSchemeNo(schemeNo);
//                    crossSchemePhaseDirTurnDTO.setPhaseNo(phaseNo);
//                    Integer lightsId = crossPhaseLightsPO.getLightsId();
//                    BaseCrossLightsPO baseCrossLightsPO = baseCrossLightsMapper.selectById(lightsId);
//                    Integer dir = baseCrossLightsPO.getDir();
//                    crossSchemePhaseDirTurnDTO.setLightsDir(dir);
//                    Integer turn = baseCrossLightsPO.getType();
//                    if (turn == 20) {
//                        continue;
//                    }
//                    crossSchemePhaseDirTurnDTO.setPhaseTime(phaseTime);
//                    crossSchemePhaseDirTurnDTO.setGreenTime(greenTime);
//                    crossSchemePhaseDirTurnDTO.setRedTime(redTime);
//                    crossSchemePhaseDirTurnDTO.setLightsTurn(turn);
//                    crossSchemePhaseDirTurnDTOList.add(crossSchemePhaseDirTurnDTO);
//                }
//            }
//        }
//    }
//
//    @Override
//    public void run(String... args) throws Exception {
//        try {
//            init();
//        } catch (Exception e) {
//            log.error("路口缓存方案相位方向转向数据初始化失败", e);
//            throw new Exception(e);
//        }
//    }
//}
