package net.wanji.datacenter.common;

import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.Objects;

/**
 * @author duanruiming
 * @date 2023/08/07 10:57
 */
@Getter
@AllArgsConstructor
public enum TurnTypeParseEnum {
    // 添加神思转向编码
    LEFT("l", 1, 2,"左转"),
    STRAIGHT("s", 2,1,  "直行"),
    RIGHT("r", 3, 4,"右转"),
    AROUND("u", 4, 8,"掉头"),
    PERSON("ped", 20, 20,"行人");

    private final String type;
    private final Integer code;
    // 神思turnCode
    private final Integer ssCode;
    private final String msg;

    public static Integer getCodeBySSCode(Integer ssCode) {
        for (TurnTypeParseEnum value : TurnTypeParseEnum.values()) {
            if (Objects.equals(value.getSsCode(), ssCode)) {
                return value.code;
            }
        }
        return null;
    }


    public static Integer getCodeByType(String type) {
        for (TurnTypeParseEnum value : TurnTypeParseEnum.values()) {
            if (Objects.equals(value.type, type)) {
                return value.code;
            }
        }
        return null;
    }

    public static String getTypeByCode(Integer code) {
        for (TurnTypeParseEnum value : TurnTypeParseEnum.values()) {
            if (Objects.equals(value.code, code)) {
                return value.type;
            }
        }
        return "l";
    }

}
