package net.wanji.datacenter.constant;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Objects;

/**
 * @ClassName EventAbnormalEnum
 * @Description
 * @Date 2021/4/15 11:13
 * @Version 1.0
 */
public enum EventAbnormalEnum {

    //机动车违停
    ILLEGALSTOP("1","机动车违停",1,3),

    //非机动车逆行
    NONMOTORETROGRADE("2","非机动车逆行",1,2),

    //机动车逆行
    RETROGRADE("3","机动车逆行",1,2),
    //占用专用车道
    OCCUPYEXCLUSIVELANE("4","占用专用车道",1,1),
    //行人在机动车道逗留
    PEDESTRIANSTAYINVEHICLELANE("5","行人在机动车道逗留",1,1),
    //机动车超速
    VEHICLEOVERSPEED("6","机动车超速",1,1),
    //非机动车超速
    NONMOTOOVERSPEED("7","非机动车超速",1,1),
    //机动车慢行
    VEHICLESLOW("8","机动车慢行",1,1),
    //机动车压线
    VEHICLELINEPRESS("9","机动车压线",1,1),
    //非机动车横穿马路
    NONMOTOCROSSROAD("10","非机动车横穿马路",1,1),
    //行人横穿马路
    PEDESTRIANCROSSROAD("11","行人横穿马路",1,3),
    //机动车横穿马路
    VEHICLECROSSROAD("12","机动车横穿马路",1,1),
    //机动车闯红灯
    VEHICLERUNREDLIGHT("13","机动车闯红灯",0.5,2),
    //行人闯红灯
    PEDESTRIANRUNREDLIGHT("14","行人闯红灯",1,2),
    //占用公交车道
    OCCUPYBUSLANE("15","占用公交车道",0.5,2),
    //变道
    CHANGELANE("16","实线违规变道",0.5,2),
    //遗撒物
    LITTER("17","遗撒物",1,3),
    //交通事故
    TRAFFICACCIDENT("18","交通事故",0.5,2),
    //占用应急车道
    OCCUPYEMERGENCYLANE("19","占用应急车道",1,1),
    //隧道悬臂物
    CANTILEVER("20","隧道悬臂物",1,1),
    //行人进入隧道
    PEDESTRIANENTERTUNNEL("21","行人进入隧道",1,1),
    //非机动车进入隧道
    NONMOTOENTERTUNNEL("22","非机动车进入隧道",1,1),
    //非机动车越线停车
    NONMOTO_PARK_ON_LINE("23","非机动车越线停车",1,3),
    // 非机动车占用机动车道
    NONMOTO_RUN_IN_OTHER_LINE("24","非机动车占用机动车道",1,2),
    // 非机动车闯红灯
    NONMOTO_RUN_REDLIGHT("25","非机动车闯红灯",1,2),
    // 非机动车载人
    NONMOTO_CARRY_PEOPLE("26","非机动车载人",1,1),
    // 机动车不按车道方向行驶
    MOTO_RUN_WRONG_DIRECTION("27","机动车不按车道方向行驶",1,1),
    // 机动车占用非机动车道
    MOTO_RUN_IN_OTHER_LINE("28","机动车占用非机动车道",1,2),
    // 机动车越线停车
    MOTO_PARK_ON_LINE("29","机动车越线停车",0.5,2),
    // 施工
    CONSTRUCTION("30","施工",1,3),
    // 机动车未礼让行人
    MOTO_NO_YIEDLD_PEDESTRIAN("31","机动车未礼让行人",0.5,2),
    // 限号出行【大屏需求改为货车限行】
    RESTRICTION_LICENSE_PLATE("32","机动车限号出行",0.5,2),
    RAPID_ACCELERATION("33", "急加速",1,1),
    RAPID_DECELERATION("34", "急减速",1,1),
    SHARP_TURN("35", "急转弯",1,1),
    //能见度异常
    ABNORMALVISIBILITY("101","能见度异常",1,1),
    //光强异常
    ABNORMALLIGHT("102","光强异常",1,1),
    //CO异常
    ABNORMALCO("103","CO异常",1,1),
    //火灾
    FIR("104","火灾",1,1),


    // *****  事故
    ACCIDENT_YS("401","疑似事故",1,1),
    ACCIDENT_ONE_YS("402","疑似单车事故",1,1),
    ACCIDENT_TWO_YS("403","疑似双车事故",1,1),
    ACCIDENT_MORE_YS("404","疑似多车事故",1,1),

    // *****  拥堵
    NO_CONGEST("501","畅通",1,1),
    LIGHT_CONGEST("502","轻微拥堵",1,1),
    MODERATE_CONGEST("503","中度拥堵",1,1),
    HEAVY_CONGEST("504","重度拥堵",1,1),

    PHASE_EMPTY("701","相位空放",1,1),
    CROSS_UNBALANCE("702","路口失衡",1,1),
    CROSS_OVERFLOW("703","路口溢出",1,1),
    CROSS_DEADLOCK("704","路口死锁",1,1),
    GREEN_SLOW("705","干线-缓行",1,1),
    GREEN_CONGEST("706","干线-拥堵",1,1),
    CROSS_CONGEST("707","路口拥堵",1,1),

    /*危险驾驶*/
    CONFLICT_POINT("601", "冲突点",1,1),
    OVERFLOW_CONGESTION("605", "路口溢出",1,1),
    ROADSEGMENT_U_TURN("606", "路段掉头",1,1),
    DANGER_S_DRIVER("607", "危险驾驶-S形驾驶",1,1),
    ABNORMAL_STOP_CAR("608", "异常停车",1,1)
    ;

    public final static double step_default = 1;

    String type;
    String desc;
    double step_turn;   // 转向时步长 s
    double step_noTurn; // 无转向时步长 s

    EventAbnormalEnum(String type, String desc, double step_turn, double step_noTurn) {
        this.type = type;
        this.desc = desc;
        this.step_turn = step_turn;
        this.step_noTurn = step_noTurn;
        //命令字
    }
    public String getType(){
        return type;
    }

    public String getDesc() {
        return desc;
    }

    public double getStep_turn() {
        return step_turn;
    }

    public double getStep_noTurn() {
        return step_noTurn;
    }

    public static EventAbnormalEnum getByType(String type){
        for (EventAbnormalEnum abnormalEnum : EventAbnormalEnum.values()) {
            if(abnormalEnum.getType().equals(type)){
                return abnormalEnum;
            }
        }
        return null;
    }

    //隐患事件类型
    public static final List<EventAbnormalEnum>  HiddenDangerEvents = Arrays.asList(
            new EventAbnormalEnum[] {
                    EventAbnormalEnum.CONFLICT_POINT,
                    EventAbnormalEnum.RAPID_ACCELERATION,
                    EventAbnormalEnum.RAPID_DECELERATION,
                    EventAbnormalEnum.SHARP_TURN,
                    EventAbnormalEnum.OVERFLOW_CONGESTION,
                    EventAbnormalEnum.ROADSEGMENT_U_TURN,
                    EventAbnormalEnum.DANGER_S_DRIVER,
                    EventAbnormalEnum.MOTO_NO_YIEDLD_PEDESTRIAN,
                    EventAbnormalEnum.MOTO_RUN_WRONG_DIRECTION,
                    EventAbnormalEnum.ABNORMAL_STOP_CAR
            }
    );

    //违法事件类型
    public static final List<EventAbnormalEnum>  IllegalEvents = Arrays.asList(
            new EventAbnormalEnum[] {
                    EventAbnormalEnum.CHANGELANE,
                    EventAbnormalEnum.ILLEGALSTOP,
                    EventAbnormalEnum.VEHICLERUNREDLIGHT,
                    EventAbnormalEnum.VEHICLEOVERSPEED,
                    EventAbnormalEnum.RETROGRADE
            }
    );
    //事故事件类型
    public static final List<EventAbnormalEnum>  AccidentEvents = Arrays.asList(
            new EventAbnormalEnum[] {
                    EventAbnormalEnum.ACCIDENT_ONE_YS,
                    EventAbnormalEnum.ACCIDENT_TWO_YS,
                    EventAbnormalEnum.ACCIDENT_MORE_YS
            }
    );

    //路口事件类型
    public static final List<EventAbnormalEnum> NotB5Events = Arrays.asList(
            new EventAbnormalEnum[] {
                    EventAbnormalEnum.ACCIDENT_YS,
                    EventAbnormalEnum.ACCIDENT_ONE_YS,
                    EventAbnormalEnum.ACCIDENT_TWO_YS,
                    EventAbnormalEnum.ACCIDENT_MORE_YS,
                    EventAbnormalEnum.NO_CONGEST,
                    EventAbnormalEnum.LIGHT_CONGEST,
                    EventAbnormalEnum.MODERATE_CONGEST,
                    EventAbnormalEnum.HEAVY_CONGEST,
                    EventAbnormalEnum.PHASE_EMPTY,
                    EventAbnormalEnum.CROSS_UNBALANCE,
                    EventAbnormalEnum.CROSS_OVERFLOW,
                    EventAbnormalEnum.CROSS_DEADLOCK
            }
    );

    // 机动车事件
    public static final List<EventAbnormalEnum> VehicleEvents = Arrays.asList(new EventAbnormalEnum[]{
            EventAbnormalEnum.ILLEGALSTOP,
            EventAbnormalEnum.RETROGRADE,
            EventAbnormalEnum.OCCUPYEXCLUSIVELANE,
            EventAbnormalEnum.VEHICLEOVERSPEED,
            EventAbnormalEnum.VEHICLESLOW,
            EventAbnormalEnum.VEHICLELINEPRESS,
            EventAbnormalEnum.VEHICLECROSSROAD,
            EventAbnormalEnum.VEHICLERUNREDLIGHT,
            EventAbnormalEnum.OCCUPYBUSLANE,
            EventAbnormalEnum.CHANGELANE,
            EventAbnormalEnum.OCCUPYEMERGENCYLANE,
            EventAbnormalEnum.MOTO_RUN_WRONG_DIRECTION,
            EventAbnormalEnum.MOTO_RUN_IN_OTHER_LINE,
            EventAbnormalEnum.MOTO_PARK_ON_LINE,
            EventAbnormalEnum.MOTO_NO_YIEDLD_PEDESTRIAN,
            EventAbnormalEnum.RESTRICTION_LICENSE_PLATE,
            EventAbnormalEnum.RAPID_ACCELERATION,
            EventAbnormalEnum.RAPID_DECELERATION,
            EventAbnormalEnum.SHARP_TURN
    });

    // 非机动车事件
    public static final List<EventAbnormalEnum> NonVehicleEvents = Arrays.asList(new EventAbnormalEnum[]{
            EventAbnormalEnum.NONMOTORETROGRADE,
            EventAbnormalEnum.NONMOTOOVERSPEED,
            EventAbnormalEnum.NONMOTOCROSSROAD,
            EventAbnormalEnum.NONMOTOENTERTUNNEL,
            EventAbnormalEnum.NONMOTO_PARK_ON_LINE,
            EventAbnormalEnum.NONMOTO_RUN_IN_OTHER_LINE,
            EventAbnormalEnum.NONMOTO_RUN_REDLIGHT,
            EventAbnormalEnum.NONMOTO_CARRY_PEOPLE
    });

    // 行人事件
    public static final List<EventAbnormalEnum> PedestrianentEvents = Arrays.asList(new EventAbnormalEnum[]{
        EventAbnormalEnum.PEDESTRIANSTAYINVEHICLELANE,
        EventAbnormalEnum.PEDESTRIANCROSSROAD,
        EventAbnormalEnum.PEDESTRIANRUNREDLIGHT,
        EventAbnormalEnum.PEDESTRIANENTERTUNNEL
    });

    // 拥堵事件
    public static final List<EventAbnormalEnum> CongestionEvents = Arrays.asList(new EventAbnormalEnum[]{
        EventAbnormalEnum.NO_CONGEST,
        EventAbnormalEnum.LIGHT_CONGEST,
        EventAbnormalEnum.MODERATE_CONGEST,
        EventAbnormalEnum.HEAVY_CONGEST
    });

    /**
     * 是否为 机动车事件
     * @param type 车辆类型
     * @return
     */
    public static boolean isVehicleEvent(String type){
        return VehicleEvents.stream().anyMatch(event -> event.getType().equals(type));
    }

    /**
     * 是否为 机动车闯红灯
     * @param type 车辆类型
     * @return
     */
    public static boolean isVehicleEvent_runRedlight(String type){
        return EventAbnormalEnum.VEHICLERUNREDLIGHT.type.equals(type);
    }

    /**
     * 是否为 机动车越线停车
     * @param type 车辆类型
     * @return
     */
    public static boolean isVehicleEvent_parkOnLine(String type){
        return EventAbnormalEnum.MOTO_PARK_ON_LINE.type.equals(type);
    }

    /**
     * 是否为 机动车不按车道方向行驶
     * @param type 车辆类型
     * @return
     */
    public static boolean isVehicleEvent_runWrongDirection(String type){
        return EventAbnormalEnum.MOTO_RUN_WRONG_DIRECTION.type.equals(type);
    }

    /**
     * 是否为 机动车占用非机动车道
     * @param type 车辆类型
     * @return
     */
    public static boolean isVehicleEvent_runInOtherLine(String type){
        return EventAbnormalEnum.MOTO_RUN_IN_OTHER_LINE.type.equals(type);
    }

    /**
     * 是否为  机动车未礼让行人
     * @param type 车辆类型
     * @return
     */
    public static boolean isVehicleEvent_NoYiedldPedestrian(String type){
        return EventAbnormalEnum.MOTO_NO_YIEDLD_PEDESTRIAN.type.equals(type);
    }

    /**
     * 是否为 非机动车事件
     * @param type 车辆类型
     * @return
     */
    public static boolean isNonVehicleEvent(String type){
        return NonVehicleEvents.stream().anyMatch(event -> event.getType().equals(type));
    }

    /**
     * 是否为 非机动车闯红灯
     * @param type 车辆类型
     * @return
     */
    public static boolean isNonVehicleEvent_runRedlight(String type){
        return EventAbnormalEnum.NONMOTO_RUN_REDLIGHT.type.equals(type);
    }

    /**
     * 是否为 非机动车逆行
     * @param type 车辆类型
     * @return
     */
    public static boolean isNonVehicleEvent_retrograde(String type){
        return EventAbnormalEnum.NONMOTORETROGRADE.type.equals(type);
    }


    /**
     * 是否为 非机动车占用机动车道
     * @param type 车辆类型
     * @return
     */
    public static boolean isNonVehicleEvent_runInOtherLine(String type){
        return EventAbnormalEnum.NONMOTO_RUN_IN_OTHER_LINE.type.equals(type);
    }

    /**
     * 是否为 非机动车越线停车
     * @param type 车辆类型
     * @return
     */
    public static boolean isNonVehicleEvent_parkOnLine(String type){
        return EventAbnormalEnum.NONMOTO_PARK_ON_LINE.type.equals(type);
    }

    /**
     * 是否为 非机动车违规载人
     * @param type 车辆类型
     * @return
     */
    public static boolean isNonVehicleEvent_carryPeople(String type){
        return EventAbnormalEnum.NONMOTO_CARRY_PEOPLE.type.equals(type);
    }

    /**
     * 是否为 行人事件
     * @param type 车辆类型
     * @return
     */
    public static boolean isPedestrianentEvent(String type){
        return PedestrianentEvents.stream().anyMatch(event -> event.getType().equals(type));
    }

    /**
     * 是否为 行人闯红灯
     * @param type 车辆类型
     * @return
     */
    public static boolean isPedestrianentEvent_runRedlight(String type){
        return EventAbnormalEnum.PEDESTRIANRUNREDLIGHT.type.equals(type);
    }

    /**
     * 是否为 行人横穿马路
     * @param type 车辆类型
     * @return
     */
    public static boolean isPedestrianentEvent_crossroad(String type){
        return EventAbnormalEnum.PEDESTRIANCROSSROAD.type.equals(type);
    }

    /**
     * 是否为 事故
     * @return
     */
    public static boolean isAccidentEvent(String type){
        return EventAbnormalEnum.ACCIDENT_YS.type.equals(type);
    }

    /**
     * 是否为 拥堵
     * @return
     */
    public static boolean isCongestionEvent(String type){
        return CongestionEvents.stream().anyMatch(event -> event.getType().equals(type));
    }

    //事件子类型
    public static List<String> getEventTypeList(String eventCategory) {

        List<EventAbnormalEnum> enumList = new ArrayList<>();
        if (Objects.equals("4", eventCategory)) {
            enumList = EventAbnormalEnum.AccidentEvents;
        } else if (Objects.equals("6", eventCategory)) {
            enumList = EventAbnormalEnum.HiddenDangerEvents;
        } else if (Objects.equals("7", eventCategory)) {
            enumList = EventAbnormalEnum.IllegalEvents;
        } else {
            enumList.addAll(EventAbnormalEnum.AccidentEvents);
            enumList.addAll(EventAbnormalEnum.HiddenDangerEvents);
            enumList.addAll(EventAbnormalEnum.IllegalEvents);
        }

        List<String> list = new ArrayList<>();
        for (EventAbnormalEnum eventEnum : enumList) {
            list.add(eventEnum.getType());
        }
        return list;
    }

    // 非 B5 事件
    public static List<String> getNotB5List() {
        List<String> list = new ArrayList<>();
        for (EventAbnormalEnum eventEnum : EventAbnormalEnum.NotB5Events) {
            list.add(eventEnum.getType());
        }
        return list;
    }
}
