package net.wanji.datacenter.kafka;

import lombok.extern.slf4j.Slf4j;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Component;
import org.springframework.util.concurrent.ListenableFuture;

import javax.annotation.Resource;

@Component
@Slf4j
public class KafkaProducerServiceHandler {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());


    @Resource(name = "kafkaTemplate2")
    private KafkaTemplate<String, String> kafkaTemplate;

    public boolean send(String topic, String dataKey, String data) {

        boolean result = false;
        long s = System.currentTimeMillis();
        try {
            ListenableFuture<?> lf = kafkaTemplate.send(topic, dataKey, data);

            result = true;
            long e = System.currentTimeMillis();
            int datalen = data.length();
//            logger.info("write to kafka success,topic:" + topic + ",key:" + dataKey + ",dataLeng:" + datalen
//                    + ",costTime:" + (e - s) + "ms\r\n");
            //Thread.sleep(100);
        } catch (Exception e) {
            logger.error("topic=" + topic + ",往kafka生成消息失败", e);
        } finally {

        }
        return result;
    }


}
