package net.wanji.datacenter.pojo.dto;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.data.annotation.Id;
import org.springframework.data.elasticsearch.annotations.Field;
import org.springframework.data.elasticsearch.annotations.FieldType;

/**
 * @author duanruiming
 * @date 2023/10/25 17:33
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
public class CrossLaneSnapshotDataDTO {

    @Id
    private String id;
    @Field(type = FieldType.Keyword, name = "crossId")
    private String crossId;
    private Integer dir;
    private Integer turn;
    @Field(type = FieldType.Keyword, name = "timeStamp")
    private Integer timeStamp;
    /**
     * 车道号(路网数据)
     */
    private String laneId;
    /**
     * 静态排队长度(米)
     */
    private double staticQueueLength;
    /**
     * 队首距离(米)
     */
    private double teamHeadDistance;
    /**
     * 队尾距离(米)
     */
    private double teamTailDistance;
    /**
     * 动态排队长度(米)
     */
    private double dynamicQueueLength;
    /**
     * 平均车头间距(米)
     */
    private double meanSpaceHeadway;
    /**
     * 车头间距方差(-)
     */
    private double stdSpaceHeadway;
    /**
     * 通道排队数量(辆)
     */
    private int queueNums;
    /**
     * 车道车辆数(辆)
     */
    private int carNums;
    /**
     * 空间密度（车辆负荷比）
     */
    private double vehicleNumsRatio;
    /**
     * 空间密度（长度占比）
     */
    private double vehicleLengthRatio;
    /**
     * 平均速度(km/h)
     */
    private double meanV;
    /**
     * 头车位置(米)
     */
    private double headCarPosition;
    /**
     * 头车速度(km/h)
     */
    private double startV;
    /**
     * 末车位置(米)
     */
    private double tailCarPosition;
    /**
     * 末车速度(km/h)
     */
    private double endV;
    /**
     * 溢出区车辆数
     */
    private int overflowNums;

    @Field(type = FieldType.Keyword, name = "overflow")
    private boolean overflow;

}
