package net.wanji.datacenter.pojo.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

/**
 * @author hfx
 * @date 2023/01/12 13:29:39
 * @desc 灯组信息
 */
@Data
public class CrossLightsDTO {

    @ApiModelProperty(name = "灯组ID",notes = "")
    private Integer id;

    @ApiModelProperty(name = "灯组号",notes = "")
    private String lightsNo;

    @ApiModelProperty(name = "灯组类型：机动车（1圆饼灯；2左转灯；3直行灯；4右转灯；5掉头灯；）；" +
            "非机动车（10非机动车灯；11左转灯；12直行灯；13右转灯；14掉头灯）；" +
            "20行人灯；21行人进口灯；22行人出口灯；" +
            "30公交专用灯",notes = "")
    private Integer type;

    @ApiModelProperty(name = "灯组放行方向：1北；2东北；3东；4东南；5南；6西南；7西；8西北",notes = "")
    private Integer dir;

    @ApiModelProperty(name = "灯组序号",notes = "")
    private Integer sort;

    @ApiModelProperty(name = "路口ID",notes = "")
    private String crossId;

    @ApiModelProperty(name = "相位ID",notes = "")
    private Integer phaseId;

    @ApiModelProperty(name = "车道信息",notes = "")
    private List<LaneInfoDTO> laneInfos;

}
