package net.wanji.datacenter.pojo.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

/**
 * @author hfx
 * @date 2023/01/12 13:29:39
 * @desc 路口相位基础信息
 */
@Data
public class CrossPhaseDTO {

    @ApiModelProperty(name = "相位ID",notes = "")
    private Integer id;

    @ApiModelProperty(name = "相位号",notes = "")
    private String phaseNo;

    @ApiModelProperty(name = "相位名称",notes = "")
    private String name;

    @ApiModelProperty(name = "相位序号",notes = "")
    private Integer sort;

    @ApiModelProperty(name = "路口ID",notes = "")
    private String crossId;

    @ApiModelProperty(name = "路口方向：1北；2东北；3东；4东南；5南；6西南；7西；8西北",notes = "")
    private Integer dirType;

    @ApiModelProperty(name = "路口转向：u掉头；l左转；s直行；r右转",notes = "")
    private String turnType;

    @ApiModelProperty(name = "计划号",notes = "")
    private String planNo;

    @ApiModelProperty(name = "方案ID",notes = "")
    private Integer schemeId;

    @ApiModelProperty(name = "方案号",notes = "")
    private String schemeNo;

    @ApiModelProperty(name = "环号",notes = "")
    private Integer ringNo;

    @ApiModelProperty(name = "组号",notes = "")
    private Integer groupNo;

    @ApiModelProperty(name = "相位类型 1实相位 2虚相位 3伴随相位",notes = "")
    private Integer type;

    @ApiModelProperty(name = "控制模式：1定周期；2绿灯；3黄灯；4红灯；5关灯；6绿闪；7黄闪；8红闪",notes = "")
    private Integer controlMode;

    @ApiModelProperty(name = "相位时间",notes = "")
    private Integer phaseTime;

    @ApiModelProperty(name = "绿灯时间",notes = "")
    private Integer greenTime;

    @ApiModelProperty(name = "绿闪时间",notes = "")
    private Integer greenFlashTime;

    @ApiModelProperty(name = "行闪时间",notes = "")
    private Integer pedFlashTime;

    @ApiModelProperty(name = "黄灯时间",notes = "")
    private Integer yellowTime;

    @ApiModelProperty(name = "红灯时间",notes = "")
    private Integer redTime;

    @ApiModelProperty(name = "最小绿灯时间",notes = "")
    private Integer minGreenTime;

    @ApiModelProperty(name = "最大绿灯时间",notes = "")
    private Integer maxGreenTime;

    @ApiModelProperty(name = "灯组信息",notes = "")
    List<CrossLightsDTO> lightsInfos;

}
