package net.wanji.datacenter.pojo.dto;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

import java.util.List;

/**
 * @author duanruiming
 * @date 2023/08/04 10:20
 * @description 路口指标-快照数据B8
 */
@Data
public class CrossSnapshotDataDTO {
    /**
     * 车道事件集合
     */
    @JsonProperty("eventList")
    private List<CrossSnapshotDataDTO.EventList> eventList;
    /**
     * 车道数量
     */
    private Integer crossNum;
    /**
     * 全域编号
     */
    private String orgCode;
    /**
     * 数据生成时间: yyyy-MM-dd HH:mm:ss:SSS
     */
    private String timeStamp;

    @Data
    @JsonIgnoreProperties(ignoreUnknown = true)
    public static class EventList {
        @JsonProperty("crossId")
        private String crossId;
        /**
         * 路口车辆数(辆)
         */
        @JsonProperty("carNums")
        private Integer carNums;
        /**
         * 扩展字段，例如：{\"key1\":\"value1\",\"key2\":\"value2\"}
         */
        @JsonProperty("expand")
        private String expand;
    }
}
