package net.wanji.datacenter.pojo.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @author hfx
 * @date 2023/1/13 19:03
 * @desc 车道信息
 */
@Data
public class LaneInfoDTO {

    @ApiModelProperty(name = "车道ID",notes = "")
    private String id;

    @ApiModelProperty(name = "车道代码",notes = "")
    private String code;

    @ApiModelProperty(name = "车道序号，从左车道开始编号11、12、13...",notes = "")
    private Integer sort;

    @ApiModelProperty(name = "车道类型：1路段车道；2进口车道；3出口车道；4左转弯待转区；6直行待行区",notes = "")
    private Integer type;

    @ApiModelProperty(name = "车道方向：1北；2东北；3东；4东南；5南；6西南；7西；8西北",notes = "")
    private Integer dir;

    @ApiModelProperty(name = "车道转向",notes = "")
    private Integer turn;

    @ApiModelProperty(name = "车道类别：1机动车；2非机动车；3公交专用；4可变；5潮汐",notes = "")
    private Integer category;

    @ApiModelProperty(name = "路段编号",notes = "")
    private String rid;

    @ApiModelProperty(name = "路口ID",notes = "")
    private String crossId;

    @ApiModelProperty(name = "灯组ID",notes = "")
    private Integer lightsId;

    @ApiModelProperty(name = "车道长度",notes = "")
    private Double length;

    @ApiModelProperty(name = "车道宽度",notes = "")
    private Double width;

}
