package net.wanji.datacenter.pojo.po;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

/**
 * @author Kent HAN
 * @date 2024/3/4 10:18
 */
@Data
public class EventInfoPO {
    /**
     * 主键ID
     */
    @ApiModelProperty(name = "主键ID", notes = "")
    private Long oid;
    /**
     * 车牌号
     */
    @ApiModelProperty(name = "车牌号", notes = "")
    private String plateNo;
    /**
     * 参与者类别 1：机动车 2：非机动车 3：行人
     */
    @ApiModelProperty(name = "参与者类别 1：机动车 2：非机动车 3：行人", notes = "")
    private String objectType;
    /**
     * 可信度
     */
    @ApiModelProperty(name = "可信度", notes = "")
    private Integer confidence;
    /**
     * 检测时间
     */
    @ApiModelProperty(name = "检测时间", notes = "")
    private Date detectTime;
    /**
     * 事件等级：1扣分 2 罚款 3警告 0 未知
     */
    @ApiModelProperty(name = "事件等级：1扣分 2 罚款 3警告 0 未知", notes = "")
    private Integer grade;
    /**
     * 事件地点描述
     */
    @ApiModelProperty(name = "事件地点描述", notes = "")
    private String placeDesc;
    /**
     * 发生地点经度
     */
    @ApiModelProperty(name = "发生地点经度", notes = "")
    private Double lng;
    /**
     * 发生地点纬度
     */
    @ApiModelProperty(name = "发生地点纬度", notes = "")
    private Double lat;
    /**
     * 事件一级类别 事件一级类别 1：机动车事件 2：非机动车事件 3：行人事件
     */
    @ApiModelProperty(name = "事件一级类别 事件一级类别 1：机动车事件 2：非机动车事件 3：行人事件", notes = "")
    private String category;
    /**
     * 二级类别
     */
    @ApiModelProperty(name = "二级类别", notes = "")
    private String type;
    /**
     * 事件发生时间
     */
    @ApiModelProperty(name = "事件发生时间", notes = "")
    private Date startTime;
    /**
     * 事件结束时间
     */
    @ApiModelProperty(name = "事件结束时间", notes = "")
    private Date endTime;
    /**
     * 事件持续时长
     */
    @ApiModelProperty(name = "事件持续时长", notes = "")
    private Integer duration;
    /**
     * 事件来源
     */
    @ApiModelProperty(name = "事件来源", notes = "")
    private String source;
    /**
     * 入库时间
     */
    @ApiModelProperty(name = "入库时间", notes = "")
    private Date ruksj;
    /**
     * 修改时间
     */
    @ApiModelProperty(name = "入库时间", notes = "")
    private Date modifyTime;
    /**
     * 车道id
     */
    @ApiModelProperty(name = "车道id", notes = "")
    private String laneId;
    /**
     * 路段id
     */
    @ApiModelProperty(name = "路段id", notes = "")
    private String rid;
    /**
     * 渠化id
     */
    @ApiModelProperty(name = "渠化id", notes = "")
    private String segmentId;
    /**
     * 路口id
     */
    @ApiModelProperty(name = "路口id", notes = "")
    private String crossId;
    /**
     * 关联的事件摄像头信息ID
     */
    @ApiModelProperty(name = "关联的事件摄像头信息ID", notes = "")
    private Long cameraOid;
    /**
     * 事件序列号作为主键
     */
    @ApiModelProperty(name = "事件序列号作为主键", notes = "")
    private String eventSerialNumber;
    /**
     *
     */
    @ApiModelProperty(name = "", notes = "")
    private Character dataStatus;
    /**
     *
     */
    @ApiModelProperty(name = "", notes = "")
    private String globalId;
    /**
     *
     */
    @ApiModelProperty(name = "", notes = "")
    private Integer stationId;
    /**
     *
     */
    @ApiModelProperty(name = "", notes = "")
    private String eventId;
    @ApiModelProperty(name = "分区字段", notes = "")
    private Integer dt;
    @ApiModelProperty(name = "路口所属绿波编号", notes = "")
    private String greenId;
    /**
     * 事件方向转向
     */
    @ApiModelProperty(name = "事件方向，溢出方向", notes = "")
    private String dir;
    @ApiModelProperty(name = "事件方向，溢出方向", notes = "")
    private String turn;
    @ApiModelProperty(name = "失衡指数1-10", notes = "")
    private Double unbalanceIndex;
    /**
     * 溢出程度的刻画（没溢出：1，即将溢出：3，溢出：5，溢停：7）
     */
    @ApiModelProperty(name = "溢出指数1-10", notes = "")
    private Double spilloverIndex;
    @ApiModelProperty(name = "告警状态  0其他 1分析中 2优化中 3优化完", notes = "")
    private Integer alarmStatus;
    @ApiModelProperty(name = "优化状态 0-未优化 1-优化过", notes = "")
    private Integer optStatus;
}
