//package net.wanji.datacenter.task;
//
//import lombok.extern.slf4j.Slf4j;
//import net.wanji.databus.dao.entity.BaseCrossSchemePO;
//import net.wanji.databus.dao.entity.CrossSectionPO;
//import net.wanji.databus.dao.entity.GreenwaveCrossPO;
//import net.wanji.databus.dao.mapper.BaseCrossSchemeMapper;
//import net.wanji.databus.dao.mapper.BaseCrossSectionMapper;
//import net.wanji.datacenter.cache.*;
//import net.wanji.datacenter.pojo.dto.CrossSchemePhaseDirTurnDTO;
//import org.apache.commons.lang3.StringUtils;
//import org.springframework.scheduling.annotation.Scheduled;
//import org.springframework.stereotype.Component;
//import org.springframework.util.CollectionUtils;
//
//import javax.annotation.Resource;
//import java.util.List;
//import java.util.Map;
//import java.util.Objects;
//import java.util.stream.Collectors;
//
///**
// * @author duanruiming
// * @description 每天凌晨更新自由流速度
// * @date 2023/10/14 9:22
// */
//@Component
//@Slf4j
//public class DataCenterTask {
//
//    @Resource
//    private WeekDirFreeFlowSpeedCache weekDirFreeFlowSpeedCache;
//    @Resource
//    private WeekTurnFreeFlowSpeedCache weekTurnFreeFlowSpeedCache;
//    @Resource
//    private CrossDirWeekAvgFlowCache crossDirWeekAvgFlowCache;
//    @Resource
//    private CrossDirWeekMaxFlowCache crossDirWeekMaxFlowCache;
//
//    @Resource
//    private BaseCrossSectionMapper baseCrossSectionMapper;
//    @Resource
//    private BaseCrossSchemeMapper baseCrossSchemeMapper;
//
//    @Scheduled(cron = "0 0 0 * * ?")
//    public void getWeekFreeFlowSpeed() throws Exception {
//        weekDirFreeFlowSpeedCache.run();
//        weekTurnFreeFlowSpeedCache.run();
//        crossDirWeekAvgFlowCache.run();
//        crossDirWeekMaxFlowCache.run();
//    }
//
//    @Scheduled(initialDelay = 1000 * 60, fixedRate = 1000 * 60 * 60)
//    public void getGreenWaveWidth() throws Exception {
//        try {
//            Map<Integer, List<GreenwaveCrossPO>> greenWaveInfoMap = CrossGreenWaveInfoCache.greenWaveInfoMap;
//            int greenwaveWidth = 100;
//            for (Map.Entry<Integer, List<GreenwaveCrossPO>> entry : greenWaveInfoMap.entrySet()) {
//                Integer greenId = entry.getKey();
//                Double lastCrossDistance = 0.0; // 当前路口与上一路口距离
//                int crossTimeOffset = 0; // 上一路口到当前路口设计速度下时间差
//                int greenDelayTime = 0; // 每个路口绿波开始时间
//                List<GreenwaveCrossPO> greenwaveCrossPOList = entry.getValue();
//                if (!CollectionUtils.isEmpty(greenwaveCrossPOList)) {
//                    greenwaveWidth = calculate(greenwaveWidth, lastCrossDistance, crossTimeOffset, greenDelayTime, greenwaveCrossPOList);
//                }
//                log.info("当前绿波编号:{}, 绿波带宽:{}", greenId, greenwaveWidth);
//            }
//        } catch (Exception e) {
//            log.error("获取绿波带宽异常", e);
//            throw new Exception("获取绿波带宽异常", e);
//        }
//    }
//
//    private int calculate(int greenwaveWidth, Double lastCrossDistance, int crossTimeOffset, int greenDelayTime, List<GreenwaveCrossPO> greenwaveCrossPOList) {
//        for (GreenwaveCrossPO greenwaveCrossPO : greenwaveCrossPOList) {
//            String crossId = greenwaveCrossPO.getCrossId();
//            Integer sectionId = greenwaveCrossPO.getSectionId();
//            Integer inDir = greenwaveCrossPO.getInDir();
//            Integer offset = greenwaveCrossPO.getOffset();
//            crossTimeOffset += (int) (lastCrossDistance / (100 / 6)); // 自由流速度60
//            if (sectionId != null) {
//                CrossSectionPO crossSectionPO = baseCrossSectionMapper.selectById(sectionId);
//                if (Objects.nonNull(crossSectionPO)) {
//                    Integer schemeId = crossSectionPO.getSchemeId();
//                    BaseCrossSchemePO baseCrossSchemePO = baseCrossSchemeMapper.selectById(schemeId);
//                    if (Objects.nonNull(baseCrossSchemePO)) {
//                        String schemeNo = baseCrossSchemePO.getSchemeNo();
//                        List<CrossSchemePhaseDirTurnDTO> crossSchemePhaseDirTurnDTOList = CrossSchemePhaseLightsCache.crossSchemePhaseDirTurnDTOList;
//                        if (!CollectionUtils.isEmpty(crossSchemePhaseDirTurnDTOList)) {
//
//                            // 过滤路口编号，方案号，直行或者圆饼灯，
//                            List<CrossSchemePhaseDirTurnDTO> currenSchemeList = crossSchemePhaseDirTurnDTOList.stream().filter(po -> StringUtils.equals(crossId, po.getCrossId()) &&
//                                    StringUtils.equals(po.getSchemeNo(), schemeNo) &&
//                                    (Objects.equals(po.getLightsTurn(), 3) || Objects.equals(po.getLightsTurn(), 1))).collect(Collectors.toList());
//
//                            Integer lastPhaseTime = 0; // 上一个相位的时间
//                            for (CrossSchemePhaseDirTurnDTO dto : currenSchemeList) {
//                                // 当前路口方案绿波方向的绿灯时间
//                                lastPhaseTime += dto.getPhaseTime();
//                                if (Objects.equals(inDir, dto.getLightsDir())) {
//                                    lastPhaseTime -= dto.getPhaseTime();
//                                    greenDelayTime = lastPhaseTime > greenDelayTime ? lastPhaseTime : greenDelayTime;
//                                    Integer greenWaveStartIndex = offset + greenDelayTime + crossTimeOffset;
//                                    Integer greenWaveEndIndex = offset + dto.getPhaseTime();
//                                    greenwaveWidth = Math.min(greenwaveWidth, greenWaveEndIndex - greenWaveStartIndex);
//                                }
//                            }
//                        }
//                    }
//                }
//            }
//            lastCrossDistance = greenwaveCrossPO.getNextCrossLen();
//        }
//        return greenwaveWidth;
//    }
//}
