//package net.wanji.datacenter.task;
//
//import com.github.kokorin.jaffree.ffmpeg.FFmpeg;
//import com.github.kokorin.jaffree.ffmpeg.UrlInput;
//import com.github.kokorin.jaffree.ffmpeg.UrlOutput;
//import lombok.extern.slf4j.Slf4j;
//import net.wanji.datacenter.config.EventSaveConfiguration;
//import net.wanji.datacenter.mapper.EventInfoMapper;
//import net.wanji.datacenter.mapper.HoloMapper;
//import net.wanji.datacenter.pojo.po.DeviceCameraPO;
//import net.wanji.datacenter.pojo.po.EventInfoPO;
//import net.wanji.datacenter.pojo.vo.B5LabelVO;
//import net.wanji.datacenter.util.RedisUtils;
//import net.wanji.datacenter.util.TimeBasedKafkaConsumer;
//import org.apache.commons.collections.CollectionUtils;
//import org.springframework.beans.factory.annotation.Value;
//import org.springframework.scheduling.annotation.Async;
//import org.springframework.scheduling.annotation.Scheduled;
//import org.springframework.stereotype.Component;
//
//import javax.annotation.Resource;
//import java.io.File;
//import java.io.IOException;
//import java.io.PrintWriter;
//import java.text.SimpleDateFormat;
//import java.util.ArrayList;
//import java.util.Date;
//import java.util.List;
//import java.util.Random;
//import java.util.concurrent.LinkedBlockingQueue;
//import java.util.concurrent.ThreadPoolExecutor;
//import java.util.concurrent.TimeUnit;
//import java.util.function.Function;
//import java.util.stream.Collectors;
//
///**
// * @author Kent HAN
// * @date 2023/12/15 16:41
// */
//@Component
//@Slf4j
//public class EventTask {
//
//    @Resource
//    private EventInfoMapper eventInfoMapper;
//
//    @Resource
//    private EventSaveConfiguration eventSaveConfiguration;
//
//    @Resource
//    private HoloMapper holoMapper;
//
//    @Resource
//    RedisUtils redisUtils;
//
//    @Value("${kafka.topics.matchResultTopic}")
//    String matchResultTopic;
//
//    @Value("${kafka.topics.lightStatusTopic}")
//    String lightStatusTopic;
//
//    @Value("${kafka.producer.bootstrap.servers}")
//    String kafkaServers;
//
//    ThreadPoolExecutor executor = new ThreadPoolExecutor(
//            20,
//            40,
//            1L,
//            TimeUnit.MINUTES,
//            new LinkedBlockingQueue<Runnable>(50),
//            new ThreadPoolExecutor.DiscardOldestPolicy()
//    );
//
//    /**
//     * 每30分钟存储事件数据集
//     */
//    @Scheduled(fixedDelay = 30 * 60 * 1000)
//    public void saveEvent() {
//
//        List<EventInfoPO> eventInfoPOList = eventInfoMapper.selectHistEvent();
//            // 相同 eventType 只保留一条记录
//            List<EventInfoPO> uniqueList = eventInfoPOList.stream()
//                    .collect(Collectors.toMap(
//                            EventInfoPO::getType,
//                            Function.identity(),
//                            (existing, replacement) -> existing))
//                    .values().stream()
//                    .collect(Collectors.toList());
//
//        if (CollectionUtils.isEmpty(uniqueList)) {
//            return;
//        }
//        // 随机选择一条记录
//        Random random = new Random();
//        EventInfoPO eventInfoPO = uniqueList.get(random.nextInt(uniqueList.size()));
//
//        SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
//        String eventType = eventInfoPO.getType();
//        Date startDate = eventInfoPO.getStartTime();
//        String startDateStr = formatter.format(startDate);
//        String dateFolderName = startDateStr + "_" + eventType;
//
//        String key =  dateFolderName + eventSaveConfiguration.getNegativeSample();
//
//        Long count = redisUtils.getIncr(key, 1000 * 60 * 60 * 24);
//
//        String pathToDate = eventSaveConfiguration.getRootFolder() + File.separator
//                + eventSaveConfiguration.getCity() + File.separator
//                + eventType + File.separator
//                + dateFolderName + File.separator;
//        // todo 暂时建立空文件夹
//        makeEmptyFolders(pathToDate, count);
//
//        // 保存标签
//        saveLabel(eventInfoPO, pathToDate, count);
//        // 保存轨迹
//        saveKafka(eventInfoPO, pathToDate, count, matchResultTopic);
//        // 保存灯态
//        saveKafka(eventInfoPO, pathToDate, count, lightStatusTopic);
//        // 保存录像
//        Long finalCount = count;
//        executor.submit(() -> saveNvr(eventInfoPO, pathToDate, finalCount));
//        // 监控线程池占用情况
//        log.warn("Current Pool Size: {}. Active Threads: {}. " +
//                "Number of Tasks Completed: {}. Number of Tasks in Queue: {}. ",
//                executor.getPoolSize(), executor.getActiveCount(),
//                executor.getCompletedTaskCount(), executor.getQueue().size());
//    }
//
//    private void saveNvr(EventInfoPO eventInfoPO, String pathToDate, Long count) {
//        String eventId = eventInfoPO.getEventId();
//        String crossId = eventInfoPO.getCrossId();
//        Date startTimeStamp = eventInfoPO.getStartTime();
//        Date endTimeStamp = eventInfoPO.getEndTime();
//        String nvrurl = eventSaveConfiguration.getNvrurl();
//
//        // 查询路口对应的相机
//        List<DeviceCameraPO> deviceCameraPOList = holoMapper.selectVideoUrlsByCrossId(crossId);
//        if (CollectionUtils.isEmpty(deviceCameraPOList)) {
//            return;
//        }
//
//        SimpleDateFormat sdf = new SimpleDateFormat("yyyy_MM_dd_HH_mm_ss");
//        String starttimeStr = sdf.format(startTimeStamp.getTime() - 30 * 1000);
//        String endtimeStr = sdf.format(endTimeStamp.getTime() + 30 * 1000);
//
//        for (DeviceCameraPO deviceCameraPO : deviceCameraPOList) {
//            if (deviceCameraPO == null) {
//                continue;
//            }
//            String monitorChannel = deviceCameraPO.getMonitorChannel();
//
//            String url = nvrurl + "?channel=" + monitorChannel + "&subtype=" + eventSaveConfiguration.getSubType()
//                    + "&starttime=" + starttimeStr + "&endtime=" + endtimeStr;
//
//            String fileName = crossId + "-" + eventId + "-" + monitorChannel;
//            String pathToCount = makeSavepathToCount(pathToDate, count);
//            String savepath = pathToCount + File.separator
//                    + eventSaveConfiguration.getEvidence() + File.separator
//                    + eventSaveConfiguration.getVideo();
//            makeDirIfNotExist(savepath);
//
//            try {
//                FFmpeg.atPath()
//                        .addInput(UrlInput.fromUrl(url))
//                        .addOutput(UrlOutput.toUrl(savepath + "/" + fileName + ".mp4")
//                                .copyAllCodecs())
//                        .execute();
//            } catch (Exception e) {
//                log.error("[" + url + "], 获取失败 !", e);
//            }
//        }
//    }
//
//    private void saveKafka(EventInfoPO eventInfoPO, String pathToDate, Long count, String topic) {
//        Date eventTimeStampStart = eventInfoPO.getStartTime();
//        Date eventTimeStampEnd = eventInfoPO.getEndTime();
//        long start = eventTimeStampStart.getTime() - 30 * 1000;
//        long end = eventTimeStampEnd.getTime() + 30 * 1000;
//
//        String savepath = makeSavepathToCount(pathToDate, count);
//        makeDirIfNotExist(savepath);
//
//        String fileName;
//        if (topic.equals(lightStatusTopic)) {
//            fileName = eventSaveConfiguration.getLightJson();
//        } else {
//            fileName = eventSaveConfiguration.getTrackJson();
//        }
//
//        // 消费前30秒和后30秒的 Kafka 数据，保存到硬盘
//        TimeBasedKafkaConsumer.consumeMessagesAroundTimestamp(kafkaServers, topic, start, end, savepath, fileName);
//    }
//
//    private void saveLabel(EventInfoPO eventInfoPO, String pathToDate, Long count) {
//        B5LabelVO vo = new B5LabelVO();
//        vo.setCategory(Integer.parseInt(eventInfoPO.getCategory()));
//        vo.setEventType(Integer.parseInt(eventInfoPO.getType()));
//
//        String globalId = eventInfoPO.getGlobalId();
//        if (globalId == null) {
//            vo.setTargetIdList(new ArrayList<>());
//        } else {
//            List<Integer> targetList = new ArrayList<>();
//            targetList.add(Integer.parseInt(globalId));
//            vo.setTargetIdList(targetList);
//        }
//
//        vo.setCrossId(eventInfoPO.getCrossId());
//        vo.setRid(eventInfoPO.getRid());
//
//        Date eventTimeStampStart = eventInfoPO.getStartTime();
//        Date eventTimeStampEnd = eventInfoPO.getEndTime();
//        vo.setStartTime(eventTimeStampStart);
//        vo.setEndTime(eventTimeStampEnd);
//        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS");
//        vo.setStartTimeDate(sdf.format(eventTimeStampStart));
//        vo.setEndTimeDate(sdf.format(eventTimeStampEnd));
//
//        // 默认值
//        vo.setLabel(-1);
//
//        String pathToCount = makeSavepathToCount(pathToDate, count);
//        makeDirIfNotExist(pathToCount);
//        String fileName = eventSaveConfiguration.getLabelJson();
//
//        try (PrintWriter writer = new PrintWriter(new File(pathToCount + File.separator + fileName))) {
//            // 写入列名
//            writer.println("category,eventType,targetIdList,crossId,rid,startTime,endTime,startTimeDate,endTimeDate," +
//                    "label,comment");
//            // 写入数据
//            writer.println(vo.getCategory() + "," + vo.getEventType() + "," + vo.getTargetIdList() + "," + vo.getCrossId() + ","
//                    + vo.getRid() + "," + vo.getStartTime().getTime() + "," + vo.getEndTime().getTime() + ","
//                    + vo.getStartTimeDate() + "," + vo.getEndTimeDate() + "," + vo.getLabel() + "," + "");
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
//    }
//
//    private String makeSavepathToCount(String pathToDate, Long count) {
//        return pathToDate + File.separator +
//                eventSaveConfiguration.getNegativeSample() + File.separator
//                + count;
//    }
//
//    private void makeEmptyFolders(String pathToDate, Long count) {
//        List<String> savepathList = new ArrayList<>();
//
//        String savepath1 = pathToDate + eventSaveConfiguration.getPositiveSample();
//        savepathList.add(savepath1);
//
//        String pathToEvidence = pathToDate
//                + eventSaveConfiguration.getNegativeSample() + File.separator
//                + count + File.separator
//                + eventSaveConfiguration.getEvidence() + File.separator;
//        String savepath2 = pathToEvidence + eventSaveConfiguration.getImage();
//        savepathList.add(savepath2);
//
//        String savepath3 = pathToEvidence + eventSaveConfiguration.getVision();
//        savepathList.add(savepath3);
//
//        for (String savepath : savepathList) {
//            makeDirIfNotExist(savepath);
//        }
//    }
//
//    private void makeDirIfNotExist(String savepath) {
//        File directory = new File(savepath);
//        if (!directory.exists()) {
//            directory.mkdirs();
//        }
//    }
//
//    @Async
//    @Scheduled(cron="0 0 2 * * ? ")
//    // 每天凌晨2点清理一星期前的数据集文件
//    public void cleanUpSavepath() {
//        String savepath = eventSaveConfiguration.getRootFolder();
//        long currentTime = System.currentTimeMillis();
//        long twoMonthsInMillis = 60L * 24 * 60 * 7 * 1000; // 大约一星期的毫秒数
//
//        File directory = new File(savepath);
//
//        if (directory.exists() && directory.isDirectory()) {
//            deleteOldFiles(directory, currentTime, twoMonthsInMillis);
//        } else {
//            log.error("目录不存在：" + savepath);
//        }
//
//    }
//
//    private void deleteOldFiles(File folder, long currentTime, long threshold) {
//        File[] files = folder.listFiles();
//        if (files != null) {
//            for (File file : files) {
//                try {
//                    if (file.isDirectory()) {
//                        // 先获取目录的最后修改时间
//                        long lastModifiedTime = file.lastModified();
//
//                        // 递归删除子目录内容
//                        deleteOldFiles(file, currentTime, threshold);
//
//                        // 检查子目录是否为空，如果为空则根据之前获取的修改时间决定是否删除目录
//                        String[] subFiles = file.list();
//                        if (subFiles != null && subFiles.length == 0 && (currentTime - lastModifiedTime) > threshold) {
//                            file.delete(); // 删除空目录
//                        }
//                    } else {
//                        // 对于文件，获取文件的最后修改时间，然后判断是否需要删除
//                        long lastModifiedTime = file.lastModified();
//                        if ((currentTime - lastModifiedTime) > threshold) {
//                            file.delete(); // 删除文件
//                        }
//                    }
//                } catch (Exception e) {
//                    log.error("删除文件失败: " + file.getAbsolutePath(), e);
//                }
//            }
//        }
//    }
//}
