package com.wanji.indicators.cache;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.vividsolutions.jts.io.ParseException;
import com.wanji.indicators.constant.Constant;
import com.wanji.indicators.model.CrossRidTurnLampStatusModel;
import com.wanji.indicators.util.GeomsConvertUtil;
import lombok.extern.slf4j.Slf4j;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * @author fengyi
 * @date 2023/10/31
 * @description
 */
@Slf4j
public class CrossLightStatusDataCache {
    //路口灯态数据实时缓存key:crossId
    private static Map<String, List<CrossRidTurnLampStatusModel>> crossLightStatusMap = new ConcurrentHashMap<>();

    private static CrossLightStatusDataCache instance;

    private CrossLightStatusDataCache() {
    }

    public static synchronized CrossLightStatusDataCache getInstance() {
        if (instance == null) {
            instance = new CrossLightStatusDataCache();
        }
        return instance;
    }

    public static Map<String, List<CrossRidTurnLampStatusModel>> getCrossLightStatusMap() {
        return crossLightStatusMap;
    }

    public static void addCrossTimeLight(String key,List<CrossRidTurnLampStatusModel> list) {
        for (Map.Entry<String, List<CrossRidTurnLampStatusModel>> entry : crossLightStatusMap.entrySet()) {
            String[] sps = entry.getKey().split(Constant.MARK);
            long ts = Long.parseLong(sps[1]);
            long nowts = System.currentTimeMillis() / 1000;
            long difSecond = nowts - ts;
            if (difSecond > 5 * 60 * 1000) {
                //清理在内存中驻留超过5分钟数据
                crossLightStatusMap.remove(entry.getKey());
            }
        }
        crossLightStatusMap.put(key,list);
    }

}
