package com.wanji.indicators.constant;

import java.util.Objects;

public enum DirectionFromCnToEn {
  North("北方向", "North direction"),
  Northeast("东北方向", "Northeast direction"),
  East("东方向", "East direction"),
  Southeast("东南方向", "Southeast direction"),
  South("南方向", "South direction"),
  Southwest("西南方向", "Southwest direction"),
  West("西方向", "West direction"),
  Northwest("西北方向", "Northwest direction");
  
  private String cndir;
  
  private String endir;
  
  DirectionFromCnToEn(String cndir, String endir) {
    this.cndir = cndir;
    this.endir = endir;
  }
  
  public String getCndir() {
    return this.cndir;
  }
  
  public void setCndir(String cndir) {
    this.cndir = cndir;
  }
  
  public String getEndir() {
    return this.endir;
  }
  
  public void setEndir(String endir) {
    this.endir = endir;
  }
  
  public static String getEnDir(String dirName) {
    DirectionFromCnToEn[] values = values();
    for (DirectionFromCnToEn dirEnum : values) {
      String dircn = dirEnum.getCndir();
      if (Objects.equals(dirName, dircn))
        return dirEnum.getEndir(); 
    } 
    return null;
  }
}
