package com.wanji.indicators.constant;

/**
 * 事件分级：~~~~3-行人、2-非机动车、1-机动车
 */
public enum EventLevelEnum {

    VEHICLE("1","机动车事件"),
    NON_VEHICLE("2","非机动事件"),
    PEDESTRIANENT("3","行人事件"),

    CROSS("4","路口事件"),
    ;

    String level;
    String desc;

    EventLevelEnum(String b, String desc) {
        this.level = b;
        this.desc = desc;
    }

    public String getLevel() {
        return level;
    }

    public String getDesc() {
        return desc;
    }

    public static EventLevelEnum getByLevel(String type){
        for (EventLevelEnum abnormalEnum : EventLevelEnum.values()) {
            if(abnormalEnum.getLevel().equals(type)){
                return abnormalEnum;
            }
        }
        return null;
    }

    public static String getLevelByEventType(String eventType){
        // 机动车事件
        if(EventAbnormalEnum.isVehicleEvent(eventType)){
            return VEHICLE.getLevel();
        }

        // 非机动车 事件
        if(EventAbnormalEnum.isNonVehicleEvent(eventType)){
            return NON_VEHICLE.getLevel();
        }

        // 行人 事件
        if(EventAbnormalEnum.isPedestrianentEvent(eventType)){
            return PEDESTRIANENT.getLevel();
        }
        // 其他返回 0
        return null;
    }

}
