package com.wanji.indicators.constant;

import java.util.Objects;

public enum FieldLabelEnum {

    //******************************************************//
    AVG_PASS_RATE("avg_pass_rate","平均通过率"),
    AVG_PASS_TIME("avg_pass_time","平均通过时长"),
    AVG_WAIT_TIME("avg_wait_time","平均等待时长"),
    AVG_WAIT_PEOPLE_NUMBER("avg_wait_people_number","平均等待人数"),
    RUN_RED_NUMBER("run_red_number","行人闯红灯数量"),
    WLRXR_NON_MOTOR_NUMBER("wlrxr_non_motor_number","未礼让行人的非机动车数量"),
    WLRXR_MOTOR_NUMBER("wlrxr_motor_number","未礼让行人的机动车数量"),
    ACCELERATE_PASS_RATE("accelerate_pass_rate","行人加速通过率"),

    NOT_CLEAR_RATE("not_clear_rate","未清空率"),
    NOT_CLEAR_NUMBER("not_clear_number","平均未清空人数"),
    RUN_UNSMOOTH_NUMBER("run_unsmooth_number","运行不流畅人数"),
    SLOW_SPEED_NUMBER("slow_speed_number","路口内减速车辆数"),
    STRAIGHT_NUMBER("straight_number","直行汇车车辆数"),
    RIGHT_NUMBER("right_number","右转汇车车辆数")

    ;
    //******************************************************//
    private String type;
    private String name;

    FieldLabelEnum(String type, String name) {
        this.type = type;
        this.name = name;
    }

    public static String getName(String type){
        for(FieldLabelEnum typeEnum: FieldLabelEnum.values()){
            if(Objects.equals(typeEnum.type,type)){
                return typeEnum.name;
            }
        }
        return null;
    }

    public static String getType(FieldLabelEnum type) {
        for(FieldLabelEnum typeEnum: FieldLabelEnum.values()) {
            if(Objects.equals(typeEnum,type)){
                return typeEnum.type;
            }
        }
        return null;
    }

}
