package com.wanji.indicators.constant;

import java.util.Objects;

public enum HistoryTrackTypeEnum {

    EFFICIENT_PEDESTRIAN_HIS_TRACK("EFF_PEDESTRIAN","效率-行人历史轨迹"),
    EFFICIENT_NON_MOTOR_HIS_TRACK("EFF_NON_MOTOR","效率-非机动车历史轨迹"),
    EFFICIENT_MOTOR_HIS_TRACK("EFF_MOTOR","效率-机动车历史轨迹"),
    PLAY_START("START","启动播放"),
    PLAY_STOP("STOP","停止播放"),
    PLAY_CONTINUE_START("CONTINUE_START","继续播放")
    ;

    private String type;
    private String name;

    HistoryTrackTypeEnum(String type, String name) {
        this.type = type;
        this.name = name;
    }

    public static String getName(String type) {
        for(HistoryTrackTypeEnum typeEnum: HistoryTrackTypeEnum.values()){
            if(Objects.equals(typeEnum.type,type)){
                return typeEnum.name;
            }
        }
        return null;
    }

    public static String getType(HistoryTrackTypeEnum type) {
        for(HistoryTrackTypeEnum typeEnum: HistoryTrackTypeEnum.values()) {
            if(Objects.equals(typeEnum,type)){
                return typeEnum.type;
            }
        }
        return null;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
}
