package com.wanji.indicators.constant;

import java.util.Objects;

public enum KafkaDataEnum {

    KAFAK_REALTIME_CAR_DATA("1","实时车辆数据"),
    KAFAK_CROSS_FLOW_DATA("2","路口流量数据"),
    KAFAK_ABNORMAL_EVENT_DATA("3","交通异常事件数据"),
    KAFAK_SIGNAL_LIGHT_STATE_DATA("4","信号灯态数据"),
    KAFAK_INSTANT_DATA("5","瞬时数据"),
    BIG_SCREEN_WXJS_DATA("BIG_SCREEN_WXJS_DATA","大屏危险驾驶数据"),
    BIG_SCREEN_SHIGU_DATA("BIG_SCREEN_SHIGU_DATA","大屏事故数据"),
    BIG_SCREEN_ZZCT_DATA("BIG_SCREEN_ZZCT_DATA","大屏直左冲突车辆数据"),
    BIG_SCREEN_XWKF_DATA("BIG_SCREEN_XWKF_DATA","大屏相位空放数据"),
    BIG_SCREEN_KYDJZ_DATA("BIG_SCREEN_KYDJZ_DATA","大屏可移动基站数据"),
    BIG_SCREEN_MXJT_DATA("BIG_SCREEN_MXJT_DATA","慢行交通数据"),
    BIG_SCREEN_WRJ_DATA("BIG_SCREEN_WRJ_DATA","无人机场景数据"),
    BIG_SCREEN_GROUP_DATA("BIG_SCREEN_GROUP_DATA","路口群组（带指标、不带指标）"),
    BIG_SCREEN_ZZCT_SIGNAL_DATA("BIG_SCREEN_ZZCT_SIGNAL_DATA","直左冲突信号灯态"),
    BIG_SCREEN_XWKF_SIGNAL_DATA("BIG_SCREEN_XWKF_SIGNAL_DATA","信号空放信号灯态")
    ;

    private String type;
    private String name;

    KafkaDataEnum(String type, String name) {
        this.type = type;
        this.name = name;
    }

    public static String getName(String type) {
        for(KafkaDataEnum typeEnum: KafkaDataEnum.values()){
            if(Objects.equals(typeEnum.type,type)){
                return typeEnum.name;
            }
        }
        return null;
    }

    public static String getType(KafkaDataEnum type) {
        for(KafkaDataEnum typeEnum: KafkaDataEnum.values()) {
            if(Objects.equals(typeEnum,type)){
                return typeEnum.type;
            }
        }
        return null;
    }

}
