package com.wanji.indicators.constant;

import java.util.Objects;

public enum LightStatusEnum {

    //******************************************************//
    GREEN("green","绿灯"),
    YELLOW("yellow","黄灯"),
    RED("red","红灯")
    ;
    //******************************************************//
    private String type;
    private String name;

    LightStatusEnum(String type, String name) {
        this.type = type;
        this.name = name;
    }

    public static String getName(String type){
        for(LightStatusEnum typeEnum: LightStatusEnum.values()){
            if(Objects.equals(typeEnum.type,type)){
                return typeEnum.name;
            }
        }
        return null;
    }

    public static String getType(LightStatusEnum type) {
        for(LightStatusEnum typeEnum: LightStatusEnum.values()) {
            if(Objects.equals(typeEnum,type)){
                return typeEnum.type;
            }
        }
        return null;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
}
