package com.wanji.indicators.constant.citybrain;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * @author duanruiming
 * @date 2024/04/01 9:03
 * @description 车道方向转化为城市大脑断面方向
 */
@Getter
@AllArgsConstructor
public enum DirConvertSectionEnum {
    ONE(1, 3),
    TWO(2, 2),
    THREE(3, 2),
    FOUR(4, 1),
    FIVE(5, 1),
    SIX(6, 4),
    SEVEN(7, 4),
    EIGHT(8, 3);

    private final int dir;
    private final int section;

    public static int getSection(int dir) {
        for (DirConvertSectionEnum dirConvertSectionEnum : DirConvertSectionEnum.values()) {
            if (dirConvertSectionEnum.getDir() == dir) {
                return dirConvertSectionEnum.getSection();
            }
        }
        return 0;
    }
}
