package com.wanji.indicators.constant.citybrain;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * @author duanruiming
 * @date 2024/03/28 11:17
 */
@Getter
@AllArgsConstructor
public enum VehicleColorConvertEnum {

    WHITE("A", (byte) 1, "白"),
    GREY("B", (byte) 9, "灰"),
    YELLOW("C", (byte) 5, "黄"),
    PINK("D", (byte) 12, "粉"),
    RED("E", (byte) 3, "红"),
    PURPLE("F", (byte) 11, "紫"),
    GREEN("G", (byte) 10, "绿"),
    BLUE("H", (byte) 6, "蓝"),
    BROWN("I", (byte) 8, "棕"),
    BLACK("J", (byte) 2, "黑");

    private final String code;
    private final byte wjCode;
    private final String desc;

    public static String getCode(byte wjCode) {
        for (VehicleColorConvertEnum vehicleColorConvertEnum : VehicleColorConvertEnum.values()) {
            if (vehicleColorConvertEnum.getWjCode() == wjCode) {
                return vehicleColorConvertEnum.getCode();
            }
        }
        return VehicleColorConvertEnum.WHITE.code;
    }

}
