package com.wanji.indicators.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.time.LocalDateTime;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.baomidou.mybatisplus.annotation.TableName;

@Data
@EqualsAndHashCode(callSuper=false)
@TableName("t_analysis_rid_lane_flow")
public class AnalysisRidLaneFlow implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 路口id
     */
    private String crossId;

    /**
     * 路口名称
     */
    private String crossName;

    /**
     * 进口rid
     */
    private String rid;

    /**
     * 进口道方向 1北；2东北；3东；4东南；5南；6西南；7西；8西北
     */
    private Integer ridDir;

    /**
     * 车道ID
     */
    private String laneId;

    /**
     * 车道序号，从左车道开始编号11、12、13...
     */
    private String laneNo;

    /**
     * 车道转向：1左转；2直行；3右转；4掉头；5直左；6直右；7左直右；8左右；9左转掉头；10直行掉头；11右转掉头；12左直掉头；13直右掉头；14左直右掉头；15左右掉头
     */
    private String turnDirNo;

    /**
     * 交通流量
     */
    private Integer flow;

    /**
     * 分析粒度【5m:五分钟 10m:10分钟 30m:30分钟 1h:一小时】
     */
    private String granularity;

    /**
     * 统计窗口的开始时间
     */
    private LocalDateTime windowStartTime;

    /**
     * 统计窗口的结束时间
     */
    private LocalDateTime windowEndTime;

    private Integer dt;

    /**
     * 入库时间
     */
    private LocalDateTime ruksj;


}
