package com.wanji.indicators.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.time.LocalDateTime;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.baomidou.mybatisplus.annotation.TableName;

@Data
@EqualsAndHashCode(callSuper=false)
@TableName("t_analysis_rid_turn_flow")
public class AnalysisRidTurnFlow implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 路口id
     */
    @TableId(value = "cross_id", type = IdType.AUTO)
    private String crossId;

    /**
     * 路口名称
     */
    private String crossName;

    /**
     * 进口rid
     */
    private String fRid;

    /**
     * 进口道方向 1北；2东北；3东；4东南；5南；6西南；7西；8西北
     */
    private Integer fRidDir;

    /**
     * 出口rid
     */
    private String tRid;

    /**
     * 转向类型
            根据进入、出口路段转向计算：
            1 左转 2 直行3右转 4 掉头
     */
    private Integer turnDirNo;

    /**
     * 交通流量
     */
    private Integer flow;

    /**
     * 分析粒度【5m:五分钟 10m:10分钟 30m:30分钟 1h:一小时】
     */
    private String granularity;

    /**
     * 统计窗口的开始时间
     */
    private LocalDateTime windowStartTime;

    /**
     * 统计窗口的结束时间
     */
    private LocalDateTime windowEndTime;

    /**
     * 时间分区字段 yyyyMMdd
     */
    private Integer dt;

    /**
     * 入库时间
     */
    private LocalDateTime ruksj;


}
