package com.wanji.indicators.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.wanji.indicators.util.DateUtil;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.util.Date;

@Data
@EqualsAndHashCode(callSuper=false)
@TableName("t_base_lane_info")
public class BaseLaneInfo extends Model<BaseLaneInfo> {

    private static final long serialVersionUID = 1L;

    /**
     * 车道编号（渠化编号_车道序号）
     */
    @TableId(value = "id", type = IdType.AUTO)
    private String id;
    @TableField(exist = false)
    private String laneId;

    /**
     * 车道代码
     */
    private String code;

    /**
     * 车道序号，从左车道开始编号11、12、13...
     */
    private Integer sort;

    /**
     * 车道类型：1路段车道；2进口车道；3出口车道；4左转弯待转区；6直行待行区
     */
    private Integer type;

    /**
     * 车道方向：1北；2东北；3东；4东南；5南；6西南；7西；8西北
     */
    private Integer dir;

    /**
     * 车道转向：1左转；2直行；3右转；4掉头；5直左；6直右；7左直右；8左右；9左转掉头；10直行掉头；11右转掉头；12左直掉头；13直右掉头；14左直右掉头；15左右掉头
     */
    private Integer turn;

    /**
     * 车道类别：1机动车；2非机动车；3公交专用；4可变；5潮汐
     */
    private Integer category;

    /**
     * 路口ID
     */
    private String crossId;

    /**
     * 路段编号
     */
    private String rid;

    /**
     * 渠化编号
     */
    private String segmentId;

    /**
     * 车道长度
     */
    private Double length;

    /**
     * 车道宽度
     */
    private Double width;

    /**
     * 空间对象
     */
    private String wkt;

    /**
     * 创建时间
     */
    private Date gmtCreate;

    /**
     * 修改时间
     */
    private Date gmtModified;

    /**
     * 终点角度，正北顺时针0~359
     */
    @TableField(exist = false)
    private Double endAngle;

    /**
     * rid 4方向
     */
    @TableField(exist = false)
    private Integer ridDir4;

    /**
     *  海信车道号
     */
    private int haixinLaneNo;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    @TableField(exist = false)
    private Integer ridLevel;
    @TableField(exist = false)
    private String ridWkt;
    @TableField(exist = false)
    private Double ridLength;
    /**
     * 车道起点,格式：x,y
     */
    @TableField(exist = false)
    private String startPoint;
    /**
     * 车道终点,格式：x,y
     */
    @TableField(exist = false)
    private String endPoint;
    @TableField(exist = false)
    private String polygonWkt;

    public static void main(String[] args) {
        String dt  = DateUtil.toDateTime(1693387277478L,"yyyy-MM-dd HH:mm:ss");
        System.out.println(dt);
    }

}
