package com.wanji.indicators.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import java.time.LocalDateTime;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;

@Data
@EqualsAndHashCode(callSuper=false)
public class BaseRidInfo extends Model<BaseRidInfo> {

    private static final long serialVersionUID = 1L;

    /**
     * 路段编号（开始路口编号+结束路口编号+主辅路序号）
     */
    @TableId(value = "id", type = IdType.AUTO)
    private String id;

    /**
     * 路段名称
     */
    private String name;

    /**
     * 道路编号
     */
    private String roadId;

    /**
     * 道路名称
     */
    private String roadName;

    /**
     * 道路方向编号
     */
    private String roadDirId;

    /**
     * 开始路口编号
     */
    private String startCrossId;

    /**
     * 结束路口编号
     */
    private String endCrossId;

    /**
     * 驶出方向：1北；2东北；3东；4东南；5南；6西南；7西；8西北
     */
    private Integer outDir;

    /**
     * 驶入方向：1北；2东北；3东；4东南；5南；6西南；7西；8西北
     */
    private Integer inDir;

    /**
     * 驶出角度，正北顺时针0~359
     */
    private Double startAngle;

    /**
     * 驶入角度，正北顺时针0~359
     */
    private Double endAngle;

    /**
     * 行驶方向：0上行；1下行
     */
    private Integer direction;

    /**
     * 顺序号：路段在道路方向的顺序号
     */
    private Integer sort;

    /**
     * 路段走向：1 南向北；2 西向东；3 北向南；4 东向西；5 内环；6 外环；99 其他（参见路段走向字典）
     */
    private Integer trend;

    /**
     * 道路等级：
41000 高速公路；
42000 国道；
43000 城市快速路；
44000 城市主干道；
45000 城市次干道；
47000 城市普通道路；
51000 省道；
52000 县道；
53000 乡道；
54000 县乡村内部道路；
49 小路（参见道路等级字典）
     */
    private Integer level;

    /**
     * 行政区划代码，跨区数据会以逗号分开
     */
    private String areaCode;

    /**
     * 路段长度（米）
     */
    private Double length;

    /**
     * 路段宽度（米）
     */
    private Double width;

    /**
     * 是否单行线：0否；1是；99其他
     */
    private Integer isOneway;

    /**
     * 路段类型：1路段；3匝道；4隧道；5桥梁；6高架；99其他
     */
    private Integer type;

    /**
     * 主辅标志：1主路；2辅路；99其他 （参见主辅标志字典）
     */
    private Integer mainFlag;

    /**
     * 空间对象
     */
    private String wkt;

    /**
     * 信控路段编号
     */
    private String scId;

    /**
     * 信控路段名称
     */
    private String scName;

    /**
     * 信控路段序号
     */
    private Integer scSort;

    /**
     * 创建时间
     */
    private LocalDateTime gmtCreate;

    /**
     * 修改时间
     */
    private LocalDateTime gmtModified;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
