package com.wanji.indicators.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.Date;

@Data
@EqualsAndHashCode(callSuper = false)
@TableName("t_analysis_event")
public class EventAnalysis implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键
     */
    private Integer oid;

    /**
     * 事件一级类别 1：机动车事件 2：非机动车事件 3：行人事件
     */
    //@ApiModelProperty(value = "事件一级类型", example = "1")
    private String eventCategory;

    /**
     * 二级类别
     */
    //@ApiModelProperty(value = "事件二级类型", example = "1")
    private String eventType;

    /**
     * 事件发生数量
     */
    //@ApiModelProperty(value = "事件发生数量", example = "1")
    private Integer eventNumber;

    /**
     * 统计日期（按天统计）
     */
    private Integer statisticTime;

    /**
     * 入库时间
     */
    private LocalDateTime ruksj;

    /**
     * 小类事件排序编号
     */
    private Integer sortNum;

    /**
     * 是否输出展示
     */
    private Boolean isShow;

    /**
     * 比例
     */
    //@ApiModelProperty(value = "事件占用比例", example = "1")
    private Double ratio;
    /**
     * 别名
     */
    //@ApiModelProperty(value = "事件名称别名", example = "1")
    private String aliasName;


    //@ApiModelProperty(value = "分析粒度【5m:五分钟 10m:10分钟 15m:15分钟 30m:30分钟】")
    private String granularity;

    //@ApiModelProperty(value = "统计窗口的开始时间")
    private Date windowStartTime;

    //@ApiModelProperty(value = "统计窗口的结束时间")
    private Date windowEndTime;

    //@ApiModelProperty(value = "路口ID")
    private String crossId;

    //@ApiModelProperty(value = "是否为违法事件")
    private Boolean isIllegalEvent = false;
    //@ApiModelProperty(value = "是否为事故事件")
    private Boolean isAccidentEvent = false;
    //@ApiModelProperty(value = "是否为隐患事件")
    private Boolean isDangerEvent = false;

    //@ApiModelProperty(value = "事件标签名称")
    private String eventLabel;

    //@ApiModelProperty(value = "进口道方向：1北；2东北；3东；4东南；5南；6西南；7西；8西北")
    private Integer ridDir;

    private String rid;
    private String segmentId;
    private String laneId;

    private String crossName;

    //@ApiModelProperty(value = "事件大类描述")
    private String categoryLabel;

}
