package com.wanji.indicators.event.cross.accident.funcnew;

import com.wanji.indicators.model.ConfigModel;
import com.wanji.indicators.model.CrossFrameModel;
import org.apache.flink.streaming.api.functions.co.CoFlatMapFunction;
import org.apache.flink.util.Collector;

import java.util.HashMap;

/**
 * 2022/2/16 10:01
 *
 * @auther fengyi
 */
public class AbnormalCheckConfigCoFlatMap implements CoFlatMapFunction<CrossFrameModel, HashMap<String, ConfigModel>, CrossFrameModel> {

    private HashMap<String, ConfigModel> hashMap;

    @Override
    public void flatMap1(CrossFrameModel frameModel, Collector<CrossFrameModel> collector) throws Exception {
        if (hashMap != null && !hashMap.isEmpty()) {
            ConfigModel model = hashMap.get(frameModel.getCrossId());
            if (model != null) {
                frameModel.setConfigModel(model);
            } else {
                frameModel.setConfigModel(new ConfigModel());
            }
        } else {
            frameModel.setConfigModel(new ConfigModel());
        }
        collector.collect(frameModel);
    }

    @Override
    public void flatMap2(HashMap<String, ConfigModel> stringConfigModelHashMap, Collector<CrossFrameModel> collector) throws Exception {
        this.hashMap = stringConfigModelHashMap;
    }

}
