package com.wanji.indicators.event.cross.accident.funcnew;

import com.wanji.indicators.model.event.accident.AccidentFrameModel;
import org.apache.flink.api.common.state.ValueState;
import org.apache.flink.api.common.state.ValueStateDescriptor;
import org.apache.flink.configuration.Configuration;
import org.apache.flink.streaming.api.functions.KeyedProcessFunction;
import org.apache.flink.util.Collector;

/**
 * 2022/1/12 11:07
 *
 * @auther ke.han
 */
public class AbnormalCheckDurationKeyedProcessValueState extends KeyedProcessFunction<String, AccidentFrameModel.CarTrack, AccidentFrameModel.CarTrack> {

    private ValueState<AccidentFrameModel.CarTrack> valueState;

    @Override
    public void open(Configuration parameters) throws Exception {
        valueState = getRuntimeContext().getState(new ValueStateDescriptor<>("abnormalCheckMinDurationValueState_02i131",AccidentFrameModel.CarTrack.class));
    }

    @Override
    public void processElement(AccidentFrameModel.CarTrack carTrack, Context context, Collector<AccidentFrameModel.CarTrack> collector) throws Exception {
        AccidentFrameModel.CarTrack value = valueState.value();
        if (value == null) {
            collector.collect(carTrack);
            valueState.update(carTrack);
            context.timerService().registerProcessingTimeTimer(System.currentTimeMillis() + 3600000L);
        }
    }

    @Override
    public void onTimer(long timestamp, OnTimerContext ctx, Collector<AccidentFrameModel.CarTrack> out) throws Exception {
        valueState.clear();
    }

}
