//package com.wanji.indicators.event.cross.accident.funcnew;
//
//import com.wanji.indicators.constant.Constant;
//import com.wanji.indicators.constant.TurnEnum;
//import com.wanji.indicators.model.ConfigModel;
//import com.wanji.indicators.model.event.accident.AccidentDetourModel;
//import com.wanji.indicators.model.event.accident.AccidentFrameModel;
//import com.wanji.indicators.util.DateUtil;
//import com.wanji.indicators.util.PtInPolyUtil;
//import org.apache.commons.lang3.StringUtils;
//import org.apache.flink.api.common.state.MapState;
//import org.apache.flink.api.common.state.MapStateDescriptor;
//import org.apache.flink.configuration.Configuration;
//import org.apache.flink.streaming.api.functions.KeyedProcessFunction;
//import org.apache.flink.util.Collector;
//import org.slf4j.Logger;
//import org.slf4j.LoggerFactory;
//
//import java.util.*;
//import java.util.stream.Collectors;
//
///**
// * @auther fengyi
// */
//public class AccidentCheckDetourKeyedProcess extends KeyedProcessFunction<String, AccidentFrameModel, AccidentFrameModel> {
//
//    private static final Logger log = LoggerFactory.getLogger(AccidentCheckDetourKeyedProcess.class);
//
//    private MapState<String, AccidentDetourModel> mapState;
//    private MapState<String, AccidentDetourModel> mapStateLike;
//    private MapState<String, AccidentFrameModel.CarTrack> mapStateDuration;
//
//    @Override
//    public void open(Configuration parameters) throws Exception {
//        mapState = getRuntimeContext().getMapState(new MapStateDescriptor<>("mapStateCheckDetour_01x010X", String.class, AccidentDetourModel.class));
//        mapStateLike = getRuntimeContext().getMapState(new MapStateDescriptor<>("mapStateCheckDetour_01x011X", String.class, AccidentDetourModel.class));
//        mapStateDuration = getRuntimeContext().getMapState(new MapStateDescriptor<>("mapStateCheckDetourDuration_01x012X", String.class, AccidentFrameModel.CarTrack.class));
//    }
//
//    @Override
//    public void processElement(AccidentFrameModel accidentFrameModel, Context context, Collector<AccidentFrameModel> collector) throws Exception {
//        ConfigModel configModel = accidentFrameModel.getConfigModel();
//        List<AccidentFrameModel.CarTrack> trackList = accidentFrameModel.getTrackList();
//
//        List<AccidentFrameModel.CarTrack> trackRun = new ArrayList<>();
//        List<AccidentFrameModel.CarTrack> trackStop = new ArrayList<>();
//        Map<String, AccidentFrameModel.CarTrack> mapTrackStop = new HashMap<>();
//        for (AccidentFrameModel.CarTrack carTrack : trackList) {
//            boolean stop = carTrack.isStop();
//            if (stop) {
//                double areaDist = carTrack.getAreaDist();
//                long stopDuration = carTrack.getStopDuration();
//                if (areaDist < configModel.getAbnormalParkDetourStopCarDriveDist()) {
//                    //左侧
//                    if (stopDuration > configModel.getAbnormalParkDetourStopDurationOfLTDriveDist()) {
//                        trackStop.add(carTrack);
//                        mapTrackStop.put(getKeyLike(carTrack), carTrack);
//                    }
//                } else {
//                    //右侧
//                    if (stopDuration > configModel.getAbnormalParkDetourStopDurationOfGTDriveDist()) {
//                        trackStop.add(carTrack);
//                        mapTrackStop.put(getKeyLike(carTrack), carTrack);
//                    }
//                }
//            } else {
//                trackRun.add(carTrack);
//            }
//        }
//        //计算是否有车辆绕行停驶车辆 并计算持续时间
//        checkDetourFlow(configModel, accidentFrameModel, trackStop, trackRun);
//
//        //遍历当前已缓存的
//        Iterator<String> iterator = mapState.keys().iterator();
//        Set<String> keySet = new HashSet<>();
//        while (iterator.hasNext()) {
//            keySet.add(iterator.next());
//        }
//        List<AccidentFrameModel.CarTrack> list = new ArrayList<>();
//
//        for (AccidentFrameModel.CarTrack carTrack : trackList) {
//            boolean stop = carTrack.isStop();
//            String key = carTrack.getRoadnet().getCrossId() + carTrack.getId();
//            if (stop) {
//                int num = 0;
//                long durationCount = 0;
//                String keyLike = getKeyLike(carTrack);
//                List<String> keys = new ArrayList<>();
//                for (String k : keySet) {
//                    if (k.contains(keyLike)) {
//                        keys.add(k);
//                        num++;
//                        AccidentDetourModel model = mapStateLike.get(keyLike);
//                        if (model != null) {
//                            if (durationCount == 0 || model.getDuration() > durationCount) {
//                                durationCount = model.getDuration() + 240;
//                            }
//                        }
//                    }
//                }
//                if (durationCount > 0) {
//                    carTrack.setDetourDuration(durationCount);
//                    carTrack.setDetourNum(num);
//                    log.info(carTrack.getPicLicense() + " 被绕行时间：{},次数：{}，绕行车辆trakId：{}", DateUtil.toDateTime(carTrack.getGlobalTimeStamp(), "yyyy-MM-dd HH:mm:ss.SSS"), num, keys.toString());
//                }
//
//                //判断绕行车次是否满足异常停车绕行车次判定阈值
//                if (carTrack.getDetourNum() > configModel.getAbnormalParkDetourNumber()) {
//                    AccidentFrameModel.CarTrack carTrackAgo = mapStateDuration.get(key);
//                    if (carTrackAgo == null) {
//                        mapStateDuration.put(key, carTrack);
//                    } else {
//                        long timeAgo = carTrackAgo.getGlobalTimeStamp();
//                        long timeNow = carTrack.getGlobalTimeStamp();
//                        long detourStopDuration = timeNow - timeAgo;
//                        carTrack.setDetourStopDuration(detourStopDuration);
//                        log.info("LOG_EVENT_DETOUR  绕行数据计算: " + carTrack.getPicLicense() +
//                                "  " + carTrack.getId() + "  绕行次数: " + carTrack.getDetourNum() +
//                                "  绕行2次后停车持续时间: " + carTrack.getDetourStopDuration() +
//                                "  绕行时间: " + durationCount);
//                    }
//                }
//            } else {
//                AccidentFrameModel.CarTrack carTrackAgo = mapStateDuration.get(key);
//                if (carTrackAgo != null) {//由停止变为运行状态，清除缓存
//                    mapStateDuration.remove(key);
//                    mapState.remove(key);
//                    mapStateLike.remove(getKeyLike(carTrackAgo));
//                }
//                //当前已不是停车状态 所以绕行持续时间直接清空
//                carTrack.setDetourDuration(0);
//                carTrack.setDetourNum(0);
//                carTrack.setDetourStopDuration(0);
//            }
//            list.add(carTrack);
//        }
//        //清除过期数据
//        for (String k : keySet) {
//            String keyLike = k.substring(0, k.lastIndexOf(Constant.MARK));
//            AccidentFrameModel.CarTrack carTrack = mapTrackStop.get(keyLike);
//            if (carTrack == null) {
//                AccidentDetourModel model = mapStateLike.get(keyLike);
//                long timeX = accidentFrameModel.getTime() - model.getTime();
//                if (timeX > 180000) {
//                    mapState.remove(k);
//                    mapStateLike.get(keyLike);
//                }
//            }
//        }
//        //发送数据
//        if (!list.isEmpty()) {
//            accidentFrameModel.setTrackList(list);
//            collector.collect(accidentFrameModel);
//        }
//
//    }
//
//
//    /**
//     * 验证绕行
//     *
//     * @param accidentFrameModel
//     * @param trackStop
//     * @param trackRun
//     * @throws Exception
//     */
//    private void checkDetourFlow(ConfigModel configModel, AccidentFrameModel accidentFrameModel, List<AccidentFrameModel.CarTrack> trackStop, List<AccidentFrameModel.CarTrack> trackRun) throws Exception {
//        long timeNow = accidentFrameModel.getTime();
//        for (AccidentFrameModel.CarTrack carStop : trackStop) {
//            double lngS = carStop.getLongitude();
//            double latS = carStop.getLatitude();
//            String ridS = carStop.getRoadnet().getRid();
//            Integer laneTurnFunc = carStop.getRoadnet().getTurn();
//            //车道功能组装
//            String laneFuncS = TurnEnum.getLaneFunction(laneTurnFunc);
//
//            for (AccidentFrameModel.CarTrack carRun : trackRun) {
//                double lngR = carRun.getLongitude();
//                double latR = carRun.getLatitude();
//                String ridR = carRun.getRoadnet().getRid();
//                String laneFuncR = TurnEnum.getLaneFunction(carRun.getRoadnet().getTurn());
//
//                if (StringUtils.isNotBlank(ridS) && ridS.equals(ridR) &&
//                        StringUtils.isNotBlank(laneFuncS) && StringUtils.isNotBlank(laneFuncR) &&
//                        (laneFuncS.contains(laneFuncR) || laneFuncR.contains(laneFuncS))) {
//                    //计算当前帧停驶车辆与行驶车辆之间的距离
//                    double distance = PtInPolyUtil.getDistance(lngS, latS, lngR, latR);
//                    double driveAngleS = carStop.getCourseAngle();
//                    double driveAngleR = carRun.getCourseAngle();
//                    String key = getKey(carStop, carRun);
//                    String keyLike = getKeyLike(carStop);
//
//                    AccidentDetourModel detourNow = new AccidentDetourModel();
//                    detourNow.setKey(key);
//                    detourNow.setTime(timeNow);
//                    detourNow.setDistance(distance);
//                    detourNow.setDuration(0L);
//
//                    AccidentDetourModel detourLikeNow = new AccidentDetourModel();
//                    detourLikeNow.setKey(keyLike);
//                    detourLikeNow.setTime(timeNow);
//                    detourLikeNow.setDistance(distance);
//                    detourLikeNow.setDuration(0L);
//
//                    //查询上一帧两车的距离
//                    AccidentDetourModel detourAgo = mapState.get(key);
//                    AccidentDetourModel detourDurationAgo = mapStateLike.get(keyLike);
//                    if (detourDurationAgo != null) {
//                        //计算两车行驶方向是否相同
//                        boolean syntropy = isSyntropy(driveAngleS, driveAngleR, 45.0);
//                        if (distance < configModel.getAbnormalParkDetourDistanceAfterStopCar() && syntropy) {
//                            long durationReal = detourDurationAgo.getDuration();
//                            long timeX = Math.abs(timeNow - detourDurationAgo.getTime());
//                            //距离大于0 且 当前距离要比上一帧距离大 (表示绕行车辆正在远离目标)
//                            if (detourAgo != null && distance > 0.0 && distance > detourAgo.getDistance()) {
//                                if (timeX < 1000L) {
//                                    durationReal += timeX;
//                                } else {
//                                    durationReal += 240;
//                                }
//                                detourLikeNow.setDuration(durationReal);
//                                mapStateLike.put(keyLike, detourLikeNow);
//                                detourNow.setDuration(durationReal);
//                                mapState.put(key, detourNow);
//                                log.info("LOG_EVENT_DETOUR  ==>> " + key + "  " + keyLike + "  " + detourNow + "  " + durationReal);
//                            }
//                        }
//                    } else {
//                        //计算停驶车辆是否在行驶车辆前
//                        double angle = PtInPolyUtil.getAngle(lngR, latR, lngS, latS);
//                        boolean isOk = isSyntropy(angle, driveAngleR, 60.0);
//                        //这里取距离8米以内的车辆做绕行计算 且
//                        double abnormalParkDetourDistanceBeforeStopCar = configModel.getAbnormalParkDetourDistanceBeforeStopCar();
//                        if (distance < abnormalParkDetourDistanceBeforeStopCar && isOk) {
//                            mapState.put(key, detourNow);
//                            mapStateLike.put(keyLike, detourLikeNow);
//                        }
//                    }
//                }
//            }
//        }
//    }
//
//
//    /**
//     * 获取唯一key
//     *
//     * @param carStop
//     * @param carRun
//     * @return
//     */
//    private static String getKey(AccidentFrameModel.CarTrack carStop, AccidentFrameModel.CarTrack carRun) {
//        return carStop.getRoadnet().getCrossId() + Constant.MARK + carStop.getId() + Constant.MARK + carRun.getId();
//    }
//
//    /**
//     * 获取模糊搜索key
//     *
//     * @param carStop
//     * @return
//     */
//    private static String getKeyLike(AccidentFrameModel.CarTrack carStop) {
//        return carStop.getRoadnet().getCrossId() + Constant.MARK + carStop.getId();
//    }
//
//    /**
//     * 计算行车角度是否同向
//     *
//     * @param angleA
//     * @param angleB
//     * @return
//     */
//    private static boolean isSyntropy(double angleA, double angleB, double checkAngle) {
//        double angleX = Math.abs(angleA - angleB);
//        if (angleX > 180.0) {
//            angleX = 360.0 - angleX;
//        }
//        if (angleX <= checkAngle) {
//            return true;
//        } else {
//            return false;
//        }
//    }
//
//}
