//package com.wanji.indicators.event.cross.accident.funcnew;
//
//import com.mapabc.constant.Constant;
//import com.mapabc.model.ConfigModel;
//import com.mapabc.model.event.LampStateCycleModel;
//import com.mapabc.model.event.accident.AccidentFrameModel;
//import lombok.extern.slf4j.Slf4j;
//import org.apache.flink.api.common.state.MapState;
//import org.apache.flink.api.common.state.MapStateDescriptor;
//import org.apache.flink.configuration.Configuration;
//import org.apache.flink.streaming.api.functions.KeyedProcessFunction;
//import org.apache.flink.util.Collector;
//
//import java.util.*;
//import java.util.stream.Collectors;
//import java.util.stream.StreamSupport;
//
///* *
// * @Description 路口无灯态数据时根据车流计算信号周期
// * @Author fengyi
// * @Date 17:05 2022/1/20
// **/
//@Slf4j
//public class AccidentNoLampSignalCycleProcess extends KeyedProcessFunction<String, AccidentFrameModel, AccidentFrameModel> {
//
//    private MapState<String, LampStateCycleModel> mapStateOfGreenStart;
//    private MapState<String, LampStateCycleModel> mapStateOfResult;
//    private MapState<Integer, AccidentFrameModel.CarTrack> mapStateCar;
//    private MapState<String, LampStateCycleModel> mapStateCrossCycle;
//
//    @Override
//    public void open(Configuration parameters) throws Exception {
//        mapStateOfGreenStart = getRuntimeContext().getMapState(new MapStateDescriptor<>("mapStateAccident_NoLamp_Green_Start", String.class, LampStateCycleModel.class));
//        mapStateOfResult = getRuntimeContext().getMapState(new MapStateDescriptor<>("mapStateAccident_NoLamp_Cycle_Result", String.class, LampStateCycleModel.class));
//        mapStateCar = getRuntimeContext().getMapState(new MapStateDescriptor<>("mapStateAccident_Car_Info", Integer.class, AccidentFrameModel.CarTrack.class));
//        mapStateCrossCycle = getRuntimeContext().getMapState(new MapStateDescriptor<>("mapStateAccident_Cross_Cycle", String.class, LampStateCycleModel.class));
//    }
//
//
//    @Override
//    public void processElement(AccidentFrameModel accidentFrameModel, Context context, Collector<AccidentFrameModel> collector) throws Exception {
//
//        //路口无灯态数据时根据车流计算信号周期
//        if (accidentFrameModel.getRidTurnLampList().isEmpty()) {
//            List<AccidentFrameModel.CarTrack> trackList = accidentFrameModel.getTrackList();
//
//            long time = accidentFrameModel.getTime();
//
//            ConfigModel configModel = accidentFrameModel.getConfigModel();
//            String crossId = accidentFrameModel.getCrossId();
//            int minCycle = configModel.getAbnormalParkNoLampMinCycle();
//            int maxCycle = configModel.getAbnormalParkNoLampMaxCycle();
//            accidentFrameModel.setCycle(maxCycle);//默认为设置的最大周期
//
//            //按进口RID分组，筛选停止线前的停止的车辆
//            Map<String, List<AccidentFrameModel.CarTrack>> groupList = trackList.stream()
//                    .filter(o -> o.getStopLineDist() >= 0 && o.getTime() == time)
//                    .collect(Collectors.groupingBy(o -> o.getRid()));
//
//            for (Map.Entry<String, List<AccidentFrameModel.CarTrack>> entry : groupList.entrySet()) {
//                String rid = entry.getKey();
//                List<AccidentFrameModel.CarTrack> value = entry.getValue();
//
//                //按车道分组，去除独立右转 及复合车道【有专用到以专用道为基准计算】
//                Map<String, List<AccidentFrameModel.CarTrack>> groupByLane = value.stream()
//                        .filter(o -> !Objects.equals(Constant.RIGHT_TURN_CODE, o.getLaneFunc()) && !o.getLaneFunc().contains(Constant.COMMA))
//                        .collect(Collectors.groupingBy(o -> o.getEntryLane() + Constant.MARK + o.getLaneFunc()));
//                if (groupByLane.isEmpty()) {//无专用车道情况
//                    groupByLane = value.stream()
//                            .filter(o -> !Objects.equals(Constant.RIGHT_TURN_CODE, o.getLaneFunc()))
//                            .collect(Collectors.groupingBy(o -> o.getEntryLane() + Constant.MARK + o.getLaneFunc()));
//                }
//
//                /* *******************计算相同转向关联的车道的车道停车比例，车道运行比例************************* */
//                Map<String, Double[]> stopAndRunLaneRate = this.getStopAndRunLaneRate(groupByLane, configModel);
//                /* ********************************************************** */
//
//                for (Map.Entry<String, Double[]> rateEntry : stopAndRunLaneRate.entrySet()) {
//                    String gkey = rateEntry.getKey();// crossId + Constant.MARK + rid + Constant.MARK + func;
//                    Double[] rate = rateEntry.getValue();
//                    double stopRate = rate[0];
//                    double runRate = rate[1];
//                    String[] sps = gkey.split(Constant.MARK);
//                    LampStateCycleModel signalState = mapStateOfGreenStart.get(gkey);
//                    if (signalState == null) {
//                        signalState = new LampStateCycleModel();
//                        signalState.setCrossId(crossId);
//                        signalState.setRid(rid);
//                        signalState.setLaneFunc(null);
//                        signalState.setTurn(sps[2]);
//                        //未计算出结果时默认按设置的最大周期
//                        signalState.setCycle(maxCycle);
//                        if (stopRate >= configModel.getAbnormalParkNoLampStopLaneRate()) {
//                            signalState.setCurrentLamp(Constant.RED);
//                            mapStateOfGreenStart.put(gkey, signalState);
//                        }
//                    } else {
//                        long timex = time - signalState.getTime();
//                        if (stopRate >= configModel.getAbnormalParkNoLampStopLaneRate()) {
//                            if (timex != 0 && signalState.getCurrentLamp().equals(Constant.GREEN) && signalState.getGreenStartTime() > 0) {//绿灯结束
//                                signalState.setGreenEndTime(time);
//                                //红灯开始后车辆延迟到达，计算的绿灯时长比实际时长会大
//                                long greenTime = signalState.getGreenEndTime() - signalState.getGreenStartTime();
//                                signalState.setGreenEndTime(time);
//                                //log.info("周期计算=》(b)绿灯第一次结束：key={}，nowTime={},greenStartTime={}，greenEndTime={},greenTime={}秒，laneId={},laneFunc={}", gkey, DateUtil.toDateTime(time, "yyyy-MM-dd HH:mm:ss:SSS"), signalState.getGreenStartTime(), signalState.getGreenEndTime(), greenTime / 1000);
//                            }
//                            signalState.setCurrentLamp(Constant.RED);
//                        } else {
//                            //红灯状态结束启动加速
//                            if (signalState.getCurrentLamp().equals(Constant.RED)) {
//                                //包含相同转向的车道上至少有80%车道上有车辆处于运行状态
//                                if (timex != 0 && signalState.getGreenStartTime() > 0 && signalState.getGreenEndTime() > 0 && runRate >= 0.8) {
//                                    Long cycleTs = time - signalState.getGreenStartTime();
//                                    int cycle = (int) (cycleTs / 1000);
//                                    if (signalState.getTime() == time) {
//                                        //同一帧进口多个相同转向时
//                                        int agoCycle = signalState.getCycle();
//                                        if (agoCycle < cycle) {
//                                            //log.info("周期计算=》(d)同一帧多个相同转向周期取较小者：key={}，greenStartTime={}，greenEndTime={},nowTime={}，cycle={}，agoCycle={}，laneId={},laneFunc={}", gkey, signalState.getGreenStartTime(), signalState.getGreenEndTime(), DateUtil.toDateTime(time, "yyyy-MM-dd HH:mm:ss:SSS"), cycle, agoCycle);
//                                            cycle = agoCycle;
//                                        }
//                                    }
//                                    //绿灯再次启亮，算周期
//                                    if (cycle > maxCycle) {
//                                        cycle = maxCycle;
//                                    } else if (cycle < minCycle) {
//                                        cycle = minCycle;
//                                    }
//                                    signalState.setCycle(cycle);
//
//                                    //log.info("周期计算=》(c)周期输出=》绿灯再次启亮时间：cycle={}s，actCycle={}s,key={}，greenStartTime={}，greenEndTime={},time={}，laneId={},laneFunc={}", signalState.getCycle(), cycleTs / 1000, gkey, signalState.getGreenStartTime(), signalState.getGreenEndTime(), DateUtil.toDateTime(time, "yyyy-MM-dd HH:mm:ss:SSS"));
//                                    signalState.setTime(time);
//                                    mapStateOfResult.put(gkey, signalState);
//                                    //清除中间缓存
//                                    mapStateOfGreenStart.remove(gkey);
//                                    continue;
//                                } else {
//                                    if (runRate >= 0.8 && time != signalState.getTime() && signalState.getGreenStartTime() == 0) {
//                                        //绿灯第一次启亮
//                                        signalState.setGreenStartTime(time);
//                                        signalState.setGreenEndTime(0L);
//                                        signalState.setCurrentLamp(Constant.GREEN);
//                                        //log.info("周期计算=》(a)绿灯第一次启亮时间：key={}，greenStartTime={},nowTime={}，laneId={},laneFunc={}", gkey, signalState.getGreenStartTime(), DateUtil.toDateTime(time, "yyyy-MM-dd HH:mm:ss:SSS"));
//                                    }
//                                }
//                            }
//                        }
//                        signalState.setTime(time);
//                        mapStateOfGreenStart.put(gkey, signalState);
//                    }
//
//                }
//            }
//            List<LampStateCycleModel> resList = StreamSupport.stream(mapStateOfResult.values().spliterator(), false).collect(Collectors.toList());
//            //融合周期
//            accidentFrameModel.setCycle(aggCycle(time, minCycle, maxCycle, resList));
//
//            //缓存清理
//            List<LampStateCycleModel> clearList = resList.stream().filter(o -> (time - o.getTime()) > 30 * 60 * 1000).collect(Collectors.toList());
//            for (LampStateCycleModel model : clearList) {
//                mapStateOfResult.remove(model.getCrossId());
//            }
//            //清理mapStateCar
//            List<AccidentFrameModel.CarTrack> tmCarList = StreamSupport.stream(mapStateCar.values().spliterator(), false).filter(o -> (time - o.getTime()) > 30 * 60 * 1000).collect(Collectors.toList());
//            for (AccidentFrameModel.CarTrack model : tmCarList) {
//                mapStateCar.remove(model.getTrackId());
//            }
//        }
//        collector.collect(accidentFrameModel);
//    }
//
//    //在最大、最小周期期间 ，按每5分钟间隔粒度，统计每个区间内周期条数，取条数最多的取平均
//    private int aggCycle(long time, int minCycle, int maxCycle, List<LampStateCycleModel> resList) throws Exception {
//        int retCycle = 0;
//        List<LampStateCycleModel> list = resList.stream().filter(o -> o.getCycle() > minCycle && o.getCycle() < maxCycle && (time - o.getTime()) <= 30 * 60 * 1000).collect(Collectors.toList());
//        if (list.isEmpty()) {
//            retCycle = maxCycle;
//        } else {
//            Map<Integer, List<Integer>> sptCycleList = new HashMap<>();
//            TreeMap<Integer, Integer> cycleRecCountMap = new TreeMap<>();
//            String crossId = null;
//            for (LampStateCycleModel cycleModel : list) {
//                crossId = cycleModel.getCrossId();
//                int midCycle = cycleModel.getCycle();
//                int idx = Math.floorDiv(midCycle, 5);
//                List<Integer> midList = sptCycleList.get(idx);
//                if (midList == null) {
//                    midList = new ArrayList<>();
//                }
//                midList.add(midCycle);
//                sptCycleList.put(idx, midList);
//                cycleRecCountMap.put(midList.size(), idx);
//            }
//            Map.Entry<Integer, Integer> lastEntry = cycleRecCountMap.lastEntry();
//            int maxCountIdx = lastEntry.getValue();
//            OptionalDouble optionalDouble = sptCycleList.get(maxCountIdx).stream().mapToInt(Integer::intValue).average();
//            retCycle = (int) optionalDouble.getAsDouble();
//            LampStateCycleModel agoCycleModel = mapStateCrossCycle.get(crossId);
//            if (agoCycleModel == null) {
//                agoCycleModel = new LampStateCycleModel();
//                agoCycleModel.setTime(time);
//                agoCycleModel.setCycle(retCycle);
//            } else if (Math.abs(retCycle - agoCycleModel.getCycle()) < 20) {
//                //周期误差在20秒内保持一个周期
//                retCycle = agoCycleModel.getCycle();
//            } else {
//                agoCycleModel.setTime(time);
//                agoCycleModel.setCycle(retCycle);
//            }
//            mapStateCrossCycle.put(crossId, agoCycleModel);
////            log.info("周期计算=》路口信号周期：cycle={}，crossId={}，nowTime={}", retCycle, crossId, DateUtil.toDateTime(time, "yyyy-MM-dd HH:mm:ss:SSS"));
//        }
//        return retCycle;
//
////        Optional<LampStateCycleModel> minCycleModelOptional = list.stream().sorted(Comparator.comparing(LampStateCycleModel::getCycle)).findFirst();
////        Optional<LampStateCycleModel> maxCycleModelOptional = list.stream().sorted(Comparator.comparing(LampStateCycleModel::getCycle).reversed()).findFirst();
////        Optional<LampStateCycleModel> newCycleModelOptional = list.stream().sorted(Comparator.comparing(LampStateCycleModel::getTime).reversed()).findFirst();
////        OptionalDouble optionalDouble = list.stream().mapToInt(o -> o.getCycle()).average();
////
////        if (newCycleModelOptional.isPresent()) {
////            int cycle = newCycleModelOptional.get().getCycle();
////            int minCycle1 = minCycleModelOptional.get().getCycle();
////            int maxCycle1 = maxCycleModelOptional.get().getCycle();
////            if (maxCycle1 - minCycle1 <= 20) {
////                //cycle = maxCycle1;
////            }
////            //cycle  = (int)optionalDouble.getAsDouble();
////            return cycle;
////            //log.info("周期计算=》路口信号周期：cycle={}，crossId={}，nowTime={}", cycle, crossId, DateUtil.toDateTime(time, "yyyy-MM-dd HH:mm:ss:SSS"));
////        }
//    }
//
//    //计算相同转向关联的车道的车道停车比例，车道运行比例
//    private Map<String, Double[]> getStopAndRunLaneRate(Map<String, List<AccidentFrameModel.CarTrack>> groupByLane, ConfigModel configModel) throws Exception {
//        Map<String, Double[]> retMap = new HashMap<>();
//        //停止状态车道数
//        Map<String, Double> turnStopRateMap = new HashMap<>();
//        //运行状态车道数
//        Map<String, Double> turnRunRateMap = new HashMap<>();
//        //每个转向关联的车道数
//        Map<String, Integer> turnLaneCountMap = new HashMap<>();
//        for (Map.Entry<String, List<AccidentFrameModel.CarTrack>> entry1 : groupByLane.entrySet()) {
//            List<AccidentFrameModel.CarTrack> value1 = entry1.getValue().stream().sorted(Comparator.comparing(o -> o.getStopLineDist())).collect(Collectors.toList());
//            AccidentFrameModel.CarTrack firstCar = value1.get(0);
//            AccidentFrameModel.CarTrack agoCar = mapStateCar.get(firstCar.getTrackId());
//            if (agoCar != null) {
//                double agoStopDist = agoCar.getStopLineDist();
//                if (agoStopDist == firstCar.getStopLineDist() && firstCar.getSpeed() > 0) {
//                    continue;//异常数据
//                }
//                if (Math.abs(firstCar.getSpeed() - agoCar.getSpeed()) > 5) {
//                    continue;//异常数据
//                }
//            }
//            mapStateCar.put(firstCar.getTrackId(), firstCar);
//            String[] funcSps = firstCar.getLaneFunc().split(Constant.COMMA);
//            if (funcSps.length > 1) {
//                continue;
//            }
//            for (String func : funcSps) {
//                String gkey = firstCar.getCrossId() + Constant.MARK + firstCar.getRid() + Constant.MARK + func;
//                Integer turnLaneCount = turnLaneCountMap.get(gkey);
//                if (turnLaneCount == null) {
//                    turnLaneCount = 1;
//                } else {
//                    turnLaneCount++;
//                }
//                turnLaneCountMap.put(gkey, turnLaneCount);
//
//                if (firstCar.getSpeed() <= configModel.getAbnormalParkStopSpeed()) {
//                    Double count = turnStopRateMap.get(gkey);
//                    if (count == null) {
//                        count = 1D;
//                    } else {
//                        count++;
//                    }
//                    turnStopRateMap.put(gkey, count);
//                } else {
//                    Double count = turnRunRateMap.get(gkey);
//                    if (count == null) {
//                        count = 1D;
//                    } else {
//                        count++;
//                    }
//                    turnRunRateMap.put(gkey, count);
//                }
//            }
//        }
//        for (Map.Entry<String, Integer> entry1 : turnLaneCountMap.entrySet()) {
//            String key = entry1.getKey();
//            double stopRate = turnStopRateMap.get(key) == null ? 0 : turnStopRateMap.get(key) / entry1.getValue();
//            double runRate = turnRunRateMap.get(key) == null ? 0 : turnRunRateMap.get(key) / entry1.getValue();
//            retMap.put(key, new Double[]{stopRate, runRate});
//        }
//        return retMap;
//    }
//
//
//    /**
//     * 获取key
//     *
//     * @param carTrack
//     * @return
//     */
//    private String getKey(AccidentFrameModel.CarTrack carTrack) {
//        return carTrack.getCrossId() + Constant.MARK + carTrack.getTrackId();
//    }
//
//}
