package com.wanji.indicators.event.cross.accident.funcnew;

import com.wanji.indicators.constant.Constant;
import com.wanji.indicators.constant.TurnEnum;
import com.wanji.indicators.entity.BaseCrossTurnInfo;
import com.wanji.indicators.model.event.accident.AccidentFrameModel;
import org.apache.commons.lang3.StringUtils;
import org.apache.flink.streaming.api.functions.co.CoFlatMapFunction;
import org.apache.flink.util.Collector;

import java.util.*;

/* *
 *
 * @Description
 * @Author fengyi
 * @Date 17:11 2022/1/20
 **/
public class AccidentRightVehicleRidRefFlatMap implements CoFlatMapFunction<AccidentFrameModel, HashMap<String, Map<String, String>>, AccidentFrameModel> {

    private Map<String, Map<String, String>> hashMap = new HashMap();

    @Override
    public void flatMap1(AccidentFrameModel accidentFrameModel, Collector<AccidentFrameModel> collector) throws Exception {

        Map<String, String> ridTurnRefMap = hashMap.get(accidentFrameModel.getCrossId());

        List<AccidentFrameModel.CarTrack> trackList = accidentFrameModel.getTrackList();
        for (AccidentFrameModel.CarTrack carTrack : trackList) {

            //车道功能
            String laneFunc = TurnEnum.getLaneFunction(carTrack.getRoadnet().getTurn());
            //右转车无灯态时
            if (Objects.nonNull(laneFunc) &&
                    laneFunc.contains(Constant.RIGHT_TURN_CODE) &&
                    (carTrack.getRidTurnLampStatusModel() == null ||
                            carTrack.getRidTurnLampStatusModel().isEmpty())
            ) {
                if (ridTurnRefMap != null) {
                    //进口道右转出口rid 可进入的rid
                    Map<String, String> map = new HashMap<>();
                    //车辆当前进口道rid
                    String currentRid = carTrack.getRoadnet().getRid();

                    for (String frids : ridTurnRefMap.values()) {
                        String crtRightRid = currentRid + Constant.SEMICOLON + Constant.RIGHT_TURN_CODE;
                        if (frids.contains(crtRightRid)) {
                            String[] sps = frids.split(Constant.COMMA);
                            //排除当前方向frid
                            List<String> fridList = new ArrayList<>(Arrays.asList(sps));
                            fridList.remove(crtRightRid);

                            String joinRid = StringUtils.join(fridList, Constant.COMMA);
                            map.put(currentRid, joinRid);
                        }
                    }
                    carTrack.setRidTurnRefMap(map);
                }
            }
        }

        collector.collect(accidentFrameModel);
    }

    @Override
    public void flatMap2(HashMap<String, Map<String, String>> ridTurnRefMap, Collector<AccidentFrameModel> collector) throws Exception {
        this.hashMap = ridTurnRefMap;
    }

}
