package com.wanji.indicators.event.cross.conflictpoint.func;

import com.wanji.indicators.model.CarTrackModel;
import com.wanji.indicators.model.ConfigModel;
import com.wanji.indicators.model.FrameModel;
import org.apache.flink.api.common.functions.FlatMapFunction;
import org.apache.flink.util.Collector;

import java.util.*;

public class ConflictCongestionFilterFlatMap implements FlatMapFunction<FrameModel, FrameModel> {
    @Override
    public void flatMap(FrameModel frameModel, Collector<FrameModel> collector) throws Exception {
        List<CarTrackModel> trackList = frameModel.getTrackList();
        ConfigModel configModel = new ConfigModel();

        Map<String, List<CarTrackModel>> listMap = new HashMap<>();
        for (CarTrackModel carTrack : trackList) {
            if (carTrack.getSpeed() < 8.0
                    /*&& StringUtils.isNotBlank(carTrack.getLaneFunc()) && !carTrack.getLaneFunc().contains(Constant.LEFT_TURN_CODE)*/) {
                String rid = carTrack.getRoadnet().getRid();
                List<CarTrackModel> carTrackRidList = listMap.get(rid);
                if (carTrackRidList == null) {
                    carTrackRidList = new ArrayList<>();
                }
                carTrackRidList.add(carTrack);
                listMap.put(rid, carTrackRidList);
            }
        }

        Set<String> ridSet = new HashSet<>();
        for (String rid : listMap.keySet()) {
            List<CarTrackModel> carTracks = listMap.get(rid);
            int size = carTracks.size();
            if (size > 5) {
                //缓存疑似拥堵的方向数据
                ridSet.add(rid);
                //CongestionVehicleCache.getInstance().put(EventType.CONFLICT_POINT + frameModel.getCrossId() + rid, frameModel.getTime());
            }
        }

        //获取拥堵状态 若发生拥堵则暂时不计算冲突点
        boolean bool = true;
        List<CarTrackModel> resultList = new ArrayList<>();
        for (CarTrackModel carTrack : trackList) {
            //过滤疑似拥堵方向的车辆
            Long aLong = 0L;//CongestionVehicleCache.getInstance().get(EventType.CONFLICT_POINT + carTrack.getCrossId() + carTrack.getRid());
            if (aLong != null) {
                long txCongestion = Math.abs(aLong - carTrack.getGlobalTimeStamp());
                if (txCongestion < 90000L) {
                    bool = false;
                } else {
                    //拥堵消散
                    //CongestionVehicleCache.getInstance().remove(EventType.CONFLICT_POINT + carTrack.getCrossId() + carTrack.getRid());
                }
            }
            if(bool){
                resultList.add(carTrack);
            }
        }
        frameModel.setTrackList(resultList);
        collector.collect(frameModel);
    }
}
