package com.wanji.indicators.event.cross.conflictpoint.func;

import com.wanji.indicators.constant.VehicleTypeEnum;
import com.wanji.indicators.model.event.confilct.EventCross;
import org.apache.flink.api.common.state.MapState;
import org.apache.flink.api.common.state.MapStateDescriptor;
import org.apache.flink.api.java.tuple.Tuple;
import org.apache.flink.configuration.Configuration;
import org.apache.flink.streaming.api.functions.KeyedProcessFunction;
import org.apache.flink.util.Collector;

public class ConflictDeduplicationKeyedProcess extends KeyedProcessFunction<Tuple, EventCross, EventCross> {

    MapState<String, EventCross> mapState = null;

    @Override
    public void open(Configuration parameters) {
        mapState = getRuntimeContext().getMapState(new MapStateDescriptor<>("eventMapStateQC", String.class, EventCross.class));
    }

    @Override
    public void processElement(EventCross event, Context ctx, Collector<EventCross> out) throws Exception {
        String key = event.getCrossId() + "-" + event.getTrackId();
        String nearKey = event.getCrossId() + "-" + event.getNearTrackObj().getTrackId();

        EventCross value = mapState.get(key);
        if (value == null) {
            event.setConfigModel(null);

            mapState.put(key, event);
            mapState.put(nearKey, event);

            out.collect(event);

            ctx.timerService().registerProcessingTimeTimer(System.currentTimeMillis() + 180000L);
        }
    }

    @Override
    public void onTimer(long timestamp, OnTimerContext ctx, Collector<EventCross> out) throws Exception {
        mapState.clear();
    }
}
