package com.wanji.indicators.event.cross.conflictpoint.func;

import com.wanji.indicators.constant.Constant;
import com.wanji.indicators.constant.VehicleTypeEnum;
import com.wanji.indicators.model.CarTrackModel;
import com.wanji.indicators.model.ConfigModel;
import com.wanji.indicators.model.CrossFrameModel;
import com.wanji.indicators.model.FrameModel;
import com.wanji.indicators.util.CommonUtil;
import com.wanji.indicators.util.PtInPolyUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.apache.flink.api.common.functions.FlatMapFunction;
import org.apache.flink.util.Collector;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Slf4j
public class ConflictFrameFlatMap implements FlatMapFunction<CrossFrameModel, CrossFrameModel> {

    @Override
    public void flatMap(CrossFrameModel frameModel, Collector<CrossFrameModel> collector) throws Exception {
        List<CarTrackModel> trackList = frameModel.getTrackList();
        ConfigModel configModel = new ConfigModel();

        if (configModel.getConflictIsOpen() == 1) {
            List<CarTrackModel> resultList = new ArrayList<>();

            for (CarTrackModel carTrack : trackList) {
                CarTrackModel.RoadNet roadNet = carTrack.getRoadnet();
                //筛选在路口内的车辆
                if (roadNet.getInCrossFlag() == Constant.CROSSING) {
                    //路口内混合车道车道转向判定
                    if (roadNet.getTurn()>4) {
                        carTrack.setCarTurn(CommonUtil.getCarTurn(carTrack));
                    } else {
                        carTrack.setCarTurn(roadNet.getTurn());
                    }
                    resultList.add(carTrack);
                }
            }
            frameModel.setTrackList(resultList);
            collector.collect(frameModel);
        }
    }
}
