package com.wanji.indicators.event.cross.conflictpoint.func;

import com.wanji.indicators.constant.Constant;
import com.wanji.indicators.model.CrossFrameModel;
import com.wanji.indicators.model.event.accident.AccidentFrameModel;
import org.apache.flink.streaming.api.functions.co.CoFlatMapFunction;
import org.apache.flink.util.Collector;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Set;

/**
 *
 * @auther fengyi
 */
public class ConflictSlotCoFlatMap implements CoFlatMapFunction<CrossFrameModel, Map<String, List<String>>, CrossFrameModel> {
    //key:cross-rid-ridDir-turn value:crossid-rid-ridDir-冲突转向
    private Map<String, List<String>> conflictSlotMap = new HashMap<>();

    @Override
    public void flatMap1(CrossFrameModel frameModel, Collector<CrossFrameModel> collector) throws Exception {
        if (conflictSlotMap != null) {
            Map<String, List<String>> filterMap = new HashMap<>();

            Set<String> keys = conflictSlotMap.keySet();
            //过滤出当前路口的数据
            for (String key : keys) {
                String[] sps = key.split(Constant.MARK);
                String crossId = sps[0];
                if (Objects.equals(crossId, frameModel.getCrossId())) {
                    filterMap.put(key,conflictSlotMap.get(key));
                }
            }
            frameModel.setConflictSlotMap(filterMap);
            collector.collect(frameModel);
        }
    }

    @Override
    public void flatMap2(Map<String, List<String>> sourceMap, Collector<CrossFrameModel> collector) throws Exception {
        this.conflictSlotMap = sourceMap;
    }

}
