package com.wanji.indicators.event.cross.conflictpoint.func;

import com.wanji.indicators.cache.PedestrianDataCache;
import com.wanji.indicators.constant.Constant;
import com.wanji.indicators.model.CarTrackModel;
import com.wanji.indicators.model.CrossFrameModel;
import com.wanji.indicators.model.FrameModel;
import com.wanji.indicators.model.event.WaitingAreaDo;
import com.wanji.indicators.util.CommonUtil;
import com.wanji.indicators.util.GeomsConvertUtil;
import org.apache.commons.lang3.StringUtils;
import org.apache.flink.api.common.functions.FlatMapFunction;
import org.apache.flink.streaming.api.functions.co.CoFlatMapFunction;
import org.apache.flink.util.Collector;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Objects;

public class ConflictWaitingAreaCoFlatMap implements FlatMapFunction<CrossFrameModel, CrossFrameModel>{


    @Override
    public void flatMap(CrossFrameModel frameModel, Collector<CrossFrameModel> out) throws Exception {
        List<CarTrackModel> resultList = new ArrayList<>();

        List<CarTrackModel> trackList = frameModel.getTrackList();
        for(CarTrackModel carTrack : trackList) {
            CarTrackModel.RoadNet roadNet = carTrack.getRoadnet();
            boolean isInWaitArea = CommonUtil.isInWaitTurnArea(roadNet.getRid(),carTrack);
            //排除掉待转区车辆
            if (!isInWaitArea) {
                resultList.add(carTrack);
            }
        }
        frameModel.getTrackList().clear();
        frameModel.setTrackList(resultList);
        out.collect(frameModel);
    }
}
