package com.wanji.indicators.event.cross.congestion.funcnew;

import com.wanji.indicators.constant.Constant;
import com.wanji.indicators.model.event.congestion.CongestionFrameModel;
import org.apache.commons.lang3.StringUtils;
import org.apache.flink.streaming.api.functions.co.CoFlatMapFunction;
import org.apache.flink.util.Collector;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * 2022/1/12 1:01
 *
 * @auther fengyi
 */
public class CongestionCheckDirCoFlatMap implements CoFlatMapFunction<CongestionFrameModel, HashMap<String, String>, CongestionFrameModel> {

    private HashMap<String, String> ridDirMap = new HashMap<>();

    @Override
    public void flatMap1(CongestionFrameModel congestionFrameModel, Collector<CongestionFrameModel> collector) throws Exception {
        List<CongestionFrameModel.CarTrack> trackList = congestionFrameModel.getTrackList();
        List<CongestionFrameModel.CarTrack> list = new ArrayList<>();
        for (CongestionFrameModel.CarTrack carTrack : trackList) {
            String ridOut = carTrack.getRidOut();
            if (StringUtils.isNotBlank(ridOut)) {
                String dirCode = ridDirMap.get(ridOut + Constant.MARK);
                if (StringUtils.isNotBlank(dirCode)){
                    carTrack.setRidOutDir(dirCode);
                } else {
                    carTrack.setRidOutDir("");
                }
            }
            list.add(carTrack);
        }
        congestionFrameModel.setTrackList(list);
        collector.collect(congestionFrameModel);
    }

    @Override
    public void flatMap2(HashMap<String, String> stringStringHashMap, Collector<CongestionFrameModel> collector) throws Exception {
        this.ridDirMap = stringStringHashMap;
    }

}
