package com.wanji.indicators.event.cross.congestion.funcnew;

import com.wanji.indicators.constant.Constant;
import com.wanji.indicators.model.event.congestion.CongestionModel;
import com.wanji.indicators.model.event.congestion.CrossShapeModel;
import org.apache.flink.streaming.api.functions.co.CoFlatMapFunction;
import org.apache.flink.util.Collector;

import java.util.HashMap;

/**
 * 2022/1/11 18:13
 *
 * @auther fengyi
 */
public class CongestionCheckOutRidCoFlatMap implements CoFlatMapFunction<CongestionModel, HashMap<String, CrossShapeModel>, CongestionModel> {

    private HashMap<String, CrossShapeModel> hashMap = new HashMap<>();

    @Override
    public void flatMap1(CongestionModel congestionFrameModel, Collector<CongestionModel> collector) throws Exception {
        String ridOut = congestionFrameModel.getRidOut();
        String key = ridOut + Constant.MARK + Constant.STRAIGHT_LINE_CODE;
        CrossShapeModel crossShapeModel = hashMap.get(key);
        if (crossShapeModel != null) {
            congestionFrameModel.setRidIn(crossShapeModel.getRidIn());
        }
        collector.collect(congestionFrameModel);
    }

    @Override
    public void flatMap2(HashMap<String, CrossShapeModel> stringCrossShapeModelHashMap, Collector<CongestionModel> collector) throws Exception {
        this.hashMap = stringCrossShapeModelHashMap;
    }


}
