package com.wanji.indicators.event.cross.congestion.funcnew;

import com.wanji.indicators.model.event.congestion.CongestionFrameModel;
import org.apache.commons.lang3.StringUtils;
import org.apache.flink.streaming.api.functions.co.CoFlatMapFunction;
import org.apache.flink.util.Collector;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * 2021/11/19 17:31
 *
 * @auther fengyi
 */
public class CongestionCheckWaitLaneCoFlatMap implements CoFlatMapFunction<CongestionFrameModel, HashMap<String, Integer>, CongestionFrameModel> {

    private HashMap<String, Integer> mapWaitLane = new HashMap<>();

    @Override
    public void flatMap1(CongestionFrameModel accidentCongestionFrameModel, Collector<CongestionFrameModel> collector) throws Exception {
        List<CongestionFrameModel.CarTrack> trackList = accidentCongestionFrameModel.getTrackList();
        List<CongestionFrameModel.CarTrack> list = new ArrayList<>();
        for(CongestionFrameModel.CarTrack carTrack : trackList) {
            String entryLane = carTrack.getEntryLane();
            if (StringUtils.isNotBlank(entryLane)) {
                //待转区距离停止线的距离
                Integer waitLaneDistance = mapWaitLane.get(entryLane);
                if( waitLaneDistance != null ) {
                    if (carTrack.getAreaDist() > waitLaneDistance + 2.5) {
                        carTrack.setWaitLaneDistance(waitLaneDistance);
                        list.add(carTrack);
                    }
                } else {
                    list.add(carTrack);
                }
            }
        }
        accidentCongestionFrameModel.setTrackList(list);
        collector.collect(accidentCongestionFrameModel);
    }

    @Override
    public void flatMap2(HashMap<String, Integer> stringIntegerHashMap, Collector<CongestionFrameModel> collector) throws Exception {
        this.mapWaitLane = stringIntegerHashMap;
    }

}
