package com.wanji.indicators.event.cross.congestion.funcnew;

import com.wanji.indicators.constant.Constant;
import com.wanji.indicators.model.ConfigModel;
import com.wanji.indicators.model.CrossFrameModel;
import com.wanji.indicators.model.FrameModel;
import org.apache.flink.streaming.api.functions.co.CoFlatMapFunction;
import org.apache.flink.util.Collector;

import java.util.HashMap;

/**
 * 2022/2/16 16:42
 *
 * @auther fengyi
 */
public class CongestionConfigCoFlatMap implements CoFlatMapFunction<CrossFrameModel, HashMap<String, ConfigModel>, CrossFrameModel> {


    private HashMap<String, ConfigModel> hashMap;

    @Override
    public void flatMap1(CrossFrameModel frameModel, Collector<CrossFrameModel> collector) throws Exception {
        if (hashMap != null) {
            ConfigModel model = hashMap.get(frameModel.getCrossId());
            if (model != null) {
                if (model.getOverFlowCongestIsOpen() == Constant.OPEN) {
                    frameModel.setConfigModel(model);
                    collector.collect(frameModel);
                }
            } else {
                frameModel.setConfigModel(new ConfigModel());
                collector.collect(frameModel);
            }
        }
    }

    @Override
    public void flatMap2(HashMap<String, ConfigModel> stringConfigModelHashMap, Collector<CrossFrameModel> collector) throws Exception {
        this.hashMap = stringConfigModelHashMap;
    }


}
