package com.wanji.indicators.event.cross.congestion.funcnew;

import com.wanji.indicators.constant.Constant;
import com.wanji.indicators.model.CarTrackModel;
import com.wanji.indicators.model.ConfigModel;
import com.wanji.indicators.model.CrossFrameModel;
import com.wanji.indicators.model.FrameModel;
import com.wanji.indicators.model.event.congestion.CongestionFrameModel;
import org.apache.commons.lang3.StringUtils;
import org.apache.flink.api.common.functions.FlatMapFunction;
import org.apache.flink.util.Collector;
import org.springframework.beans.BeanUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * 2021/11/18 16:44
 *
 * @auther fengyi
 */
public class CongestionFlatMap implements FlatMapFunction<CrossFrameModel, CongestionFrameModel> {
    @Override
    public void flatMap(CrossFrameModel frameModel, Collector<CongestionFrameModel> collector) throws Exception {
        List<CarTrackModel> trackList = frameModel.getTrackList();
        ConfigModel configModel = frameModel.getConfigModel();
        if (configModel.getOverFlowCongestIsOpen() == Constant.OPEN) {
            List<CongestionFrameModel.CarTrack> list = new ArrayList<>();
            for (CarTrackModel carTrack : trackList) {
                if (StringUtils.equals(carTrack.getRoadnet().getLaneId(), "null")) {

                    CongestionFrameModel.CarTrack car = new CongestionFrameModel.CarTrack();
                    BeanUtils.copyProperties(carTrack,car);

                    list.add(car);
                }
            }
            CongestionFrameModel model = new CongestionFrameModel();
            model.setConfigModel(configModel);
            model.setCrossId(frameModel.getCrossId());
            model.setTime(frameModel.getGlobalTimeStamp());
            model.setTrackList(list);
            collector.collect(model);
        }
    }


}
