package com.wanji.indicators.event.cross.deadlock.func;

import com.wanji.indicators.constant.Constant;
import com.wanji.indicators.model.event.deadlock.DeadLockFrameModel;
import org.apache.flink.streaming.api.functions.co.CoFlatMapFunction;
import org.apache.flink.util.Collector;

import java.util.*;

/**
 * 2021/11/19 17:31
 *
 * @auther fengyi
 */
public class DeadlockConflictSlotCoFlatMap implements CoFlatMapFunction<DeadLockFrameModel, Map<String, List<String>>, DeadLockFrameModel> {

    private Map<String, List<String>> conflictSlotMap = new HashMap<>();

    @Override
    public void flatMap1(DeadLockFrameModel frameModel, Collector<DeadLockFrameModel> collector) throws Exception {
        if (conflictSlotMap != null) {
            Map<String, List<String>> filterMap = new HashMap<>();

            Set<String> keys = conflictSlotMap.keySet();
            //过滤出当前路口的数据
            for (String key : keys) {
                String[] sps = key.split(Constant.MARK);
                String crossId = sps[2];
                if (Objects.equals(crossId, frameModel.getCrossId())) {
                    String subKey = key.substring(0,key.lastIndexOf(Constant.MARK));
                    filterMap.put(subKey,conflictSlotMap.get(key));
                }
            }

            frameModel.setConflictSlotMap(filterMap);
            collector.collect(frameModel);
        }
    }

    @Override
    public void flatMap2(Map<String, List<String>> sourceMap, Collector<DeadLockFrameModel> collector) throws Exception {
        this.conflictSlotMap = sourceMap;
    }

}
