package com.wanji.indicators.event.cross.deadlock.func;

import com.wanji.indicators.constant.Constant;
import com.wanji.indicators.constant.VehicleTypeEnum;
import com.wanji.indicators.model.CarTrackModel;
import com.wanji.indicators.model.ConfigModel;
import com.wanji.indicators.model.CrossFrameModel;
import com.wanji.indicators.model.FrameModel;
import com.wanji.indicators.model.event.deadlock.DeadLockFrameModel;
import org.apache.flink.api.common.functions.FlatMapFunction;
import org.apache.flink.util.Collector;
import org.springframework.beans.BeanUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * 死锁事件--过滤出路口内轨迹
 */
public class DeadlockFlatMap implements FlatMapFunction<CrossFrameModel, DeadLockFrameModel> {


    @Override
    public void flatMap(CrossFrameModel frameModel, Collector<DeadLockFrameModel> collector) throws Exception {
        List<CarTrackModel> trackList = frameModel.getTrackList();
        List<DeadLockFrameModel.CarTrack> list = new ArrayList<>();

        ConfigModel configModel = frameModel.getConfigModel();
        if (configModel.getThreeColorAlarmIsOpen() == Constant.OPEN) {
            for (CarTrackModel carTrack : trackList) {
                if (VehicleTypeEnum.isMotorVehicles(carTrack.getOriginalType().shortValue())
                        && carTrack.getRoadnet().getInCrossFlag() == Constant.CROSSING
                        //&& carTrack.getStopLineDist() < 0
                        //&& carTrack.getAreaDist() > 8
                ) {
                    DeadLockFrameModel.CarTrack car = new DeadLockFrameModel.CarTrack();
                    BeanUtils.copyProperties(carTrack, car);
                    list.add(car);
                }
            }
            DeadLockFrameModel model = new DeadLockFrameModel();
            model.setCrossId(frameModel.getCrossId());
            model.setTime(frameModel.getGlobalTimeStamp());
            model.setTrackList(list);
            model.setRidTurnLampList(frameModel.getRidTurnLampList());
            model.setConfigModel(frameModel.getConfigModel());
            collector.collect(model);
        }
    }
}
