package com.wanji.indicators.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.wanji.indicators.entity.BaseCrossTurnInfo;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface BaseCrossTurnInfoMapper extends BaseMapper<BaseCrossTurnInfo> {
	
	 /**
	  *  查询表t_base_cross_turn_info所有信息
	  */
	 List<BaseCrossTurnInfo> findAllBaseCrossTurnInfo();
	  
	 /**
	  *  根据主键id查询表t_base_cross_turn_info信息
	  *  @param id
	  */
	 BaseCrossTurnInfo findBaseCrossTurnInfoByid(@Param("id") String id);

	/**
	*  根据条件查询表t_base_cross_turn_info信息
	*  @param baseCrossTurnInfo
	*/
	List<BaseCrossTurnInfo> findBaseCrossTurnInfoByCondition(BaseCrossTurnInfo baseCrossTurnInfo);

	 /**
	  *  根据主键id查询表t_base_cross_turn_info信息
	  *  @param id
	  */
	 Integer deleteBaseCrossTurnInfoByid(@Param("id") String id);
	
	 /**
	  *  根据主键id更新表t_base_cross_turn_info信息
	  *  @param baseCrossTurnInfo
	  */
	 Integer updateBaseCrossTurnInfoByid(BaseCrossTurnInfo baseCrossTurnInfo);
	
	 /**
	  *  新增表t_base_cross_turn_info信息
	  *  @param baseCrossTurnInfo
	  */
	 Integer addBaseCrossTurnInfo(BaseCrossTurnInfo baseCrossTurnInfo);


	/**
	 *  根据条件查询表t_base_cross_turn_info信息
	 *  @param baseCrossTurnInfo
	 *  @return
	 */
	List<BaseCrossTurnInfo> findRidTurnInfo(BaseCrossTurnInfo baseCrossTurnInfo);
	
}

