package com.wanji.indicators.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.wanji.indicators.entity.BaseLaneInfo;

import java.util.List;
import java.util.Map;

public interface BaseLaneInfoMapper extends BaseMapper<BaseLaneInfo>{

	/**
	 *  根据条件查询表t_base_lane_info信息
	 *  @param baseLaneInfo
	 */
	List<BaseLaneInfo> findBaseLaneInfoByCondition(BaseLaneInfo baseLaneInfo);



	/**
	 * 查询路口道路方向坐标、车道坐标，
	 * @param params
	 * @return
	 */
	List<BaseLaneInfo> findCrossLaneInfo(Map<String,Object> params);

	/**
	 * 获取RID信息
	 * @return
	 */
	List<Map<String,Object>> findRidInfo(Map<String, Object> params);

	/**
	 * 路段自由流查询
	 * @return
	 */
	List<Map<String,Object>> findRidFreeSpeed(Map<String,Object> params);


	List<Map<String,Object>> findLaneJoinRef(Map<String,Object> params);
}

