package com.wanji.indicators.model;

import com.wanji.indicators.constant.Constant;
import lombok.Data;
import lombok.ToString;
import lombok.experimental.SuperBuilder;

import java.io.Serializable;

/**
 * @Author fengyi
 * @Date 2020/4/10 19:25
 **/
@Data
public class BaseEventResultModel   implements Serializable {
    String id;
    /**
     * 路口id
     */
    private String crossId;
    /**
     * 路口车辆标识
     */
    private Integer trackId;
    /**
     * 所属车道id
     */
    private String laneId;
    /**
     * rid
     */
    private String rid;
    /**
     * 事件标识
     */
    private String eventClass;
    /**
     * 车辆号牌
     */
    private String plateNumber;
    /**
     * 车牌颜色
     */
    private int plateColor;
    /**
     * 车身颜色
     */
    private int vehicleColor;
    /**
     * 车辆品牌
     */
    private String vehicleBrand;
    /**
     * 车牌类型
     */
    private int plateType;
    /**
     * 车辆类型
     */
    private String vehicleType;
    /**
     * 事件类型
     */
    private String eventType;
    /**
     * 事件类型编码
     */
    private String typeCode;
    /**
     * 开始时间
     */
    private long startTime;
    private String startTimeStr;
    /**
     * 结束时间
     */
    private long endTime;
    private String endTimeStr;
    /**
     * 持续时间
     */
    private long duration;
    /**
     * 事件信息
     */
    private String desc;
    /**
     * 事件信息 - 英文
     */
    private String descEn;
    /**
     * 坐标点
     */
    private double [] location;
    /**
     * 车速
     */
    private double speed;
    /**
     * 图片1时间
     */
    private long pictureTime1;
    /**
     * 图片2时间
     */
    private long pictureTime2;
    /**
     * 图片3时间
     */
    private long pictureTime3;

    private double x;

    private double y;
    /**
     * 时间  必须有
     */
    private long time;
    /**
     * 事件检出时间
     */
    private long checkOutTime;
    /**
     * 路口名称
     */
    private String recoveryCross;
    /**
     * 状态
     */
    private int eventState;

    /**
     * 记录时间，格式：yyyy-MM-dd HH:mm:ss.SSS
     */
    private String recordDateTime;
    /**
     * 影响的rid，多个以逗号分割
     */
    private String effectRids;

    private int category;


}


