package com.wanji.indicators.model;

import com.wanji.indicators.constant.ParticipantEnum;
import lombok.Data;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.Serializable;

@Data
public class ConfigModel implements Serializable {

    private static final Logger log = LoggerFactory.getLogger(ConfigModel.class);
    //三色预警开关
    private int threeColorAlarmIsOpen = 1;

    //=================异常停车配置  开始=======================//
    private long abnormalParkIsOpen = 1;
    /*目录类型，多个以逗号分隔（机动车、非机动车、人行）*/
    private String abnormalParkObjectType = ParticipantEnum.MOTOR.getType();
    /*距离停止线距离过滤*/
    private double abnormalParkStopLineDist = 6;
    /*无灯态-》距离停止线距离过滤*/
    private double abnormalNoLampParkStopLineDist = 12;
    /*判定路口溢出速度阈值*/
    private double abnormalParkCongestSpeed = 10.0;
    /*判定路口溢出持续时间阈值*/
    private long abnormalParkCongestDuration = 3000;
    /*判定拥堵消散车辆数阈值*/
    private long abnormalParkCongestDissipationCarNum = 2;
    /*判定拥堵消散速度阈值*/
    private double abnormalParkCongestDissipationSpeed = 10;
    /*判定拥堵消散持续时间阈值*/
    private long abnormalParkCongestDissipationDuration = 3000;
    /*路口内拥堵比例阈值*/
    private double abnormalParkCrossCongestRate = 0.25;
    /*路口内是否使用拥堵比例的车辆数阈值*/
    private long abnormalParkUseCrossCongestCarNum = 5;
    /*路口内 缓慢车辆总数 阈值*/
    private long abnormalParkCrossSlowCarNum = 3;
    /*停车抖动车速阈值*/
    private double abnormalParkStopShakeSpeed = 3.6;
    /*停车抖动位移阈值*/
    private double abnormalParkStopShakeRange = 5;
    /*判定正常行驶车速阈值*/
    private double abnormalParkStopRemoveSpeed = 5;
    /*判定停车的车速阈值 3.6km/h(1m/s)*/
    private double abnormalParkStopSpeed = 3.6;
    /*停车轨迹消散 移除状态时间阈值*/
    private long abnormalParkStopDissipateRemoveTime = 1700;
    /*提取绕行停车车辆轨迹-行驶距离过滤阈值*/
    private double abnormalParkDetourStopCarDriveDist = 13.0;
    /*提取绕行停车车辆轨迹-小于行驶距离阈值时停车时间阈值*/
    private long abnormalParkDetourStopDurationOfLTDriveDist = 6000;
    /*提取绕行停车车辆轨迹-大于行驶距离阈值时停车时间阈值*/
    private long abnormalParkDetourStopDurationOfGTDriveDist = 1500;
    /*绕行车辆车次阈值*/
    private long abnormalParkDetourNumber = 2;
    /*无灯态绕行停车最小持续时长 单位毫秒*/
    private long abnormalParkDetourNoLampMinStopDuration = 30000;
    /*停车前位置绕行距离阈值*/
    private double abnormalParkDetourDistanceBeforeStopCar = 10;
    /*停车后位置绕行距离阈值*/
    private double abnormalParkDetourDistanceAfterStopCar = 20;
    /*停车时长基础阈值*/
    private long abnormalParkStopBaseDuration = 8*1000;
    /*停车时长最小阈值*/
    private long abnormalParkStopMinDuration = 40 * 1000;
    /*停车时长最大阈值*/
    private long abnormalParkStopMaxDuration = 200 * 1000;
    /*有灯态停车持续时长阈值*/
    private long abnormalParkStopGeenDuration = 8 * 1000;
    /*有相同方向车流判定异常停车的持续时长*/
    private long abnormalParkHaveSameFlowStopDuration = 8*1000;
    /*无相同方向车流判定异常停车的持续时长*/
    private long abnormalParkNoSameFlowStopDuration = 15*1000;
    /*异常停车三色预警配置*/
    private String abnormalParkingThreeColor = "1:30-180;2:180-300;3:300-360000";
    /*异常停车蓝色预警开关*/
    private String abnormalParkingBlueSwitch = "ON";
    /* 异常停车死锁车速判定 */
    private double abnormalParkDeadlockStopCarSpeed = 3.0;
    /* 异常停车死锁持续时间判定 */
    private long abnormalParkDeadlockStopCarDuration = 5000;
    /* 异常停车死锁车辆数判定 */
    private long abnormalParkDeadlockMinCarNums = 5;
    /* 异常停车死锁比例判定 */
    private double abnormalParkDeadlockStopCarRate = 0.5;
    /* 异常停车死锁消散持续时间判定 */
    private long abnormalParkDeadlockDissipationDuration = 5000;
    /*每个冲突方向至少停止车辆数*/
    private long abnormalParkDeadlockConflictMinStopCarNums = 2;
    /*异常停车-死锁冲突车辆间的最大距离 单位米*/
    private long abnormalParkDeadlockConflictCarMaxDistance = 10;
    /*直左对方-安全穿插车头时距阈值 单位秒*/
    private long abnormalParkStraightLeftSafeTimeHead = 5;
    /*直左对方-停车车辆在满足安全穿插车头时距时停车次数*/
    private long abnormalParkStraightLeftStopCount = 2;
    /*直左对方-车辆绿灯停车时长阈值 单位毫秒*/
    private long abnormalParkStraightLeftStopGreenDuration = 9000;
    /*无灯态路口最大周期阈值设置 单位秒*/
    private int abnormalParkNoLampMaxCycle = 180;
    /*无灯态路口最小周期阈值设置 单位秒*/
    private int abnormalParkNoLampMinCycle = 80;
    /*通过停车车道数比例来规避某车道出现跳变情况*/
    private double abnormalParkNoLampStopLaneRate = 0.5;
    /*异常停车斑马线长度阈值*/
    private double abnormalParkZebraCrossLength = 8;
    /*异常停车斑马线区域内至少停车时间*/
    private long abnormalParkZebraAreaCheckTime = 60000;
    /*异常停车路口中央区域内至少停车时间*/
    private long abnormalParkCenterAreaCheckTime = 40000;
    /*异常停车出口区域内至少停车时间*/
    private long abnormalParkOutAreaCheckTime = 20000;
    /*异常停车待转区域内至少停车时间*/
    private long abnormalParkWaitTurnAreaCheckTime = 80000;
    //=====================异常停车配置  结束===================================//

    //=====================路口溢出配置  开始===================================//
    private long overFlowCongestIsOpen = 1;
    /*斑马线长度阈值过滤*/
    private double overFlowCongestZebraCrossLength = 8;
    /*车辆路口内旅行时间阈值*/
    private double overFlowCongestCarTravelTime = 10;
    /*判定车辆拥堵速度阈值*/
    private double overFlowCongestSpeed = 9.0;
    /*判定车辆拥堵车辆数阈值*/
    private long overFlowCongestCarNums = 5;

    /*判定拥堵消散车辆数阈值*/
    private long overFlowCongestDissipationCarNums = 3;
    /*拥堵消散持续时间阈值*/
    private long overFlowCongestDissipationDuration = 60000;
    /*拥堵持续过长切割时间阈值*/
    private long overFlowCongestSplitMaxDuration = 1800000;
    /*拥堵未满足持续时长清理状态时间阈值*/
    private long overFlowCongestUnsatisfiedDurationClear = 5000;

    /*路口溢出三色预警配置*/
    private String overFlowCongestThreeColor = "1:30-120;2:120-300;3:300-360000";
    /*蓝色预警开关*/
    private String overFlowCongestBlueSwitch = "ON";
    //=====================路口溢出配置  结束===================================//

    //=====================违规变道配置  开始===================================//
    private long illegalChangeLaneIsOpen = 1;
    /*车辆行驶速度最低阈值*/
    private double illegalChangeLaneCarMinSpeed = 1.5;
    /*计算范围：车辆距离停止线最小值*/
    private double illegalChangeLaneMinStopLineDist = 1.5;
    /*计算范围：车辆距离停止线最大值*/
    private double illegalChangeLaneMaxStopLineDist = 6;
    /*延后帧数*/
    private int illegalChangeLaneDelayFrameNum = 4;
    //=====================违规变道配置  结束===================================//

    //=====================不按车道行驶配置  开始===================================//
    private long illegalDrivingIsOpen = 1;
    /*车辆行驶速度阈值*/
    private double illegalDrivingMinSpeed = 0.0;
    /*计算范围：车辆距离停止线最小值*/
    private double illegalDrivingMinStopLineDist = 1.0;
    /*计算范围：车辆距离停止线最大值*/
    private double illegalDrivingMaxStopLineDist = 6.0;

    //=====================不按车道行驶配置  结束===================================//

    //=====================冲突事件配置  结束===================================//
    private long conflictIsOpen = 1;
    /*冲突路口斑马线长度阈值过滤*/
    private double conflictCrossZebraCrossLength = 8;
    /*过滤停车车辆前有同行车辆距离阈值*/
    private double conflictFilterSameDirTravelDist = 8;
    /*停车车辆车头延长距离（延长后的点作为车头）*/
    private double conflictStopCarAlongLengOfHead = 1.2;
    /*停车车辆车尾延长距离（延长后的点作为车尾）*/
    private double conflictStopCarAlongLengOfRear = 2.5;
    /*距离计算范围:车头位置与行驶车辆的距离计算范围*/
    private double conflictTwoCarMaxDist = 5;
    /*角度计算范围:停车车辆与行驶车辆两车角度差 最小范围 */
    private double conflictTwoCarMinAngle = 60;
    /*角度计算范围:停车车辆与行驶车辆两车角度差 最大范围 */
    private double conflictTwoCarMaxAngle = 300;
    /*停车车辆向前延长线*/
    private double conflictStopCarForwardAlongLength = 16;
    /*停车车辆向后延长线*/
    private double conflictStopCarBackAlongLength = 18;
    /*行驶车辆车身长度阈值*/
    private double conflictTravelCarLength = 5;
    /*行驶车辆向前延长线*/
    private double conflictTravelCarForwardAlongLength = 16;
    /*行驶车辆向后延长线*/
    private double conflictTravelCarBackAlongLength = 18;
    /*停车车辆车头与行驶车辆冲突角度差*/
    private double conflictResultAngleDif = 60;
    /*冲突持续时间阈值，单位毫秒*/
    private double conflictDuration = 3*1000;
    //=====================冲突事件配置  结束================================//


    //=====================逆行配置  开始===================================//
    private long retrogradeIsOpen = 1;
    //逆行验证时间 逆行时间需要超过2秒
    private long retrogradeDurationTime = 2000;
    //逆行验证距离 逆行距离需要大于10米
    private double retrogradeDistance = 10.0;

    //=====================逆行配置  结束===================================//


    //=====================超速配置  开始===================================//
    private long speedingIsOpen = 1;
    //超速判定最低速度过滤阈值
    private double speedingMinSpeedFilter = 10.0;
    //超速判定比例阈值
    private double speedingCheckRatio = 0.10;

    //=====================急加速事件配置  开始===================================//
    private long rapidAccelerationIsOpen = 1;
    /*加速度计算范围 急加速最小加速度值*/
    private double rapidAccelerationMinValue = -8;
    /*加速度计算范围 急加速最大加速度值*/
    private double rapidAccelerationMaxValue = 8;
    /*异常跳跃数据过滤-车辆连续两帧的加速度差*/
    private double rapidAccelerationAbnormalJumpAccDif = 5;
    /*异常跳跃数据过滤-车辆连续两帧之间的距离*/
    private double rapidAccelerationAbnormalJumpDist = 2.6;
    /*急加速触发-最小加速度阈值*/
    private double rapidAccelerationTriggerMinValue = 3;
    /*急加速持续时间阈值*/
    private long rapidAccelerationDuration = 1800;
    /*急加速结束-最大加速度阈值*/
    private double rapidAccelerationFinishValue = 2.5;
    //=====================急加速事件配置  结束===================================//

    //=====================急减速事件配置  开始===================================//
    private long rapidDecelerationIsOpen = 1;
    /*加速度计算范围 急减速最小加速度值*/
    private double rapidDecelerationMinValue = -8;
    /*加速度计算范围 急减速最大加速度值*/
    private double rapidDecelerationMaxValue = 8;
    /*异常跳跃数据过滤-车辆连续两帧的加速度差*/
    private double rapidDecelerationAbnormalJumpAccDif = 5;
    /*异常跳跃数据过滤-车辆连续两帧之间的距离*/
    private double rapidDecelerationAbnormalJumpDist = 2.6;
    /*急减速触发-最大加速度阈值*/
    private double rapidDecelerationTriggerMaxValue = -4;
    /*急减速持续时间阈值*/
    private long rapidDecelerationtDuration = 1800;
    /*急减速结束-最小加速度阈值*/
    private double rapidDecelerationFinishValue = -3.5;
    //=====================急减速事件配置  结束===================================//

    //=====================急转弯事件配置  开始===================================//
    private long sharpTurnIsOpen = 1;
    /*转弯线轨迹最低平均速度阈值*/
    private double sharpTurnTrackMinAvgSpeed = 15;
    /*离心加速度最低阈值*/
    private double sharpTurnCentrifugalAcceleration = 3.4;
    /*转弯半径最低阈值*/
    private double sharpTurnMinRadius = 4.5;
    /*转弯半径最大阈值*/
    private double sharpTurnMaxRadius = 30;
    /*筛除加速度过大的值*/
    private double sharpTurnTooBigAccelerationFilter = 15;
    /*平均转弯离心加速度放大系数*/
    private double sharpTurnCentrifugalAccelerationFactor = 3.5;
    /*最低连续帧数阈值*/
    private double sharpTurnMinFrameNums = 6;
    //=====================急转弯事件配置  结束===================================//

    //=====================死锁事件配置  开始===================================//
    private long deadlockIsOpen = 1;
    /*死锁停车判断阈值 km/h*/
    private double deadlockStopCarSpeed = 3;
    /*死锁停车判断持续时长阈值 单位毫秒*/
    private long deadlockStopCarDuration = 30000;
    /*死锁路口内最低车辆数阈值 5*/
    private long deadlockMinCarNums = 5;
    /*冲突车辆停车比例 0.5*/
    private double deadlockStopCarRate = 0.5;
    /*死锁消散冲突时间 单位毫秒*/
    private long deadlockDissipationDuration = 60000;
    /*每个冲突方向至少车辆数*/
    private long deadlockConflictMinStopCarNums = 2;
    /*死锁冲突车辆间的最大距离 单位米*/
    private long deadlockConflictCarMaxDistance = 10;
    /*未满足持续时间清理状态时间阈值*/
    private long deadlockStateUnsatisfiedDurationClear = 5000;
    //=====================死锁弯事件配置  结束===================================//

    //路口拥堵事件
    private long crossCongestDuration = 12000;
    private long crossCongestIsOpen = 1;
    //三色预警路口拥堵配置项
    private String crossCongestBlueSwitch = "ON";
    private String crossCongestThreeColor = "1:120-300;2:300-600;3:600-360000";


    //路口失衡事件
    private long crossImbalanceDuration = 12000;
    private long crossImbalanceIsOpen = 1;
    //三色预警路口失衡配置项
    private String crossImbalanceBlueSwitch = "ON";
    private String crossImbalanceThreeColor = "1:120-300;2:300-600;3:600-360000";

    //-------------------- 事故配置项 ---------------------

    private long accidentObjectType;

    private long accidentUseCrossCongestCarNum;

    private double accidentStopShakeSpeed;

    private double accidentStopShakeRange;

    private double accidentStopRemoveSpeed;

    private double accidentStopSpeed;

    private double accidentDetourStopCarDriveDist;

    private double accidentDetourStopDurationOfLTDriveDist;

    private double accidentDetourStopDurationOfGTDriveDist;

    private double accidentDetourDistanceBeforeStopCar;

    private double accidentDetourDistanceAfterStopCar;

    private double accidentStopLineDist;

    private double accidentCongestSpeed;

    private long accidentCongestDuration;

    private long accidentCongestDissipationCarNum;

    private double accidentCongestDissipationSpeed;

    private double accidentCrossCongestRate;

    private long accidentIsOpen = 1;

    private long accidentStopBaseDuration;

    private long accidentStopMinDuration;

    private long accidentStopMaxDuration;

    private long accidentStopGeenDuration;

    private long accidentCrossSlowCarNum;

    private long accidentCongestDissipationDuration;

    private long accidentStopDissipateRemoveTime;

    //-------------------- 事故配置项结束 ---------------


    /**
     * flink离线工作目录
     */
    private String flinkWorkSpacePath;
    /**
     * 三色预警-蓝色预警开关
     */
    private String isOpenBlue;
    /**
     * 安全专题 - 路口溢出持续时间判断阈值 单位(秒)
     */
    private long overFlowCongestionTime;
    /**
     * 车辆跟踪移除车速 5-9 单位(km/h)
     */
    private double stopShakeSpeed;
    /**
     * 停车轨迹允许抖动范围 1-5 单位(m)
     */
    private double stopShakeRange;
    /**
     * 车辆跟踪移除车速 5-9 单位(km/h)
     */
    private double stopRemoveSpeed;
    /**
     * 车辆消失移除时间 1-5 单位(秒)
     */
    private long stopRemoveTime;
    /**
     * 逆行验证时间 1-5 单位(秒)
     */
    private long retrogradeTime;
    /**
     * 逆行验证距离 5-20 单位(米)
     */
    private double retrogradeLength = 10.0;
    /**
     * 异常停车 待转区最小停车时间阈值  60-180 单位(秒)
     */
    private long abnormalParkingWaitingAreaTime;
    /**
     * 异常停车 斑马线最小停车时间阈值  60-180 单位(秒)
     */
    private long abnormalParkingZebraCrossingTime;
    /**
     * 异常停车 路口中央最小停车时间阈值  20-60 单位(秒)
     */
    private long abnormalParkingCrossingCenterTime;
    /**
     * 异常停车 路口出口最小停车时间阈值  20-60 单位(秒)
     */
    private long abnormalParkingCrossingExportTime;
    /**
     * 异常停车持续时间阈值 单位(秒)
     */
    private long abnormalParkingCheckTime;
    /**
     * 异常停车被绕行持续时间阈值 单位(秒)
     */
    private long abnormalParkingDetourTime;
    /**
     * 异常停车道路可通行状态下持续时间阈值 单位(秒)
     */
    private long abnormalParkingPassableTime;
    /**
     * 异常停车以上条件不满足情况下的最大停车时间阈值 单位(秒)
     */
    private long abnormalParkingSpecialTime;


}
