package com.wanji.indicators.model;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 单路口帧数据
 * @author fengyi
 * @date 2023/3/1
 * @description
 */
@Data
public class CrossFrameModel implements Serializable {

    private String crossId;
    private ConfigModel configModel = new ConfigModel();
    //路口各进口道灯态数据
    private List<CrossRidTurnLampStatusModel> ridTurnLampList = new ArrayList<>();

    private String timeStamp;
    private Long globalTimeStamp;
    private Integer participantNum;
    private String orgCode = "";

    private List<CarTrackModel> trackList = new ArrayList<>();

    //冲突相位信息 key:cross-rid-ridDir-turn value:crossid-rid-ridDir-冲突转向
    private Map<String, List<String>> conflictSlotMap = new HashMap<>();

}
