package com.wanji.indicators.model;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;

import java.io.Serializable;
import java.util.*;

/**
 * @author fengyi
 * @date 2023/3/1
 * @description
 */
@Data
public class RoutePathCarTrackModel implements Serializable {

    //id域集合，不同的路口范围可能域ID和车辆ID发生变更 {"orgCode":"","id":""}
    private Set<Map<String,Object>> targetId = new HashSet<>();

    /*车牌号*/
    private String picLicense;
    Integer originalType;
    /*路径起始点车辆时间*/
    private String startTime;
    /*起点所在车道*/
    private String startLaneId;
    /*起点所属路段*/
    private String startRid;
    /*起点所属渠化*/
    private String startSegmentId;
    /*起点所属路口*/
    private String startCrossId;
    /*起点坐标*/
    private Double startLongitude;
    /*终点坐标*/
    private Double startLatitude;
    /*起点时间戳*/
    @JSONField(serialize = false)
    private Long startGlobalTimeStamp;

    /*路径终点车辆时间*/
    private String endTime;
    /*终点所在车道*/
    private String endLaneId;
    /*终点所属路段*/
    private String endRid;
    /*终点所属渠化*/
    private String endSegmentId;
    /*终点所属路口*/
    private String endCrossId;
    /*终点坐标*/
    private Double endLongitude;
    /*终点坐标*/
    private Double endLatitude;
    /*终点时间戳*/
    @JSONField(serialize = false)
    private Long endGlobalTimeStamp;

    /*路径编号*/
    //@JSONField(serialize = false)
    private Integer lineNo = 0;
    /*路径点序号*/
    //@JSONField(serialize = false)
    private Integer seqNo;
    /*路径长度*/
    //@JSONField(serialize = false)
    private Double routeLength=0D;
    //路径坐标集合
//    @JSONField(serialize = false)
    private List<Double[]> pointList = new ArrayList<>();
    /*上一个点坐标*/
    @JSONField(serialize = false)
    private Double preLongitude;
    /*上一个点坐标*/
    @JSONField(serialize = false)
    private Double preLatitude;
    /*上一个点时间戳*/
    @JSONField(serialize = false)
    private Long preTimestamp;

    @JSONField(serialize = false)
    private String preDateTime;

    /*是否为完成计算的路径*/
    @JSONField(serialize = false)
    private boolean isFinished;

    @JSONField(serialize = false)
    private Long createTime;

    //路网数据
    private Set<CarTrackModel.RoadNet> roadNets = new HashSet<>();
    /*车牌颜色*/
    private Integer licenseColor;
    /*车辆颜色*/
    private Integer originalColor;
    /*车辆所有人*/
    private String owner;
    /*使用性质*/
    private Integer function;
    /*所有权*/
    private Integer ownership;

}


