package com.wanji.indicators.model;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import java.util.Set;

/**
 * @author fengyi
 * @date 2023/3/1
 * @description
 */
@Data
public class SingleCarTrackListModel implements Serializable {
    /**
     * 公用属性Start
     */
    /*全域ID*/
    private String orgCode;
    /*车辆ID*/
    private Integer id;
    /*车牌号*/
    private String picLicense;
    /*车牌颜色*/
    private Integer licenseColor;
    /*车辆颜色*/
    private Integer originalColor;
    /*车辆类型*/
    private Integer originalType;
    /*车辆所有人*/
    private String owner;
    /*使用性质*/
    private Integer function;
    /*所有权*/
    private Integer ownership;
    /*窗口开始时间*/
    @JSONField(format="yyyy-MM-dd HH:mm:ss.SSS")
    private Date startTime;
    /*窗口结束时间*/
    @JSONField(format="yyyy-MM-dd HH:mm:ss.SSS")
    private Date endTime;
    /*批次全域监测开始时间*/
    @JSONField(format="yyyy-MM-dd HH:mm:ss.SSS")
    private Date globalStartTime;
    /*批次全域监测结束时间*/
    @JSONField(format="yyyy-MM-dd HH:mm:ss.SSS")
    private Date globalEndTime;
    //路网数据
    private Set<CarTrackModel.RoadNet> roadNets;

    //private CarTrackCommonProperty staticProperty;

    /**
     * 轨迹动态属性集合
     */
    private List<CarTrackDynamicProperty> tracks;

//    @Data
//    @ToString
//    public static class CarTrackCommonProperty implements Serializable {
//        /*全域ID*/
//        private Integer orgCode;
//        /*车辆ID*/
//        private Integer id;
//        /*车牌号*/
//        private String picLicense;
//        /*车牌颜色*/
//        private Integer licenseColor;
//        /*车辆颜色*/
//        private Integer originalColor;
//        /*车辆类型*/
//        private Integer originalType;
//        /*车辆所有人*/
//        private String owner;
//        /*使用性质*/
//        private String function;
//        /*所有权*/
//        private String ownership;
//        /*窗口开始时间*/
//        private String startTime;
//        /*窗口结束时间*/
//        private String endTime;
//        /*批次全域监测开始时间*/
//        private String globalStartTime;
//        /*批次全域监测结束时间*/
//        private String globalEndTime;
//
//    }

    @Data
    public static class CarTrackDynamicProperty implements Serializable {
        /*格式化时间戳：yyyy-MM-dd HH:mm:ss.SSS*/
        private String timeStamp;
        /*数值时间戳*/
        private Long globalTimeStamp;
        /*经度*/
        private Double longitude;
        /*纬度*/
        private Double latitude;
        /*速度*/
        private Double speed;
        /*航向角*/
        private Double courseAngle;
    }
}


