package com.wanji.indicators.model.event.accident;

import com.wanji.indicators.constant.Constant;
import com.wanji.indicators.model.BaseEventResultModel;
import lombok.Data;
import lombok.ToString;

import java.io.Serializable;
import java.util.List;

/**
 * 事故专题展示类
 **/
@Data
@ToString(callSuper = true)
public class AccidentShowModel extends BaseEventResultModel implements Serializable {

    /**
     * 路口唯一id
     */
    private String crossId;
    /**
     * 路口车辆唯一id
     */
    private Integer trackId;
    /**
     * 路口车辆唯一id  多个用逗号分隔
     */
    private String trackIds;
    /**
     * 其他事故车辆
     */
    private List<AccidentFrameModel.CarTrack> otherCarList;

    /**
     * 结果集显示车道
     */
    private String laneId;
    /**
     * 当前所在车道
     */
    private String matchLane;
    /**
     * 另外一辆车 当前所在车道
     */
    private String matchLaneOther;
    /**
     * 路口入口车道
     */
    private String entryLane;
    /**
     * 当前所在rid
     */
    private String rid;
    /**
     * 车牌
     */
    private String plateNumber;

    /**
     * 车辆类型
     */
    private String vehicleType;
    /**
     * 车牌类型
     */
    private int plateType;
    /**
     * 车身颜色
     */
    private int vehicleColor;
    /**
     * 车辆品牌
     */
    private String vehicleBrand;

    /**
     * 事件大类
     */
    private int category;

    /**
     * 处理状态 默认0
     */
    private int handle;

    /**
     * 坐标点
     */
    private double x;
    private double y;

    /**
     * 事件类型
     */
    private String eventType;
    /**
     * 事件类型编码
     */
    private String typeCode;

//----------------   事故辅助定责   --------------------

    /**
     * 检测耗时
     */
    private long checkTime;
    /**
     * 事故时间
     */
    private long startTime;
    private String startTimeStr;
    /**
     * 事故地点
     */
    private String accidentLocation;
    /**
     * 事故描述
     */
    private String accidentDescribe;
    /**
     * 定责建议
     */
    private String responsibility;
    /**
     * 辅助信息
     */
    private String auxiliaryInfo;

    /**
     * 事故描述 - 英语
     */
    private String accidentDescribeEn;
    /**
     * 定责建议 - 英语
     */
    private String responsibilityEn;
    /**
     * 辅助信息 - 英语
     */
    private String auxiliaryInfoEn;

//----------------   交通影响报告   --------------------

    /**
     * 涉事时间段  早高峰=1  平峰=2  晚高峰=3  夜间=4
     */
    private int timeSlot;
    /**
     * 涉事地点 路口=1 路段=2
     */
    private int place;
    /**
     * 涉事车辆数量 单车=1  多车=2
     */
    private int vehicleNum;
    /**
     * 涉事非机动车 无=0 有=1
     */
    private int hasNonMotorVehicle;
    /**
     * 涉事行人 无=0 有=1
     */
    private int hasPedestrian;
    /**
     * 交通影响程度: 低=1 较低=2 中=3 较高=4 高=5
     */
    private int influenceDegree;

//--------------------------------------------------------------

    /**
     * 安全专题显示持续时间
     */
    private long duration;
    /**
     * 事件标识
     */
    private String eventClass;
    /**
     * 事故检测时间
     */
    private long endTime;
    private String endTimeStr;
//--------------------------------------------------------------
    /**
     * 坐标
     */
    private double [] location;
    /**
     * 图片1时间
     */
    private long pictureTime1;
    /**
     * 图片2时间
     */
    private long pictureTime2;
    /**
     * 图片3时间
     */
    private long pictureTime3;
    /**
     * 是否是真实事故  0=否  1=是  2=疑似
     */
    private int isAccident;

    private long time;


    private String sysTimeStart;
    private String sysTimeEnd;

    //标记是停车车辆是否有同转向车道车辆
    private boolean isHasSameTurnCar;
    //有同行方向车辆持续停车时长
    private long sameTurnStopDuration;
    //冲突方向是否有车流行驶
    private boolean isHasConflictCar;

    //是否绿灯停车
    private boolean isGreenStop;
    //绿灯停车持续时间
    private long greenStopDuration;
    //绿灯停车开始时间
    private String greenStopStartTime;
    //非疑似事故异常停车标识
    private boolean isAbnormalStop;

    public void setId() {
        this.setId(crossId + Constant.MARK + trackId + Constant.MARK + trackIds  + Constant.MARK + typeCode + Constant.MARK + startTime);
    }

}
