package com.wanji.indicators.model.event.confilct;


import com.alibaba.fastjson.annotation.JSONField;
import com.wanji.indicators.model.ConfigModel;
import lombok.Data;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

@Data
public class EventCross implements Serializable {

    @JSONField(serialize = false)
    ConfigModel configModel = new ConfigModel();
    /**
     * 路口唯一id
     */
    private String crossId;
    /**
     * 路口车辆唯一id
     */
    private int trackId;
    /**
     * 经度
     */
    private double lng;
    /**
     * 纬度
     */
    private double lat;
    /**
     * 路口入口车道
     */
    private String entryLane;
    /**
     * 当前所在rid
     */
    private String rid;
    /**
     * 速度
     */
    private double speed;
    /**
     * 转向角度
     */
    private double driveAngle;
    /**
     * 车牌
     */
    private String plateNumber;
    /**
     * 车辆类型
     */
    private int vehicleType;
    /**
     * 数据类型  行人机动车 / 2 / 3
     */
    private int objectType;
    /**
     * 事件时间
     */
    private long time;
    /**
     * 持续时间
     */
    private long duration;
    /**
     * 车道功能 1左转 2直行 3右转 4掉头
     */
    private String laneFunction;

    private long startTime;
    private long endTime;
    /**
     * 分类事件 的 类型代码
     */
    private int typeCode;
    private String trackIdNear;
    //冲突临近对象
    private EventCross nearTrackObj;

    private int category;


}
