package com.wanji.indicators.service;

import com.wanji.indicators.entity.BaseLaneInfo;
import com.baomidou.mybatisplus.extension.service.IService;
import com.baomidou.mybatisplus.core.metadata.IPage;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 车道基础信息 服务类
 * </p>
 *
 * @author fengyi
 * @since 2023-04-06
 */
public interface BaseLaneInfoService extends IService<BaseLaneInfo> {

    public List<BaseLaneInfo> findLaneRidInfo();

    public Map<String, BaseLaneInfo> findLaneInfo(String crossId);

    /**
     * 获取RID转向对应的冲突信息
     */
    public Map<String, List<String>> getRidTurnConflictInfo(String crossList);

    public double getAreaFreeSpeed(String crossList, Double defaultFreeSpeed);

    public Map<String, Map<String, Double>> getRidFreeSpeed(String crossList, Double defaultFreeSpeed);

    Map<String, String> findLaneJoinRef();

    /**
     * 进口道RID同方向出口车道集合
     * @param laneList
     * @return
     */
    public Map<String, List<BaseLaneInfo>> findRidSameDirLaneInfo(Collection<BaseLaneInfo> laneList);
}
