package com.wanji.indicators.service.impl;

import com.vividsolutions.jts.geom.LineString;
import com.wanji.indicators.entity.BaseRidInfo;
import com.wanji.indicators.mapper.BaseRidInfoMapper;
import com.wanji.indicators.service.BaseRidInfoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.wanji.indicators.util.ArithOfBigDecmial;
import com.wanji.indicators.util.GeomsConvertUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import javax.annotation.Resource;
import java.util.List;

/**
* <p>
* 路段基础信息 服务实现类
* </p>
*
* @author fengyi
* @since 2023-04-05
*/
@Service
public class BaseRidInfoServiceImpl extends ServiceImpl<BaseRidInfoMapper, BaseRidInfo> implements BaseRidInfoService {

	@Resource
	 private BaseRidInfoMapper baseRidInfoMapper;

	@Override
	public List<BaseRidInfo> findAll() {
		List<BaseRidInfo> list = baseRidInfoMapper.findAllBaseRidInfo();

		for (BaseRidInfo model : list) {
			String wkt = model.getWkt();
			LineString lineString = GeomsConvertUtil.getLineString(wkt);
			double ridLength = lineString.getLength();
			model.setLength(ridLength);
		}
		return null;
	}

	public static void main(String[] args) {
		String wkt = "112.96358875770298,28.188337641846843;112.96340547895414,28.18724784621854;112.96322220020323,28.18615803948525;112.96310925849781,28.184595086003952;112.96292227780222,28.18303210967499";
		LineString lineString = GeomsConvertUtil.getLineString(wkt);
		double ridLength = lineString.getLength();
		System.out.println(ArithOfBigDecmial.mul(ridLength, 6371000 * Math.PI / 180));
	}
}
