package com.wanji.indicators.service.impl;

import com.wanji.indicators.entity.CongestionArea;
import com.wanji.indicators.mapper.CongestionAreaMapper;
import com.wanji.indicators.service.CongestionAreaService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;
import javax.annotation.Resource;
import java.util.List;

/**
* <p>
*  服务实现类
* </p>
*
* @author fengyi
* @since 2023-10-25
*/
@Service
 public class CongestionAreaServiceImpl extends ServiceImpl<CongestionAreaMapper, CongestionArea> implements CongestionAreaService {

	 @Resource
	 private CongestionAreaMapper congestionAreaMapper;

	
	 /**
	 * 详情
	 * @param id
	 * @return
	 */
	 @Override
	 public CongestionArea info(Long id) {
	
	 	return getById(id);
	 }
	
	 /**
	 * 新增
	 * @param param 根据需要进行传值
	 * @return
	 */
	 @Override
	 public void add(CongestionArea param) {
	
	 	save(param);
	 }
	
	 /**
	 * 修改
	 * @param param 根据需要进行传值
	 * @return
	 */
	 @Override
	 public void modify(CongestionArea param) {
	
	 	updateById(param);
	 }
	
	 /**
	 * 删除(单个条目)
	 * @param id
	 * @return
	 */
	 @Override
	 public void remove(Long id) {
	 	removeById(id);
	 }
	
	 /**
	 * 删除(多个条目)
	 * @param ids
	 * @return
	 */
	 @Override
	 public void removes(List<Long> ids) {
	
	 	removeByIds(ids);
	 }
	 }
