package com.wanji.indicators.sink;

import com.alibaba.fastjson.JSONObject;
import com.wanji.indicators.model.BaseEventResultModel;
import com.wanji.indicators.model.event.accident.AccidentShowModel;
import com.wanji.indicators.util.FileUtil;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.time.DateFormatUtils;
import org.apache.flink.streaming.api.functions.sink.SinkFunction;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class AccidentEventFileSink implements SinkFunction<AccidentShowModel> {
    private static final Logger log = LoggerFactory.getLogger(AccidentEventFileSink.class);

    private String path;

    public AccidentEventFileSink(String path) {
        this.path = path;
    }

    @Override
    public void invoke(AccidentShowModel accidentShowModel, Context context) {

        if(StringUtils.isNotBlank(path)) {
            String eventType = accidentShowModel.getEventType();
            String plateNumber = accidentShowModel.getPlateNumber();
            Integer trackId = accidentShowModel.getTrackId();
            String timeStr = DateFormatUtils.format(accidentShowModel.getStartTime(),"yyyyMMdd_HHmmss");
            String timeStrs = DateFormatUtils.format(accidentShowModel.getStartTime(),"yyyy-MM-dd HH:mm:ss");
            FileUtil.writeApend(path + "event_" + eventType + "_" + plateNumber +"_"+ trackId + "_" + timeStr + ".json", JSONObject.toJSONString(accidentShowModel));
            log.info("\n{********** The result has been written to the file ********** ==> " + path +
                    "event_" + eventType + "_" + plateNumber + "_" + timeStrs + ".json}\n");
        }

    }

}
