package com.wanji.indicators.sink;

import com.wanji.indicators.task.export.KafkaRecordModel;
import com.wanji.indicators.util.FileUtil;
import org.apache.commons.lang3.StringUtils;
import org.apache.flink.streaming.api.functions.sink.SinkFunction;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.Map;
import java.util.Set;

public class PartitionFileSink implements SinkFunction<Map<Integer,String>> {
    private static final Logger log = LoggerFactory.getLogger(PartitionFileSink.class);

    private Map<Integer,String> partitionPath;
    public PartitionFileSink(Map<Integer,String> partitionPath) {
        this.partitionPath = partitionPath;
    }

    @Override
    public void invoke(Map<Integer,String> dataMap, Context context) {
        Set<Integer> keys = dataMap.keySet();
        for (Integer key : keys) {
            String path = partitionPath.get(key);
            if (StringUtils.isNotBlank(path)) {
                FileUtil.writeApend(path, dataMap.get(key));
            }
        }

    }

}
