package com.wanji.indicators.source;

import com.wanji.indicators.constant.Constant;
import com.wanji.indicators.model.event.RidDirDo;
import com.wanji.indicators.util.PtInPolyUtil;
import org.apache.flink.streaming.api.functions.source.RichParallelSourceFunction;

import java.util.HashMap;
import java.util.List;
import java.util.concurrent.TimeUnit;

/**
 * @Author ke.han
 * @Date 2020/4/16 19:03
 **/
public class RidDirSource extends RichParallelSourceFunction<
        HashMap<String, String>> {

    private volatile boolean running = true;

    @Override
    public void run(SourceContext<HashMap<String, String>> out) throws Exception {
        HashMap<String, String> outMap = new HashMap<>();
        while (running) {
            String sql = "SELECT rid,dir_4_no AS dir,angle FROM rid";
            List<RidDirDo> ridLaneNumDos = null;//new JdbcUtil().excuteQueryToList(RidDirDo.class, sql);
            if (ridLaneNumDos != null && !ridLaneNumDos.isEmpty()) {
                outMap.clear();
                for (RidDirDo data : ridLaneNumDos) {
                    String rid = data.getRid();
                    String dir = data.getDir();
                    outMap.put(rid, dir);
                    if(data.getAngle() != null) {
                        outMap.put(rid + Constant.MARK, PtInPolyUtil.getDir(data.getAngle()));
                    }
                }
            }
            if (outMap.size() > 0) {
                out.collect(outMap);
            }
            TimeUnit.MINUTES.sleep(1);
//            Thread.sleep(1000*60);
        }
    }

    @Override
    public void cancel() {
        running = false;
    }
}
