package com.wanji.indicators.source;

import org.apache.flink.streaming.api.functions.source.RichParallelSourceFunction;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.HashMap;
import java.util.concurrent.TimeUnit;

/**
 * 待转区数据源
 */
public class WaitingAreaSource extends RichParallelSourceFunction<
        HashMap<String, Integer>> {
    private static final Logger log = LoggerFactory.getLogger(WaitingAreaSource.class);
    private volatile boolean running = true;

    @Override
    public void run(SourceContext<HashMap<String, Integer>> out) throws Exception {
        HashMap<String, Integer> outMap = new HashMap<>();
        while (running) {
            String sql = "SELECT * FROM cross_flink_settings WHERE waiting_area <> 0";
            try {

                if (outMap.size() > 0) {
                    out.collect(outMap);
                }
                TimeUnit.MINUTES.sleep(1);
            } catch (Exception e) {
                log.error("路口待转配置查询异常:" + e.getMessage());
                out.collect(outMap);
            }
//            Thread.sleep(1000L*30L);
        }
    }

    @Override
    public void cancel() {
        running = false;
    }

}
