package com.wanji.indicators.task.area.service.model;

import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.ToString;

import java.io.Serializable;

@Data
@EqualsAndHashCode(callSuper = false)
@ToString
public class AreaIndexAnalysis implements Serializable {

    /**
     * 忽略父类的String类型id
     */
    public String id = "AREA_INDEX_10M";

    /**
     * 交通指数
     */
    private Double trafficIndex = 1D;

    /**
     * 交通状态 1：畅通（指数<1.5）2：缓行（指数[1.5,2)）3:拥堵([2,4)) 4:严重拥堵（>4）
     */
    private String trafficState = "1";

    /**
     * 行驶速度，单位km/h
     */
    private Double speed = 0D;

    /**
     * 拥堵距离，单位米
     */
    private Double congestLength = 0D;

    /**
     * 在途车辆数
     */
    private Integer inWayVehicleNum = 1;

    /**
     * 本埠车辆数
     */
    private Integer localVehicleNum = 0;

    /**
     * 抓拍到本地有车牌的车辆数
     */
    private Integer localHavePlateNum = 0;

    /**
     * 外埠车辆数
     */
    private Integer outVehicleNum = 0;


    /**
     * 时间分析粒度,【10m：10分钟，30m：30分钟】
     */
    private String granularity = "10m";


    /**
     * 行程时间
     */
    private Double travelTime = 0D;

    private String startTime;

    private String endTime;

    int pedestrianNum = 0;

    int nonMotorNum = 0;

    private Long timeStamp;
}
