package com.wanji.indicators.task.area.service.sink;

import com.alibaba.fastjson.JSON;
import com.wanji.indicators.task.area.service.model.AreaIndexAnalysis;
import org.apache.flink.streaming.connectors.redis.common.mapper.RedisCommand;
import org.apache.flink.streaming.connectors.redis.common.mapper.RedisCommandDescription;
import org.apache.flink.streaming.connectors.redis.common.mapper.RedisMapper;

/**
 * @author fengyi
 * @date 2023/4/7
 * @description
 */
public   class TravelRedisMapper implements RedisMapper<AreaIndexAnalysis> {
    private String redisKey ;
    public TravelRedisMapper(String redisKey){
        this.redisKey = redisKey;
    }
    // 定义保存数据到redis的命令，存成Hash表，hset sensor_temp id temperature
    @Override
    public RedisCommandDescription getCommandDescription() {
        return new RedisCommandDescription(RedisCommand.HSET, this.redisKey);
    }

    @Override
    public String getKeyFromData(AreaIndexAnalysis data) {
        return data.getId();
    }

    @Override
    public String getValueFromData(AreaIndexAnalysis data) {
        return JSON.toJSONString(data);
    }
}
