package com.wanji.indicators.task.beihang;

import com.wanji.indicators.model.CrossFrameModel;
import com.wanji.indicators.task.laneIndicators.CrossLaneIndicatorMainNew;
import com.wanji.indicators.util.DateUtil;
import org.apache.flink.api.java.utils.ParameterTool;
import org.apache.flink.streaming.api.datastream.DataStreamSource;
import org.apache.flink.streaming.api.environment.StreamExecutionEnvironment;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 离线计算入口
 */
public class OfflineBeiHangFlowTaskMain {

    private static final Logger log = LoggerFactory.getLogger(OfflineBeiHangFlowTaskMain.class);

    public static void main(String[] args) {
        //初始化环境
        StreamExecutionEnvironment env = StreamExecutionEnvironment.getExecutionEnvironment();

        //加载配置项 并获取工作路径
        String inPath = "d:/flink/workspace";
        String outPath = "d:/flink/out/";

        ParameterTool parameter = ParameterTool.fromArgs(args);
        inPath = parameter.get("inPath", "D:\\WanJi-Work\\07 项目\\02 济南\\数据");
        outPath = parameter.get("outPath", "d:/flink/out/");
        String st = parameter.get("startTime");
        String et = parameter.get("endTime");
        // --inPath D:\上地西路数据\后厂村+九街20240412\20240412
        // inPath = "D:\\上地西路数据\\七街20240412\\20240412";
//        inPath = "D:\\上地西路数据\\qj202405";
//        st = "20240513";
//        et = "20240518";
        long startTime = DateUtil.StringToMillis(st, "yyyyMMdd");
        long endTime = DateUtil.StringToMillis(et, "yyyyMMdd");
        int parallelism = parameter.getInt("parallelism", 1);
        env.setParallelism(parallelism);
        //读取离线数据
        DataStreamSource<CrossFrameModel> streamSource = env.addSource(new BeiHangTrackFrameDateFile(inPath, startTime, endTime));
        try {
            CrossLaneIndicatorMainNew.init(env, outPath, false).run(streamSource);
            //CrossTurnIndicatorMainNew.init(env,outPath,true).run(streamSource);
            env.execute("转向流量-车道流量-周期计算");
        } catch (Exception e) {
            e.printStackTrace();
            log.error("事件测试 - 计算任务异常 : " + e);
        }
    }
}
