package com.wanji.indicators.task.citybrain.lanestatistics;

import com.wanji.indicators.task.citybrain.vo.LaneSnapShotOverFlowAreaCarNumsDTO;
import org.apache.flink.api.common.functions.AggregateFunction;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author duanruiming
 * @date 2024/04/01 16:55
 */
public class OverflowCarNumsAggregateFunction implements AggregateFunction<LaneSnapShotOverFlowAreaCarNumsDTO, LaneSnapShotOverFlowAreaCarNumsDTO, LaneSnapShotOverFlowAreaCarNumsDTO> {

    private static final Logger log = LoggerFactory.getLogger(OverflowCarNumsAggregateFunction.class);

    @Override
    public LaneSnapShotOverFlowAreaCarNumsDTO createAccumulator() {
        LaneSnapShotOverFlowAreaCarNumsDTO dto = new LaneSnapShotOverFlowAreaCarNumsDTO();
        dto.setOverflowNums(0);
        return dto;
    }

    @Override
    public LaneSnapShotOverFlowAreaCarNumsDTO add(LaneSnapShotOverFlowAreaCarNumsDTO in, LaneSnapShotOverFlowAreaCarNumsDTO acc) {
        try {
            int overflowNums = in.getOverflowNums() + 1;
            int currentOverflowNums = acc.getOverflowNums();
            //if (currentOverflowNums <= overflowNums) {
            //    acc.setOverflowNums(currentOverflowNums);
            //}
            acc.setOverflowNums(currentOverflowNums + overflowNums);
            acc.setTimeStampLong(in.getTimeStampLong());
            acc.setLaneId(in.getLaneId());
        } catch (Exception e) {
            log.error("OverflowCarNumsAggregateFunction add():", e);
            throw new RuntimeException(e);
        }
        return acc;
    }

    @Override
    public LaneSnapShotOverFlowAreaCarNumsDTO getResult(LaneSnapShotOverFlowAreaCarNumsDTO acc) {
        log.error("OverflowCarNumsAggregateFunction getResult():", acc);
        return acc;
    }

    @Override
    public LaneSnapShotOverFlowAreaCarNumsDTO merge(LaneSnapShotOverFlowAreaCarNumsDTO laneSnapShotOverFlowAreaCarNumsDTO, LaneSnapShotOverFlowAreaCarNumsDTO acc1) {
        return null;
    }
}
