package com.wanji.indicators.task.citybrain.vo;

import lombok.Data;

/**
 * @author duanruiming
 * @date 2024/03/25 17:12
 * @description 数据大脑停车事件实体
 */
@Data
public class LaneParkEventVO {
    // 数据时间,毫秒级时间戳
    private String data_time;
    // parking：停车事件，jam：拥堵事件，accident事故事件
    private String eventType;
    // 设备编号
    private String deviceNo;
    // 断面编号，南向北 1，东向西 2，北向南 3，西向东 4
    private String sectionNo;
    // 事件唯一编号
    private String euuid;
    // 目标id
    private String id;
    // 当前所处桩号 桩号不需要，告诉才有
    private String station;
    // 0：上行，1：下行  从北到南为下行，从南到北为上行，从东往西为下行，从西往东为上行
    private String flow;
    // 车道编号
    private String laneId;
    // 目标位置,相对于雷达[x,y,z]
    private String position;
    // 目标停车地理位置[经度,纬度,海拔]（84坐标系）
    private String geography;
    // 停车类型 illegal-违法停车, abnormal-异常停车, emergency-应急车道停车
    private String type;
    // 停车状态类型 0 停车消散, 1 停车触发, 2 停车持续
    private String state;
    // 车辆类型
    private String vehicleType;
    // 车辆颜色
    private String vehicleColor;
    // 车牌类型
    private String plateType;
    // 车牌号码
    private String plateNumber;
}
