package com.wanji.indicators.task.citybrain.vo;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

import java.util.List;

/**
 * @author duanruiming
 * @date 2024/03/25 15:37
 * @description  数据大脑统计数据实体
 */
@Data
public class LaneStatisticsDataVO {

    // 数据时间,毫秒级时间戳
    private String data_time;
    // 车道总数
    private int laneNum;
    // 设备编号
    private String deviceNo;
    // 统计周期（s）
    private int cycle;
    // 线圈数量
    private int coilNum;
    // 断面编号，南向北 1，东向西 2，北向南 3，西向东 4
    private String sectionNo;
    // 数据数组，包含下面各线圈的数据
    @JsonProperty("data_list")
    private List<LaneStatisticsDetail> data_list;

}
