package com.wanji.indicators.task.citybrain.vo;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

/**
 * @author duanruiming
 * @date 2024/03/25 15:43
 */
@Data
public class LaneStatisticsDetail {
    // 车道编号，（1，2，3，4....） 与车辆正常行驶方向的垂直方向从左向右依次编号，最左侧靠近道路中间线的为1车道
    @JsonProperty("laneNo")
    private String laneNo;
    // 线圈编号
    @JsonProperty("coilNo")
    private String coilNo;
    // 不区分车型机动车总流量
    @JsonProperty("volumeSum")
    private int volumeSum;
    // 行人流量
    @JsonProperty("volumePerson")
    private int volumePerson;
    // 非机动车流量
    @JsonProperty("volumeCarNon")
    private int volumeCarNon;
    // 小车流量
    @JsonProperty("volumeCarSmall")
    private int volumeCarSmall;
    // 中车流量

    @JsonProperty("volumeCarMiddle")
    private int volumeCarMiddle;
    // 大车流量
    @JsonProperty("volumeCarBig")
    private int volumeCarBig;
    // 平均速度（km/h）
    @JsonProperty("speedAvg")
    private String speedAvg;
    // 时间占有率（%）
    @JsonProperty("occupancy")
    private String occupancy;
    // 平均车头时距（s）
    @JsonProperty("headway")
    private String headway;
    // 平均车身间距（s）
    @JsonProperty("gap")
    private String gap;
    // 85位速度（km/h）
    @JsonProperty("speed85")
    private String speed85;
    // 车流量总和
    @JsonProperty("wArrivalFlow")
    private String wArrivalFlow;
    // 平均空间占有率
    @JsonProperty("fSpaceOccupyRation")
    private String fSpaceOccupyRation;
    // 堵塞状态下最大排队长度
    @JsonProperty("byQueueLen")
    private String byQueueLen;
    // 平均延误
    @JsonProperty("wDelay")
    private String wDelay;
    // 平均停车次数
    @JsonProperty("byStoppingTimes")
    private String byStoppingTimes;
    // 左转总流量
    @JsonProperty("dwLeftVehNum")
    private int dwLeftVehNum;
    // 右转总流量
    @JsonProperty("dwRightVehNum")
    private int dwRightVehNum;
    // 直行总流量
    @JsonProperty("dwStraightVehNum")
    private int dwStraightVehNum;

}
