package com.wanji.indicators.task.citybrainreceive.event.park;

import com.wanji.indicators.entity.EventInfo;
import com.wanji.indicators.mapper.EventInfoMapper;
import org.apache.flink.configuration.Configuration;
import org.apache.flink.streaming.api.functions.sink.RichSinkFunction;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.List;

/**
 * @author duanruiming
 * @date 2024/04/16 16:15
 */
@Service
public class LaneParkEventSaveFunction extends RichSinkFunction<List<EventInfo>> {

    EventInfoMapper eventInfoMapper;

    @Override
    public void open(Configuration parameters) throws Exception {
        super.open(parameters);
        ApplicationContext beanConf = new ClassPathXmlApplicationContext("spring-container.xml");
        eventInfoMapper = beanConf.getBean(EventInfoMapper.class);
    }

    @Override
    public void invoke(List<EventInfo> value, Context context) throws Exception {
        if (!CollectionUtils.isEmpty(value)) {
            for (EventInfo eventInfo : value) {
                eventInfoMapper.insert(eventInfo);
            }
        }
    }
}