package com.wanji.indicators.task.citybrainreceive.passcarinfo;

import lombok.Data;

import java.util.List;

@Data
public class PasscarInfoReceiveModel {
    private Header headers;
    private List<Body> body;

    // Header内部类
    @Data
    public static class Header {
        private String name;
        private String from;
        private String taskId;
    }

    // Body内部类
    @Data
    public static class Body {
        // 数据时间, 毫秒级时间戳
        private Long data_time;

        // 设备编号
        private String deviceNo;

        // 断面编号，南向北 1，东向西 2，北向南 3，西向东 4
        private Integer sectionNo;

        // 车道编号，与车辆正常行驶方向的垂直方向从左向右依次编号，最左侧靠近道路中间线的为1车道
        private Integer laneNo;

        // 线圈编号
        private String coilNo;

        // 线圈状态，第几位表示几号线圈状态，状态1-到达，0-离开
        private String wLoopState;

        // 线圈状态掩码，掩码位为1对应wLoopState状态位有效，为0表示无效
        private String wStateMask;

        // 目标ID
        private Integer targetId;

        // 车长(m)
        private Double targetLen;

        // 目标类型，1行人，2非机动车，3小型车，4中型车，5大型车
        private Integer targetType;

        // 目标驶入线圈时的速度(km/h)
        private Double speedIn;

        // 目标驶离线圈时的速度(km/h)
        private Double speedOut;

        // 压占时间/存在时间（ms）
        private Long presenceTime;

        // 目标进入线圈的时间，毫秒级时间戳
        private Long driveInTime;

        // 驶离时间, 毫秒级时间戳
        private Long driveOutTime;

        // 车辆类型（字典见附录）
        private String vehicleType;

        // 车身颜色（字典见附录）
        private String vehicleColor;

        // 车牌类型（字典见附录）
        private String plateType;

        // 车牌号，如“苏A xxxx”
        private String plateNumber;
    }
}
