package com.wanji.indicators.task.citybrainreceive.snapshot;

import lombok.Data;

import java.util.List;

@Data
public class AreaDataReceiveModel {
    private Header headers;
    private List<Body> body;

    // Header内部类
    @Data
    public static class Header {
        private String name;
        private String from;
        private String taskId;
    }

    // Body内部类
    @Data
    public static class Body {
        private Long data_time; // 数据时间,毫秒级时间戳
        private String deviceNo; // 设备编号
        private Integer laneNum; // 车道总数
        private Integer sectionNo; // 断面编号，南向北 1，东向西 2，北向南 3，西向东 4
        private List<LaneInfo> data_list; // 数据数组，包含各车道的数据

        @Data
        public static class LaneInfo {
            private String laneNo; // 车道编号，与车辆正常行驶方向的垂直方向从左向右依次编号，最左侧靠近道路中间线的为1车道
            private Integer targetCount; // 车道内车辆数
            private Double occupancy; // 车道内空间占有率（%）
            private Double speedAvg; // 平均速度（km/h）
            private Double pareto; // 车道内车辆分布情况（车间距方差m）
            private Double speedHead; // 头车速度（km/h）
            private Double speedTail; // 末车速度（km/h）
            private Double posHead; // 车道内第一辆车位置（m）
            private Double posTail; // 车道内最后一辆车位置（m）
        }
    }
}
