package com.wanji.indicators.task.citybrainreceive.snapshot;

import lombok.Data;

import java.util.List;

@Data
public class QueueReceiveModel {
    private Header headers;
    private List<Body> body;

    // Header内部类
    @Data
    public static class Header {
        private String name;
        private String from;
        private String taskId;
    }

    // Body内部类
    @Data
    public static class Body {
        private Long data_time; // 数据时间,毫秒级时间戳
        private String deviceNo; // 设备编号
        private Integer laneNum; // 车道总数
        private Integer sectionNo; // 断面编号，南向北 1，东向西 2，北向南 3，西向东 4
        private Integer queuetype = 0; // 未知，兼容 yigou 公司数据
        private List<LaneInfo> data_list; // 数据数组，包含各车道的数据

        @Data
        public static class LaneInfo {
            private String laneNo; // 车道编号，（1，2，3，4....）与车辆正常行驶方向的垂直方向从左向右依次编号，最左侧靠近道路中间线的为1车道
            private Double queueLen; // 排队长度（m）
            private Double queueHead; // 排队第一辆车距离停止线距离（m）
            private Double queueTail; // 排队最后一辆车距离停止线距离（m）
            private Integer queueCount; // 排队车辆数（辆）
        }
    }
}
