package com.wanji.indicators.task.citybrainreceive.targetinfo;

import com.wanji.indicators.util.CityBrainReceiveUtil;
import com.wanji.indicators.util.DateUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.flink.api.common.functions.FlatMapFunction;
import org.apache.flink.shaded.jackson2.com.fasterxml.jackson.databind.ObjectMapper;
import org.apache.flink.util.Collector;

import java.util.Comparator;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.concurrent.ConcurrentHashMap;
import java.util.stream.Collectors;

@Slf4j
public class TargetInfoConvertFlatMap implements FlatMapFunction<String, TargetInfoReceiveModel> {
    private static final ObjectMapper objectMapper = new ObjectMapper();
    static Long timeTemp;

    @Override
    public void flatMap(String value, Collector<TargetInfoReceiveModel> out) {

        TargetInfoReceiveModel targetInfoReceiveModel = null;
        try {
            String processedValue = CityBrainReceiveUtil.processJson(value);
            targetInfoReceiveModel = objectMapper.readValue(processedValue, TargetInfoReceiveModel.class);
        } catch (Exception e) {
            log.error("", e);
        }
        if (targetInfoReceiveModel != null && !targetInfoReceiveModel.getBody().isEmpty()) {
            long dataTime = targetInfoReceiveModel.getBody().get(0).getData_time();
            if (dataTime > System.currentTimeMillis()) {
                dataTime = System.currentTimeMillis();
            }
            List<TargetInfoReceiveModel.Body> bodyList = targetInfoReceiveModel.getBody();
            //排除异常数据
            bodyList = bodyList.stream().filter(o ->Objects.nonNull(o.getLongitude()) &&
                                                    Objects.nonNull(o.getLatitude()) &&
                                                    o.getLongitude() > 1 &&
                                                    o.getLatitude() > 1
                                                ).collect(Collectors.toList());

            for (TargetInfoReceiveModel.Body body : bodyList) {
                body.setData_time(dataTime);
            }
            if (!bodyList.isEmpty()) {
                targetInfoReceiveModel.setBody(bodyList);
                targetInfoReceiveModel.setDataTime(dataTime);
                out.collect(targetInfoReceiveModel);
            }
        }
    }
}
