package com.wanji.indicators.task.crossstate.service.func;

import com.alibaba.fastjson.JSONArray;
import com.wanji.indicators.entity.CrossStateData;
import org.apache.flink.api.common.functions.FlatMapFunction;
import org.apache.flink.util.Collector;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;

/**
 * 帧数据转换
 */
public class CrossStateFromJsonFlatMap implements FlatMapFunction<String, List<CrossStateData>> {

    private static final Logger log = LoggerFactory.getLogger(CrossStateFromJsonFlatMap.class);

    @Override
    public void flatMap(String trackJson, Collector<List<CrossStateData>> collector) throws Exception {
        List<CrossStateData> list = JSONArray.parseArray(trackJson, CrossStateData.class);
        collector.collect(list);
    }

}
