package com.wanji.indicators.task.crossstate.service.sink;

import com.wanji.indicators.entity.CrossStateData;
import com.wanji.indicators.service.CrossStateDataService;
import com.wanji.indicators.service.impl.CrossStateDataServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.apache.flink.configuration.Configuration;
import org.apache.flink.streaming.api.functions.sink.RichSinkFunction;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import java.util.List;

/**
 * @author fengyi
 * @date 2024/1/23
 * @description
 */
@Slf4j
public class CrossStateSinkFunction extends RichSinkFunction<List<CrossStateData>> {

    CrossStateDataService crossStateDataService;

    @Override
    public void open(Configuration parameters) throws Exception {
        super.open(parameters);
        ApplicationContext beanConf = new ClassPathXmlApplicationContext("spring-container.xml");
        crossStateDataService = beanConf.getBean(CrossStateDataServiceImpl.class);
    }

    @Override
    public void invoke(List<CrossStateData> values, Context context) throws Exception {
        try {
            crossStateDataService.save(values);
        } catch (Exception e) {
            log.error(this.getClass().getName() + ".invoke()执行失败", e);
        }
    }
}
