package com.wanji.indicators.task.export;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.google.gson.JsonObject;
import com.wanji.indicators.model.TopicLastTimeModel;
import com.wanji.indicators.task.track.service.func.SplitRoutePathFunction;
import org.apache.flink.api.common.serialization.DeserializationSchema;
import org.apache.flink.api.common.typeinfo.TypeInformation;
import org.apache.flink.streaming.connectors.kafka.KafkaDeserializationSchema;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


public class ReadKafkaDeserialization implements KafkaDeserializationSchema<KafkaRecordModel> {
    private static final Logger log = LoggerFactory.getLogger(SplitRoutePathFunction.class);

    private final String encoding = "UTF8";
    public ReadKafkaDeserialization( ) {
    }

    @Override
    public TypeInformation<KafkaRecordModel> getProducedType() {
        return TypeInformation.of(KafkaRecordModel.class);
    }

    @Override
    public void open(DeserializationSchema.InitializationContext context) throws Exception {

    }

    @Override
    public boolean isEndOfStream(KafkaRecordModel nextElement) {
        return false;
    }

    @Override
    public KafkaRecordModel deserialize(ConsumerRecord<byte[], byte[]> consumerRecord) throws Exception {
        if (consumerRecord != null) {
            try {
                String json = new String(consumerRecord.value(),"UTF-8");
                JSONObject jsonObject = JSONObject.parseObject(json);

                KafkaRecordModel model = new KafkaRecordModel();
                model.setTimestamp(consumerRecord.timestamp());
                model.setTimestampType(consumerRecord.timestampType());
                model.setValues(jsonObject);
                model.setTopic(consumerRecord.topic());

                return model;
            } catch (Exception e) {
                log.error("deserialize failed : " + e.getMessage());
            }
        }
        return null;
    }

}