package com.wanji.indicators.task.maincontrol.entity;

import cn.net.wanji.v2xprotocol.annotation.ParseList;
import cn.net.wanji.v2xprotocol.annotation.ProtocolField;
import cn.net.wanji.v2xprotocol.annotation.ProtocolType;
import cn.net.wanji.v2xprotocol.annotation.ReservedSpace;
import cn.net.wanji.v2xprotocol.entity.E1FrameParticipant;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * @ClassName E1Frame
 * @Description
 * @Date 2021/3/8 9:42
 * @Version 1.0
 */
@ProtocolType(isNeedTransfer=false,isVerifyFrameCheck = false,childCmd = 2)
@Data
public class E1Frame extends Org {
    //设备ID  unit16_t 2
    @ProtocolField(length = 2)
    int deviceId;
    //算法耗时 ms
    short algorithmDuration;
    //点云数据帧号
    @ProtocolField(length = 4)
    long frameNo;
    @ProtocolField(dateType = 0)
    Date timeStamp;
    //    //时间戳秒	uint32_t	4	1900起，在最终计算时间上添加8h后为标准北京时间
//    @ProtocolField(length = 4)
//    long unixTimeSec;
//    //时间戳微秒	uint32_t	4	时间戳小数部分，单位为电脑晶振时钟周期（➗4.295后即为小数点后有效值）
//    @ProtocolField(length = 4)
//    long unixTimeDecimal;
    //激光器原点经度	nint32_t	4	分辨率1e-7°，东经为正，西经为负
    @ProtocolField(length = 4,multiple = 0.0000001)
    double longitude;
    //激光器原点纬度	nint32_t	4   分辨率1e-7°，北纬为正，南纬为负
    @ProtocolField(length = 4,multiple = 0.0000001)
    double latitude;
    //激光器角度	uint16_t	2	y轴与正北方的夹角(0-360°正北为0)
    short angle;
    //交通参与者数量	nint8_t	1
    short participantNum;
    //交通参与者集合
    @ParseList(elementClass = E1FrameParticipant.class , field4Size = "participantNum")
    @ReservedSpace(frontReservedSpacelength = 4,behindReservedSpacelength = 4)
    List<E1FrameParticipant> e1FrameParticipant;
}
