package com.wanji.indicators.task.monitor.service.func;

import com.wanji.indicators.model.TopicLastTimeModel;
import com.wanji.indicators.task.track.service.func.SplitRoutePathFunction;
import org.apache.flink.api.common.serialization.DeserializationSchema;
import org.apache.flink.api.common.typeinfo.TypeInformation;
import org.apache.flink.streaming.connectors.kafka.KafkaDeserializationSchema;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


public class CustomKafkaDeserialization implements KafkaDeserializationSchema<TopicLastTimeModel> {
    private static final Logger log = LoggerFactory.getLogger(SplitRoutePathFunction.class);

    private final String encoding = "UTF8";
    public CustomKafkaDeserialization( ) {
    }

    @Override
    public TypeInformation<TopicLastTimeModel> getProducedType() {
        return TypeInformation.of(TopicLastTimeModel.class);
    }

    @Override
    public void open(DeserializationSchema.InitializationContext context) throws Exception {

    }

    @Override
    public boolean isEndOfStream(TopicLastTimeModel nextElement) {
        return false;
    }

    @Override
    public TopicLastTimeModel deserialize(ConsumerRecord<byte[], byte[]> consumerRecord) throws Exception {
        if (consumerRecord != null) {
            try {
                String topic  = consumerRecord.topic();
                long ts = consumerRecord.timestamp();
                long offset = consumerRecord.offset();

                TopicLastTimeModel model = new TopicLastTimeModel();

                model.setTimestamp(ts);
                model.setTopic(topic);
                model.setOffset(offset);
                model.setCreateTime(System.currentTimeMillis());

                return model;
            } catch (Exception e) {
                log.error("deserialize failed : " + e.getMessage());
            }
        }
        return null;
    }

}