package com.wanji.indicators.task.queuelength.service.func;

import com.wanji.indicators.model.SnapshotInfo;
import com.wanji.indicators.model.SnapshotIndicatorModel;
import com.wanji.indicators.util.DateUtil;
import org.apache.flink.api.common.functions.FlatMapFunction;
import org.apache.flink.util.Collector;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;

/**
 * 帧数据转换
 */
public class ParseSnapshotInfoFlatMap implements FlatMapFunction<SnapshotIndicatorModel, SnapshotInfo> {

    private static final Logger log = LoggerFactory.getLogger(ParseSnapshotInfoFlatMap.class);


    @Override
    public void flatMap(SnapshotIndicatorModel snapshotIndicatorModel, Collector<SnapshotInfo> collector) throws Exception {

        String timeStamp = snapshotIndicatorModel.getTimeStamp();
        long ts = DateUtil.StringToMillis(timeStamp, "yyyy-MM-dd HH:mm:ss:SSS");
        String globalId = snapshotIndicatorModel.getOrgCode();

        List<SnapshotInfo> list = snapshotIndicatorModel.getEventList();

        list.forEach(o -> {
            o.setTimestamp(ts);
            o.setGlobalId(globalId);
            collector.collect(o);
        });
    }

    /**
     * 获取随机数
     *
     * @param min
     * @param max
     * @return
     */
    public static int getRandom(int min, int max) {
        int floor = (int) Math.floor(Math.random() * (max - min + 1) + min);
        return floor;
    }

}
