package com.wanji.indicators.task.queuelength.service.func;

import com.wanji.indicators.task.queuelength.service.model.MaxQueueResultModel;
import com.wanji.indicators.util.DateUtil;
import org.apache.flink.streaming.api.functions.windowing.ProcessWindowFunction;
import org.apache.flink.streaming.api.windowing.windows.TimeWindow;
import org.apache.flink.util.Collector;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.StreamSupport;

/**
 * @author fengyi
 * @date 2023/4/6
 * @description
 */
public class QueueProcessWindow extends ProcessWindowFunction<
        MaxQueueResultModel,
        MaxQueueResultModel,
        String,
        TimeWindow> {
    private static final Logger log = LoggerFactory.getLogger(QueueProcessWindow.class);
    @Override
    public void process(String s, Context context, Iterable<MaxQueueResultModel> elements, Collector<MaxQueueResultModel> out) throws Exception {
        long windowStartTs = context.window().getStart();
        long windowEndTs = context.window().getEnd();

        List<MaxQueueResultModel> list = StreamSupport.stream(elements.spliterator(), false).collect(Collectors.toList());

        if (elements.iterator().hasNext()) {

            MaxQueueResultModel result = elements.iterator().next();
            result.setStartTime(DateUtil.toDateTime(windowStartTs,"yyyy-MM-dd HH:mm:ss.SSS"));
            result.setEndTime(DateUtil.toDateTime(windowEndTs,"yyyy-MM-dd HH:mm:ss.SSS"));

            log.info("MaxQueueLength Result:" + result.toString());

            out.collect(result);
        }
    }
}
