package com.wanji.indicators.task.queuelength.service.func;

import com.alibaba.fastjson.JSONObject;
import com.wanji.indicators.model.SnapshotIndicatorModel;
import org.apache.flink.api.common.functions.FlatMapFunction;
import org.apache.flink.util.Collector;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 帧数据转换
 */
public class SnapshotFlatMap implements FlatMapFunction<String, SnapshotIndicatorModel> {

    private static final Logger log = LoggerFactory.getLogger(SnapshotFlatMap.class);

    @Override
    public void flatMap(String trackJson, Collector<SnapshotIndicatorModel> collector) throws Exception {

        SnapshotIndicatorModel frameModel = JSONObject.parseObject(trackJson, SnapshotIndicatorModel.class);

        collector.collect(frameModel);

    }

}
