package com.wanji.indicators.task.queuelength.service.sink;

import com.alibaba.fastjson.JSON;
import com.wanji.indicators.task.freeflow.service.model.MaxSpeedResultModel;
import com.wanji.indicators.task.queuelength.service.model.MaxQueueResultModel;
import org.apache.flink.streaming.connectors.redis.common.mapper.RedisCommand;
import org.apache.flink.streaming.connectors.redis.common.mapper.RedisCommandDescription;
import org.apache.flink.streaming.connectors.redis.common.mapper.RedisMapper;

/**
 * @author fengyi
 * @date 2023/4/7
 * @description
 */
public   class QueueRedisMapper implements RedisMapper<MaxQueueResultModel> {
    private String redisKey ;
    public QueueRedisMapper(String redisKey){
        this.redisKey = redisKey;
    }
    // 定义保存数据到redis的命令，存成Hash表，hset sensor_temp id temperature
    @Override
    public RedisCommandDescription getCommandDescription() {
        return new RedisCommandDescription(RedisCommand.HSET, this.redisKey);
    }

    @Override
    public String getKeyFromData(MaxQueueResultModel data) {
        return data.getId();
    }

    @Override
    public String getValueFromData(MaxQueueResultModel data) {
        return JSON.toJSONString(data);
    }
}
