package com.wanji.indicators.task.track.service.func;

import com.alibaba.fastjson.JSONObject;
import com.wanji.indicators.model.FrameModel;
import org.apache.flink.api.common.functions.FlatMapFunction;
import org.apache.flink.util.Collector;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 帧数据转换
 */
public class FrameFlatMap implements FlatMapFunction<String, FrameModel> {

    private static final Logger log = LoggerFactory.getLogger(FrameFlatMap.class);

    @Override
    public void flatMap(String trackJson, Collector<FrameModel> collector) throws Exception {

        FrameModel frameModel = JSONObject.parseObject(trackJson, FrameModel.class);

        collector.collect(frameModel);

    }

}
