package com.wanji.indicators.task.track.service.func;

import com.wanji.indicators.model.CarTrackModel;
import org.apache.flink.streaming.api.functions.AssignerWithPeriodicWatermarks;
import org.apache.flink.streaming.api.watermark.Watermark;

/**
 * @author fengyi
 * @date 2023/3/3
 * @description
 */
public class MyWaterMark implements AssignerWithPeriodicWatermarks<CarTrackModel> {

    private final long maxTimeLag = 3000; // 3 seconds

    @Override
    public long extractTimestamp(CarTrackModel element, long previousElementTimestamp) {
        return element.getGlobalTimeStamp();
    }

    @Override
    public Watermark getCurrentWatermark() {
        // return the watermark as current time minus the maximum time lag
        return new Watermark(System.currentTimeMillis() - maxTimeLag);
    }
}
