package com.wanji.indicators.task.trafficstate.func;

/**
 * @author fengyi
 * @ 2023/10/30
 * @dedatescription
 */

import com.wanji.indicators.cache.BaseLaneCache;
import com.wanji.indicators.entity.BaseCrossTurnInfo;
import com.wanji.indicators.entity.BaseLaneInfo;
import com.wanji.indicators.model.CarTrackModel;
import com.wanji.indicators.model.CrossFrameModel;
import com.wanji.indicators.util.CommonUtil;
import com.wanji.indicators.util.PtInPolyUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.flink.api.common.functions.FlatMapFunction;
import org.apache.flink.util.Collector;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * 行人轨迹基础
 */
@Slf4j
public class BoundCarRoadNetInfoCoFlatMap implements FlatMapFunction<CarTrackModel, CarTrackModel> {

    //private Map<String, BaseLaneInfo> map = new HashMap();

    @Override
    public void flatMap(CarTrackModel carTrack, Collector<CarTrackModel> collector) throws Exception {

        Map<String, BaseLaneInfo> map = BaseLaneCache.getInstance().getBaseLaneInfoMap();

        Map<String, List<BaseCrossTurnInfo>> turnRelationMap = BaseLaneCache.getInstance().getCrossTurnInfoMap();

        String entryLane = carTrack.getRoadnet().getLaneId();
        BaseLaneInfo baseLaneInfo = map.get(entryLane);
        //扩展属性绑定
        CommonUtil.boundLaneExtProperty(carTrack, baseLaneInfo, turnRelationMap);

        collector.collect(carTrack);
    }

}