package com.wanji.indicators.task.trafficstate.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

/**
 * @author fengyi
 * @date 2023/10/16
 * @description
 */
@Data
public class LanePeriodData {

        /**
         * 数据生成时间: yyyy-MM-dd HH:mm:ss:SSS
         */
        private String dateTime;
        private long timestamp;

        private String rid;
        /**
         * 车道号(路网数据)
         */
        private String laneId;
        /**
         * 车道长度
         */
        private double laneLength;
        /**
         * 路段长度
         */
        private double ridLength;

        /**
         * 绿灯结束排队长度
         */
        private double lightGreenFinishQueueLength;
        /**
         * 绿灯起亮排队长度
         */
        private double lightGreenStartQueueLength;
        /**
         * 平均停车次数
         */
        private int meanStopsNumber;
        /**
         * 平均点速度
         */
        private double meanV;
        /**
         * 平均车长(米)
         */
        private double meanLen;
        /**
         * 最大静态排队长度
         */
        private double staticQueueLengthMax;
        /**
         * 最小静态排队长度
         */
        private double staticQueueLengthMin;

}
