package com.wanji.indicators.task.trafficstate.sink;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.wanji.indicators.task.area.service.model.AreaIndexAnalysis;
import com.wanji.indicators.task.trafficstate.model.LaneTrafficStateResult;
import org.apache.flink.streaming.connectors.redis.common.mapper.RedisCommand;
import org.apache.flink.streaming.connectors.redis.common.mapper.RedisCommandDescription;
import org.apache.flink.streaming.connectors.redis.common.mapper.RedisMapper;

import java.util.List;

/**
 * @author fengyi
 * @date 2023/4/7
 * @description
 */
public   class TrafficStateRedisMapper implements RedisMapper<JSONObject> {
    private String redisKey ;
    public TrafficStateRedisMapper(String redisKey){
        this.redisKey = redisKey;
    }
    // 定义保存数据到redis的命令，存成Hash表，hset sensor_temp id temperature
    @Override
    public RedisCommandDescription getCommandDescription() {
        return new RedisCommandDescription(RedisCommand.HSET, this.redisKey);
    }

    @Override
    public String getKeyFromData(JSONObject data) {
        return data.getString("id");
    }

    @Override
    public String getValueFromData(JSONObject data) {
        return JSON.toJSONString(data);
    }
}
