package com.wanji.indicators.trigger;

import org.apache.flink.api.common.eventtime.WatermarkGenerator;
import org.apache.flink.api.common.eventtime.WatermarkOutput;
import org.apache.flink.streaming.api.functions.AssignerWithPeriodicWatermarks;
import org.apache.flink.streaming.api.watermark.Watermark;
import org.apache.flink.util.Preconditions;

public   class MyAssignerWithPeriodicWatermarksAdapter<T> implements WatermarkGenerator<T> {
    private final AssignerWithPeriodicWatermarks<T> wms;
    private final Long autoWatermarkInterval;

    public MyAssignerWithPeriodicWatermarksAdapter(AssignerWithPeriodicWatermarks<T> wms, Long autoWatermarkInterval) {
        this.wms = (AssignerWithPeriodicWatermarks) Preconditions.checkNotNull(wms);
        this.autoWatermarkInterval = autoWatermarkInterval;
    }

    @Override
    public void onEvent(T event, long eventTimestamp, WatermarkOutput output) {
    }

    @Override
    public void onPeriodicEmit(WatermarkOutput output) {
        Watermark next = this.wms.getCurrentWatermark();
        if (next != null) {
            Long emitWatermarkTimestamp = (autoWatermarkInterval != null && autoWatermarkInterval.longValue() != 0L && (System.currentTimeMillis() - next.getTimestamp() < autoWatermarkInterval)) ? next.getTimestamp() : System.currentTimeMillis();
            output.emitWatermark(new org.apache.flink.api.common.eventtime.Watermark(emitWatermarkTimestamp));
        }
    }
}

