package com.wanji.indicators.trigger;

import org.apache.flink.api.common.eventtime.TimestampAssigner;
import org.apache.flink.api.common.eventtime.TimestampAssignerSupplier;
import org.apache.flink.api.common.eventtime.WatermarkGenerator;
import org.apache.flink.api.common.eventtime.WatermarkStrategy;
import org.apache.flink.streaming.api.functions.AssignerWithPeriodicWatermarks;
import org.apache.flink.util.Preconditions;

public class MyWatermarkStrategy<T> implements WatermarkStrategy<T> {
    private static final long serialVersionUID = 1L;
    private final AssignerWithPeriodicWatermarks<T> wms;
    private final Long autoWatermarkInterval;

    public MyWatermarkStrategy(AssignerWithPeriodicWatermarks<T> wms, Long autoWatermarkInterval) {
        this.wms = (AssignerWithPeriodicWatermarks) Preconditions.checkNotNull(wms);
        this.autoWatermarkInterval = autoWatermarkInterval;
    }

    @Override
    public TimestampAssigner<T> createTimestampAssigner(TimestampAssignerSupplier.Context context) {
        return this.wms;
    }

    @Override
    public WatermarkGenerator<T> createWatermarkGenerator(org.apache.flink.api.common.eventtime.WatermarkGeneratorSupplier.Context context) {
        return new MyAssignerWithPeriodicWatermarksAdapter(this.wms, this.autoWatermarkInterval);
    }
}

