package com.wanji.indicators.udf;

/**
 * 计算线段长度
 * @author fengyi
 * @date 2023/7/25
 * @description
 */
import com.vividsolutions.jts.geom.LineString;
import com.wanji.indicators.util.ArithOfBigDecmial;
import com.wanji.indicators.util.GeomsConvertUtil;
import org.apache.commons.lang3.StringUtils;
import org.apache.flink.table.functions.FunctionContext;
import org.apache.flink.table.functions.ScalarFunction;

public class LineLengthUdf extends ScalarFunction {
    // 可选，open方法可以不写。
    // 如果编写open方法需要声明'import org.apache.flink.table.functions.FunctionContext;'。
    @Override
    public void open(FunctionContext context) {
    }
    public double eval(String points) {
        if (StringUtils.isEmpty(points))
            return 0;
        LineString lineString = GeomsConvertUtil.getLineString(points);
        //度单位转换为米单位
        double length = ArithOfBigDecmial.mul(lineString.getLength(), 6371000 * Math.PI / 180);
        length = ArithOfBigDecmial.round(length, 2);
        return length;
    }

    //可选，close方法可以不写。
    @Override
    public void close() {
    }
}
