package com.wanji.indicators.util;

import java.util.HashMap;
import java.util.Map;

/**
 * 4方向转换
 */
public class BaseLocationConverter {
    private static final Map<Integer, String> wanjiToBrain = new HashMap<>();
    private static final Map<String, Integer> brainToWanji = new HashMap<>();

    static {
        wanjiToBrain.put(0, null);
        wanjiToBrain.put(1, "3");
        wanjiToBrain.put(2, "2");
        wanjiToBrain.put(3, "1");
        wanjiToBrain.put(4, "4");
        wanjiToBrain.put(5, "3");
        wanjiToBrain.put(6, "2");
        wanjiToBrain.put(7, "1");
        wanjiToBrain.put(8, "4");

        brainToWanji.put("1", 3);
        brainToWanji.put("2", 2);
        brainToWanji.put("3", 1);
        brainToWanji.put("4", 4);
    }

    public static String convertWanjiToBrain(int wanjiCode) {
        return wanjiToBrain.getOrDefault(wanjiCode, null); // 没有找到映射返回 null
    }

    public static int convertBrainToWanji(String brainCode) {
        return brainToWanji.getOrDefault(brainCode, -1); // 没有找到映射返回 -1
    }

}
