package com.wanji.indicators.util;

import java.util.HashMap;
import java.util.Map;

/**
 * 车身颜色转换
 */
public class BodyColorConverter {
    private static final Map<Integer, String> wanjiToBrain = new HashMap<>();
    private static final Map<String, Integer> brainToWanji = new HashMap<>();

    static {
        wanjiToBrain.put(0, null);
        wanjiToBrain.put(1, "A");
        wanjiToBrain.put(2, "J");
        wanjiToBrain.put(3, "E");
        wanjiToBrain.put(4, null);
        wanjiToBrain.put(5, "C");
        wanjiToBrain.put(6, "H");
        wanjiToBrain.put(7, null);
        wanjiToBrain.put(8, "I");
        wanjiToBrain.put(9, "B");

        brainToWanji.put("A", 1);
        brainToWanji.put("B", 9);
        brainToWanji.put("C", 5);
        brainToWanji.put("D", 0);
        brainToWanji.put("E", 3);
        brainToWanji.put("F", 0);
        brainToWanji.put("G", 0);
        brainToWanji.put("H", 6);
        brainToWanji.put("I", 8);
        brainToWanji.put("J", 2);
    }

    public static String convertWanjiToBrain(int wanjiCode) {
        return wanjiToBrain.getOrDefault(wanjiCode, null); // 没有找到映射返回 null
    }

    public static int convertBrainToWanji(String brainCode) {
        return brainToWanji.getOrDefault(brainCode, -1); // 没有找到映射返回-1
    }

}
