package com.wanji.indicators.util;

import org.joda.time.DateTime;

/**
 * @author fengyi
 * @date 2023/1/12
 * @description
 */
public class CarNumGenerator {

    public static void main(String[] args) {

        System.out.println(DateUtil.StringToMillis("2023-12-24 00:00:00"));
        DateTime currentDateTime = new DateTime();

        DateTime dateTime = currentDateTime.withMillisOfDay(0).minusHours(-4);
        dateTime = currentDateTime.withTimeAtStartOfDay();
        System.out.println(DateUtil.toDateTime(dateTime.getMillis(),DateUtil.YYYY_MM_DD_HH_MM_SS));
    }

    /**
     * 中国各个地区的数组
     */
    private static final String[] CAR_AREA_ARRAY = {"云"};

    /**
     * 城市代码，不能有字母 I 和 O
     */
    private static final String[] CAR_LETTER_ARRAY = {"A"/*,"K","L","B","M","C","N","P","D","Q","E","R","F","S","H","U","V"*/};

    /**
     * 车牌号，不能有字母 I 和 O
     */
    private static final String[] CAR_CHAR_ARRAY = {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", "E", "F", "G", "H", "J", "K",
            "L", "M", "N", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"};

    /**
     * 车牌编号长度
     */
    private static final int CAR_NUM_LENGTH = 5;

    public static String getCarNum() {
        // 随机获取地区
        String area =  CAR_AREA_ARRAY[(int)(Math.random() * CAR_AREA_ARRAY.length)];

        // 随机生成城市编号
        String cityCode = CAR_LETTER_ARRAY[(int)(Math.random() * CAR_LETTER_ARRAY.length)];

        // 循环5次，生成车牌号
        StringBuilder sb = new StringBuilder();
        for(int i=0; i<CAR_NUM_LENGTH; i++) {
            sb.append(CAR_CHAR_ARRAY[(int)(Math.random()*CAR_CHAR_ARRAY.length)]);
        }

        // 拼接
        return area + cityCode + sb;
    }

}
