package com.wanji.indicators.util;

import java.util.HashMap;
import java.util.Map;

/**
 * 车辆类型转换
 */
public class CarTypeConverter {
    private static final Map<Integer, String> wanjiToBrain = new HashMap<>();
    private static final Map<String, Integer> brainToWanji = new HashMap<>();

    static {
        wanjiToBrain.put(0, "0");
        wanjiToBrain.put(1, "1");
        wanjiToBrain.put(2, "14");
        wanjiToBrain.put(3, "7");
        wanjiToBrain.put(4, null);
        wanjiToBrain.put(5, null);
        wanjiToBrain.put(6, null);
        wanjiToBrain.put(7, "6");
        wanjiToBrain.put(8, null);
        wanjiToBrain.put(9, null);
        wanjiToBrain.put(10, "13");
        wanjiToBrain.put(11, "11");
        wanjiToBrain.put(12, null);
        wanjiToBrain.put(13, null);
        wanjiToBrain.put(14, null);
        wanjiToBrain.put(15, "17");
        wanjiToBrain.put(150, null);
        wanjiToBrain.put(151, null);
        wanjiToBrain.put(152, null);
        wanjiToBrain.put(153, null);
        wanjiToBrain.put(154, null);
        wanjiToBrain.put(160, "17");
        wanjiToBrain.put(161, "17");
        wanjiToBrain.put(162, "17");
        wanjiToBrain.put(163, "17");
        wanjiToBrain.put(164, "17");
        wanjiToBrain.put(165, "17");
        wanjiToBrain.put(166, "17");
        wanjiToBrain.put(170, null);
        wanjiToBrain.put(171, null);
        wanjiToBrain.put(172, null);
        wanjiToBrain.put(173, null);
        wanjiToBrain.put(174, null);
        wanjiToBrain.put(175, null);
        wanjiToBrain.put(176, null);
        wanjiToBrain.put(177, null);
        wanjiToBrain.put(178, null);
        wanjiToBrain.put(179, null);
        wanjiToBrain.put(180, null);
        wanjiToBrain.put(181, null);
        wanjiToBrain.put(182, null);
        wanjiToBrain.put(183, null);

        brainToWanji.put("0", 0);
        brainToWanji.put("1", 1);
        brainToWanji.put("2", 1);
        brainToWanji.put("3", 1);
        brainToWanji.put("4", 1);
        brainToWanji.put("5", 1);
        brainToWanji.put("6", 7);
        brainToWanji.put("7", 3);
        brainToWanji.put("8", 3);
        brainToWanji.put("9", 10);
        brainToWanji.put("10", 10);
        brainToWanji.put("11", 11);
        brainToWanji.put("13", 10);
        brainToWanji.put("14", 2);
        brainToWanji.put("15", 2);
        brainToWanji.put("16", 2);
        brainToWanji.put("17", 15);
        brainToWanji.put("18", 0);
        brainToWanji.put("19", 0);
    }

    public static String convertWanjiToBrain(Integer wanjiCode) {
        return wanjiToBrain.getOrDefault(wanjiCode, null); // 没有找到映射返回 null
    }

    public static Integer convertBrainToWanji(String brainCode) {
        return brainToWanji.getOrDefault(brainCode, -1); // 没有找到映射返回-1
    }

}
