package com.wanji.indicators.util;

import java.util.HashMap;
import java.util.Map;

/**
 * 车牌颜色转换
 */
public class PlateColorConverter {
    private static final Map<Integer, String> wanjiToBrain = new HashMap<>();
    private static final Map<String, Integer> brainToWanji = new HashMap<>();

    static {
        wanjiToBrain.put(0, "02");
        wanjiToBrain.put(1, "01");
        wanjiToBrain.put(2, "03");
        wanjiToBrain.put(3, "23");
        wanjiToBrain.put(4, "52");
        wanjiToBrain.put(5, "51");
        wanjiToBrain.put(6, null);
        wanjiToBrain.put(7, "22");
        wanjiToBrain.put(8, null);
        wanjiToBrain.put(9, null);
        wanjiToBrain.put(10, null);
        wanjiToBrain.put(11, "52");
        wanjiToBrain.put(12, null);

        brainToWanji.put("01", 1);
        brainToWanji.put("02", 0);
        brainToWanji.put("03", 2);
        brainToWanji.put("04", 2);
        brainToWanji.put("05", 2);
        brainToWanji.put("06", 2);
        brainToWanji.put("07", -1);
        brainToWanji.put("08", -1);
        brainToWanji.put("09", -1);
        brainToWanji.put("10", -1);
        brainToWanji.put("11", -1);
        brainToWanji.put("12", -1);
        brainToWanji.put("13", 1);
        brainToWanji.put("14", 1);
        brainToWanji.put("15", 1);
        brainToWanji.put("16", 1);
        brainToWanji.put("17", -1);
        brainToWanji.put("18", -1);
        brainToWanji.put("19", -1);
        brainToWanji.put("20", 3);
        brainToWanji.put("21", -1);
        brainToWanji.put("22",7);
        brainToWanji.put("23", -1);
        brainToWanji.put("24", -1);
        brainToWanji.put("25", -1);
        brainToWanji.put("26", -1);
        brainToWanji.put("27", -1);
        brainToWanji.put("31", -1);
        brainToWanji.put("32", -1);
        brainToWanji.put("33", -1);
        brainToWanji.put("41", -1);
        brainToWanji.put("42", -1);
        brainToWanji.put("43", -1);
        brainToWanji.put("51", 5);
        brainToWanji.put("52", 4);
        brainToWanji.put("99", -1);
    }

    public static String convertWanjiToBrain(int wanjiCode) {
        return wanjiToBrain.getOrDefault(wanjiCode, null); // 没有找到映射返回 null
    }

    public static int convertBrainToWanji(String brainCode) {
        return brainToWanji.getOrDefault(brainCode, -1); // 没有找到映射返回-1
    }

}
